// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.

package JRunMC.ui;

import JRunMC.util.*;

// Imports
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;

class PanelJets  
                extends JDialog { 


  public static final long serialVersionUID = 111;

  // Variables declaration - do not modify
  private javax.swing.JButton jButton1;
  public JComboBox FSjtype;
  public JComboBox FSJangle;
  public JComboBox FSJrecom;
  public JComboBox FSJNfixed;
  public JTextField ycut;
  public JTextField sETAmin;
  public JTextField sETAmax;
  public JTextField sETmin;
  public JTextField sETmax;
  private JPanel SETTINGjets;
  private JPanel SETTINGkinem;
  private JPanel contentPane;
   
 
  //  jet pannel    
   public PanelJets()  {

   super( Global.mainFrame );
   setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);

 
   contentPane = (JPanel)getContentPane();
   setTitle( "Jet Settings");
   setSize(new Dimension(250, 250));
   contentPane.setPreferredSize(new Dimension(230, 345));
   
    SETTINGjets = new JPanel();
    SETTINGjets.setPreferredSize(new java.awt.Dimension(230, 340));
    SETTINGjets.setMinimumSize(new java.awt.Dimension(100, 100));
    contentPane.add(SETTINGjets);

        
      // jet type
      FSjtype = new JComboBox(SetIni.Jtype);
      FSjtype.setSelectedIndex(0);
      FSjtype.setFont(SetEnv.FontBold);
      FSjtype.setSelectedIndex(0);
      FSjtype.setPreferredSize(new java.awt.Dimension(200, 25));
      SETTINGjets.add(FSjtype);    
    FSjtype.addItemListener(new java.awt.event.ItemListener() {
    public void itemStateChanged(java.awt.event.ItemEvent evt) {
       if (FSjtype.getSelectedIndex() == 0) SetIni.JetType=2;
       if (FSjtype.getSelectedIndex() == 1) SetIni.JetType=3;
       if (FSjtype.getSelectedIndex() == 2) SetIni.JetType=4;
       // remove y-cut window
       ycut.setVisible(true);
       if (SetIni.JetType != 2) ycut.setVisible(false);
      //  T7.showSummaryOut2();
        setMessageFS(); 
    } });
 
 
      // jets
      FSJangle = new JComboBox(SetIni.Jangle);
      FSJangle.setSelectedIndex(0);
      FSJangle.setFont(SetEnv.FontBold);
      FSJangle.setSelectedIndex(0);
      FSJangle.setPreferredSize(new java.awt.Dimension(200, 25));
      SETTINGjets.add(FSJangle);    
    FSJangle.addItemListener(new java.awt.event.ItemListener() {
    public void itemStateChanged(java.awt.event.ItemEvent evt) {
      SetIni.JetAngle= FSJangle.getSelectedIndex()+1;
    } });
     

 
      FSJrecom = new JComboBox(SetIni.Jrecom);
      FSJrecom.setSelectedIndex(0);
      FSJrecom.setFont(SetEnv.FontBold);
      FSJrecom.setSelectedIndex(0);
      FSJrecom.setPreferredSize(new java.awt.Dimension(200, 25));
      SETTINGjets.add(FSJrecom);    
      FSJrecom.addItemListener(new java.awt.event.ItemListener() {
    public void itemStateChanged(java.awt.event.ItemEvent evt) {
      SetIni.JetRecomb= FSJrecom.getSelectedIndex()+1;
    } });
     

 
      FSJNfixed = new JComboBox(SetIni.JNfixed);
      FSJNfixed.setSelectedIndex(0);
      FSJNfixed.setFont(SetEnv.FontBold);
      FSJNfixed.setSelectedIndex(0);
      FSJNfixed.setPreferredSize(new java.awt.Dimension(200, 25));
      SETTINGjets.add(FSJNfixed);    
    // settings for jets
    FSJNfixed.addItemListener(new java.awt.event.ItemListener() {
    public void itemStateChanged(java.awt.event.ItemEvent evt) {
      SetIni.JetNfixed=FSJNfixed.getSelectedIndex()+1;
    } });
 
      
       ycut = new JTextField();
       ycut.setBackground(new java.awt.Color(252, 252, 252));
       ycut.setFont(SetEnv.FontBold);
       ycut.setPreferredSize(new java.awt.Dimension(100, 45));
       ycut.setMinimumSize(new java.awt.Dimension(50, 25));
       ycut.setHorizontalAlignment(JTextField.RIGHT);
       ycut.setText("0.002");
       ycut.setBorder(new TitledBorder(null,
                                   "Y-cut",TitledBorder.DEFAULT_JUSTIFICATION,
                                    TitledBorder.DEFAULT_POSITION, 
                                     new java.awt.Font("Dialog", 0, 12)));
       SETTINGjets.add(ycut);

     ycut.getDocument().addDocumentListener(new DocumentListener() {
     public void changedUpdate(DocumentEvent e) {
     String s1;  s1=ycut.getText();   s1=s1.trim();
     SetIni.JetYcut=Utility.GetDouble(s1);  }
     public void removeUpdate(DocumentEvent e) {
     String s2;  s2=ycut.getText(); s2=s2.trim();
     SetIni.JetYcut=Utility.GetDouble(s2);    }
     public void insertUpdate(DocumentEvent e) {
     // text was inserted
      String s3; s3=ycut.getText(); s3=s3.trim();
      SetIni.JetYcut=Utility.GetDoubleError(s3);
     }  });
     
        
        
    SETTINGkinem = new JPanel();
    SETTINGkinem.setPreferredSize(new java.awt.Dimension(230, 110));
    SETTINGkinem.setMinimumSize(new java.awt.Dimension(100, 100));
    SETTINGkinem.setBackground(new java.awt.Color(204, 204, 255));
    SETTINGjets.add(SETTINGkinem);
  
    sETmin = new JTextField();
    sETmin.setBackground(new java.awt.Color(252, 252, 252));
       sETmin.setFont(SetEnv.FontBold);
       sETmin.setPreferredSize(new java.awt.Dimension(100, 45));
       sETmin.setMinimumSize(new java.awt.Dimension(50, 25));
       sETmin.setHorizontalAlignment(JTextField.RIGHT);
       sETmin.setText("0.0");
       sETmin.setBorder(new TitledBorder(null,
                                   "ET(min)",TitledBorder.DEFAULT_JUSTIFICATION,
                                    TitledBorder.DEFAULT_POSITION, 
                                     new java.awt.Font("Dialog", 0, 12)));

     sETmin.getDocument().addDocumentListener(new DocumentListener() {
     public void changedUpdate(DocumentEvent e) {
     String s1;  s1=sETmin.getText();   s1=s1.trim();
     SetIni.ETmin=Utility.GetDouble(s1);  }
     public void removeUpdate(DocumentEvent e) {
     String s2;  s2=sETmin.getText(); s2=s2.trim();
     SetIni.ETmin=Utility.GetDouble(s2);    }
     public void insertUpdate(DocumentEvent e) {
     String s3; s3=sETmin.getText(); s3=s3.trim();
     SetIni.ETmin=Utility.GetDoubleError(s3);
     }  });



      sETmax = new JTextField();
      sETmax.setBackground(new java.awt.Color(252, 252, 252));
       sETmax.setFont(SetEnv.FontBold);
       sETmax.setPreferredSize(new java.awt.Dimension(100, 45));
       sETmax.setMinimumSize(new java.awt.Dimension(50, 25));
       sETmax.setHorizontalAlignment(JTextField.RIGHT);
       sETmax.setText("1000000.0");
       sETmax.setBorder(new TitledBorder(null,
                                   "ET(max)",TitledBorder.DEFAULT_JUSTIFICATION,
                                    TitledBorder.DEFAULT_POSITION, 
                                     new java.awt.Font("Dialog", 0, 12)));


// ETmax for jets ----------------------------------------------
     sETmax.getDocument().addDocumentListener(new DocumentListener() {
     public void changedUpdate(DocumentEvent e) {
     String s1;  s1=sETmax.getText();   s1=s1.trim();
     SetIni.ETmax=Utility.GetDouble(s1);  }
     public void removeUpdate(DocumentEvent e) {
     String s2;  s2=sETmax.getText(); s2=s2.trim();
     SetIni.ETmax=Utility.GetDouble(s2);    }
     public void insertUpdate(DocumentEvent e) {
     String s3; s3=sETmax.getText(); s3=s3.trim();
     SetIni.ETmax=Utility.GetDoubleError(s3);
     }  });

  
      sETAmin = new JTextField();
      sETAmin.setBackground(new java.awt.Color(252, 252, 252));
       sETAmin.setFont(SetEnv.FontBold);
       sETAmin.setPreferredSize(new java.awt.Dimension(100, 45));
       sETAmin.setMinimumSize(new java.awt.Dimension(50, 25));
       sETAmin.setHorizontalAlignment(JTextField.RIGHT);
       sETAmin.setText("-999.0");
       sETAmin.setBorder(new TitledBorder(null,
                                   "ETA(min)",TitledBorder.DEFAULT_JUSTIFICATION,
                                    TitledBorder.DEFAULT_POSITION, 
                                     new java.awt.Font("Dialog", 0, 12)));
     sETAmin.getDocument().addDocumentListener(new DocumentListener() {
     public void changedUpdate(DocumentEvent e) {
     String s1;  s1=sETAmin.getText();   s1=s1.trim();
     SetIni.ETAmin=Utility.GetDouble(s1);  }
     public void removeUpdate(DocumentEvent e) {
     String s2;  s2=sETAmin.getText(); s2=s2.trim();
     SetIni.ETAmin=Utility.GetDouble(s2);    }
     public void insertUpdate(DocumentEvent e) {
     String s3; s3=sETAmin.getText(); s3=s3.trim();
     SetIni.ETAmin=Utility.GetDoubleError(s3);
     }  });



     sETAmax = new JTextField();
      sETAmax.setBackground(new java.awt.Color(252, 252, 252));
       sETAmax.setFont(SetEnv.FontBold);
       sETAmax.setPreferredSize(new java.awt.Dimension(100, 45));
       sETAmax.setMinimumSize(new java.awt.Dimension(50, 25));
       sETAmax.setHorizontalAlignment(JTextField.RIGHT);
       sETAmax.setText("999.0");
       sETAmax.setBorder(new TitledBorder(null,
                                   "ETA(max)",TitledBorder.DEFAULT_JUSTIFICATION,
                                    TitledBorder.DEFAULT_POSITION, 
                                     new java.awt.Font("Dialog", 0, 12)));
        
       
     sETAmax.getDocument().addDocumentListener(new DocumentListener() {
     public void changedUpdate(DocumentEvent e) {
     String s1;  s1=sETAmax.getText();  s1=s1.trim();
     SetIni.ETAmax=Utility.GetDouble(s1);  }
     public void removeUpdate(DocumentEvent e) {
     String s2;  s2=sETAmax.getText(); s2=s2.trim();
     SetIni.ETAmax=Utility.GetDouble(s2);    }
     public void insertUpdate(DocumentEvent e) {
     String s3; s3=sETAmax.getText(); s3=s3.trim();
     SetIni.ETAmax=Utility.GetDoubleError(s3);
     }  });
       
  
        SETTINGkinem.add(sETmin);   
        SETTINGkinem.add(sETmax);   
        SETTINGkinem.add(sETAmin);   
        SETTINGkinem.add(sETAmax);   
        
        
        jButton1 = new javax.swing.JButton();
        jButton1.setText("Exit");
        jButton1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton1.setMaximumSize(new java.awt.Dimension(60, 25));
        jButton1.setPreferredSize(new java.awt.Dimension(70, 25));
        jButton1.setVerticalAlignment(javax.swing.SwingConstants.BOTTOM);
        jButton1.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
         getContentPane().add(jButton1,java.awt.BorderLayout.SOUTH);
          
        
         jButton1.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
          JOptionPane dialog1 = new JOptionPane();
          int ask=dialog1.showConfirmDialog(dialog1, "Exit Jet Settings?",
          "Question", JOptionPane.YES_NO_OPTION,
           JOptionPane.QUESTION_MESSAGE, null );
           if (ask == JOptionPane.YES_OPTION) { setVisible(false); dispose();}
        }  });

        
        
        pack(); 
//        setVisible();    
   
        }   


// update this pannel with new settings
   public void setPan()  {

// remove y-cut window if necessary
      ycut.setVisible(true);
      if (SetIni.JetType != 2) ycut.setVisible(false);

     if (SetIni.JetType == 1) FSjtype.setSelectedIndex(0);
     if (SetIni.JetType == 2) FSjtype.setSelectedIndex(0);
     if (SetIni.JetType == 3) FSjtype.setSelectedIndex(1);
     if (SetIni.JetType == 4) FSjtype.setSelectedIndex(2);
     if (SetIni.JetRecomb>0 && SetIni.JetRecomb<6) {
          FSJrecom.setSelectedIndex(SetIni.JetRecomb-1);
     }
     FSJangle.setSelectedIndex(SetIni.JetAngle-1);

     if (SetIni.JetNfixed>0 && SetIni.JetNfixed<11) {
         FSJNfixed.setSelectedIndex(SetIni.JetNfixed-1);
     }

     ycut.setText(Double.toString(SetIni.JetYcut));

     if (SetIni.JetType > 1) { // jets
     sETmin.setText(Double.toString(SetIni.ETmin));
     sETmax.setText(Double.toString(SetIni.ETmax));
     sETAmin.setText(Double.toString(SetIni.ETAmin));
     sETAmax.setText(Double.toString(SetIni.ETAmax));
     }




    } // end function 



   private void setMessageFS()  {
    String FSouts=SetIni.FS[SetIni.FStype-1];
    String Jetouts="none";
    if (SetIni.JetType == 1) Jetouts="none";
    if (SetIni.JetType == 2) Jetouts="Jade jets";
    if (SetIni.JetType == 3) Jetouts="Durham jets";
    if (SetIni.JetType == 4) Jetouts="Kt jets";
    SetIni.ShowFS=FSouts+";    jets: "+Jetouts;
    }



// create about
   public void setVisible() {

// store mainframe dimensions
    Dimension dim = Global.mainFrame.getSize();
    int w=dim.width;
    int h=dim.height;
 // Get the system resolution
    Dimension res = Toolkit.getDefaultToolkit().getScreenSize();
   // make sure the dialog is not too big
    Dimension size = new Dimension(Math.min( (int)(0.42*w),res.width),
                        Math.min((int)(0.7*h), res.height) );
    this.setSize(size);
    Util.rightWithin ( Global.mainFrame, this );

 //   Util.centreWithin( Global.mainFrame, this );
    this.setVisible(true); 

   }

// create about
   public void setInvisible() {
        setVisible(false);
   }

          
       

} // end class

