// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.

package JRunMC.ui;


// to set all static variables
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.plaf.*;
import java.io.*;
import java.math.*;

   public class  SetIni {
     
     
   public static String  MC[] = {"PYTHIA","HERWIG","ARIADNE",
                                 "LEPTO","AROMA","CASCADE","PHOJET","RAPGAP","ThePEG"}; 
   
   public static String  exeMC[] = {"none","runmc.pythia6","runmc.herwig","runmc.ariadne",
                                 "runmc.lepto","runmc.aroma","runmc.cascade",
                                 "runmc.phojet","runmc.rapgap3","runmc.thepeg"}; 
  
   public static String  exeNTUPLES[] = {"none","runmc.pythia6","runmc.pythia6","runmc.external"};
 
  
   public static String card[] = {"none","pythia6.cards","herwig6.cards","ariadne.cards",
                                  "lepto65.cards","aroma22.cards","cascade.cards",
                                  "phojet.cards","rapgap3.cards","thepeg.cards"};   
  
   
   public static String PIDname[] = {"e-","e+","p","pbar","n","nbar","gamma","mu-","mu+"}; 
   public static int    PIDmap1[] = {-11,11,2212,-2212,2112,-2112,22,13,-13};

    
   
   public static String PDF[]     = {"CTEQ","MRST","GRV"};  
   public static String NTUPLES[] = {"Ntuple RUNMC","Ntuple HEPEVT","External"};
   public static String FS[] =      {"for all stable","for partons", "for all", 
                       "for stable charged", "for stable+all","for user defined"};
   public static String JET[]  = {"separate particles","hadronic jets"};
   
   public static String OPT1[] = {"Show every 2 sec","Show every 5 sec",
                    "Show every 10 sec","Show every 30 sec","Show every 1 min"};
   
   public static String OPT2[] = {"Show all plots ","Show 1 plot",
                    "Show 2 plots","Show 4 plots","No canvas","Create but not show"};
   
   public static String OPT3[] = {"Show statistics","no statistics"};

   public static String OPT4[] = {"Color style (lines)","Plane style (lines)",
                    "Plane style (markers)","Color style (markers)",
                    "Color style (1)", "Color style (2)"};
   public static String OPT4D[] = {"2D Lego color","2D Lego plane",
                     "2D Surface","2D Color surface","2D Color box style",
                     "2D Color box Z","2D Contour style","2D Arrow mode","2D Box style"};

   public static String OPT5X[] = {"X linear scale","X log scale"};
   public static String OPT5Y[] = {"Y linear scale","Y log scale"};

   public static String OPT6[] = {"events No","norm to 1", "X-sections (pb)", "X-sections (nb)"};

   public static String MFrame[] = {"laboratory frame","HCM frame", "Breit frame (ep)"};

   public static String Jangle[] = {"angle (1)","delta R (2)", "angle QCD emission"};

   public static String Jrecom[] = {"recombination(1) E","recombination Pt (2)", 
                      "recombination Pt2 (3)", "recombination Et (4)","recombination Et2 (5)"};
   
   public static String JNfixed[] = {"1 jets","2 jets","3 jets","4 jets",
                       "5 jets","6 jets","7 jets","8 jets","9 jets","10 jets"};
     
   public static String  Jtype[] = {"Jade","Durham","KT"};
                       
   

    public static final int  HisMAX=500;
    public static String ShowInitState=""; // store message with initial state 
    public static String ShowCanvas=""; // store message with canvas state 
    public static String ShowFS=""; // store message with final state  
    public static String ShowFout=""; // store message with output 
    public static String ShowHistoN="";  // store message with No of histograms
    public static String ShowStatus="";  // store message with No of histograms
    public static int  MCtype;     // set MC type
    public static int  Nevents;    // total number of events
    public static int  MCprocess;  // MC process (dummy so far)
    public static String NTname;   // name of ntuple for readings
    public static String NTdir;    // directory for ntuples
    public static int    NTwhat;   // NTwhat=1 - RUNMC ntuple; NTwhat=2 - HEPEVT ntuple;
    public static int    NTread;   // only this file (0), read all (1)
    public static double  NTlumi;  // lumi for this ntuple
    public static String MOutput;   // output file MC (current)
    public static String MOutputOld;   // was red from start-up. Never modified  
    public static String PipeName;  // name of the pipe file
    public static int IDparticle1;  // type of first colliding particle
    public static int IDparticle2;  // type of second colliding particle
    public static double Energy1;    // Energy of first   collnding particle
    public static double Energy2;    // Energy of second  collnding particle
    public static int PDFparticle1; // PDF type of first colliding particle
    public static int PDFparticle2; // PDF type of second colliding particle
    public static int FStype;       // type of final state (hadrons or partons)
    public static int JetType; // Jet kinematics: 1 - particles,2-JADE,3-Durham,4-Ktlong invv
    public static double JetYcut;  // Y cuts
    public static  int   JetAngle;  // angle defition (angle,DeltaR,QCD)
    public static  int   JetRecomb; // recombination scheme : Pt,Pt2,...
    public static  int   JetNfixed; // force jets to this number
    public static  int   Frame;     //  farme (0=lab,1-HCM,2-Breit)
    public static  double Q2min,Q2max; // Q2 cuts
    public static  double Xmin,Xmax;   // X cuts
    public static  double Ymin,Ymax;   // X cuts
    public static  double Wmin,Wmax;   // proton energy
    public static  double ETmin;  // ET (PT) cut
    public static  double ETmax;  // ET max
    public static  double ETAmin; // ETA cuts
    public static  double ETAmax;
    public static  int   Steering;  // infor about steering card to use (CASCADE)
    public static  int Stop;        // variable to define stop signal
    public static  int Renice;      // renice program
   
  // ----------------- Histograms --------------------------------------              
     public static int HistoN;    // number of histograms
     public static int HistoNcurrent;   // total number of histograms
     public static int HistoNcurrent1D;   // number of current histograms (1D only)
     public static int HistoNcurrent2D; // number of current histograms (2D only)
     public static int HistoOptions[];  // options for plotting 
                   // HistoOptions[9]   - (0) no histograms (1) yes histograms
                   // HistoOptions[10]  - (0) no HEPEVT (1) yes HEPEVT output
                   // HistoOptions[11]  - (0) no RunMC (1) yes RunMC  output
                   // HistoOptions[12]  - (1) options for 2D histograms
                   // 13-20 - not used yet
     public static String HistoName[];  // histogram name
     public static String HistoComm[];   // histogram comment
     public static int HistoType[];   // position in GUI
     public static int Histo2D[];     // 2D (=2) or 1D (=1)
     public static double HistoMax[];     // Maximum values for histograms
     public static double HistoMin[];     // Minimum values for histograms
     public static int HistoBins[];    // Number of bins for histograms
     public static double HistoWeight[];  // Weight for this histogram                            
      
            
// initialisation
      public static void init(){                
     
      Nevents=1000;
      MCtype=1;
      MCprocess=0;
      NTwhat=0;
      NTread=0;
      NTname="undefined";
      NTdir="undefined";
      NTlumi=0;
      IDparticle1=11;
      IDparticle2=-11;
      PDFparticle1=1;
      PDFparticle2=1;
      FStype=1;
      Stop=0;    // interap
      Renice=10; // renice
      Energy1=250;
      Energy2=250;
      Q2min=10;
      Q2max=100;
      Xmin=0;
      Xmax=0;
      Ymin=0;
      Ymax=0;
      Wmin=0;
      Wmax=100000;
      JetType=1;
      JetYcut=0.002;
      JetAngle=1;
      JetRecomb=1;
      JetNfixed=2;
      Frame=1;
      ETmin=0.0;
      ETmax=100000.0;
      ETAmax=100.;
      ETAmin=-100.;
      Steering=0;
      MOutput = "default";
      PipeName= "pipe_default";

// ---------------- histograms ----------------------      
      HistoOptions = new int[20]; 
      HistoName = new String[HisMAX];
      HistoComm = new String[HisMAX];
      HistoType= new int[HisMAX];
      Histo2D= new int[HisMAX];
      HistoMax= new double[HisMAX];
      HistoMin= new double[HisMAX];
      HistoBins= new int[HisMAX];
      HistoWeight= new double[HisMAX];
      HistoN=0; HistoNcurrent=0; HistoNcurrent1D=0; HistoNcurrent2D=0;
      HistoOptions[0]=1; HistoOptions[1]=1;
      HistoOptions[2]=1; HistoOptions[3]=600; HistoOptions[4]=400; HistoOptions[5]=1;
      HistoOptions[6]=1; HistoOptions[7]=1;   HistoOptions[8]=1;
      HistoOptions[9]=1; HistoOptions[10]=0;  HistoOptions[11]=0;
      HistoOptions[12]=0; HistoOptions[13]=0; HistoOptions[14]=0;
      HistoOptions[15]=0; HistoOptions[16]=0; HistoOptions[17]=0;
      HistoOptions[18]=0; HistoOptions[19]=0;
      for (int i=0; i<HisMAX; i++) {
      HistoType[i]=0; Histo2D[i]=1; HistoMax[i]=0.; HistoMin[i]=0.; HistoBins[i]=0;
      HistoWeight[i]=1.;  HistoName[i]="undefined";
      }
      
      
      } // end constrctor
      
      


      
// read from MC file
      public static void FileReadMC(String S1) throws Exception { 
      FileReader inF = new FileReader(S1);
      BufferedReader br = new BufferedReader(inF);
      String s;
      int in2=0; double dd1=0.0;
      int k1=0; int k2=0;
      while (( s=br.readLine())!= null) {
        s=s.trim();           // System.out.println(s);
        if (!s.startsWith("#") &&  
            !s.startsWith(" ") &&
            !s.startsWith("*") ) {
        String[] words = s.split (" ");
        String[] sword; sword = new String[100];
      
        // trim, take non empty strings
        int n=0;
        for (int i=0;i<words.length;i++) {
             words[i]=words[i].trim();
             if (words[i].length()>0) {
               sword[n]=words[i];
              // debag:  System.out.print(sword[n]); System.out.print("~");
               n++;  }  };
        
         // debag: System.out.println("");
         if (sword[0].startsWith("S-") && n>1) {
         if(sword[0].equals("S-PROJECT")) MOutput=sword[1];
         SetIni.MOutputOld=MOutput; // copy it to keep track what was set at the start-up;  
         if(sword[0].equals("S-NTNAME"))  NTname=sword[1];
         if(sword[0].equals("S-NTDIR"))   NTdir=sword[1]; 
         if(sword[0].equals("S-PIPE"))    PipeName=sword[1]; 
        }
     
       // integers
       String s0=sword[0]; 
       
        if (s0.startsWith("I-") && n>1) {
         String s1=sword[1];  s1=s1.trim();
         if (s1.length()>0) { 
         in2=Integer.parseInt(s1);
         if(s0.equals("I-EVENTS"))  Nevents=in2;
         if(s0.equals("I-MCTYPE"))  MCtype=in2;
         if(s0.equals("I-PROCESS")) MCprocess=in2;
         if(s0.equals("I-ID1"))     IDparticle1=in2;
         if(s0.equals("I-ID2"))     IDparticle2=in2;
         if(s0.equals("I-PDF1"))    PDFparticle1=in2;
         if(s0.equals("I-PDF2"))    PDFparticle2=in2;
         if(s0.equals("I-NTTYPE"))  NTwhat=in2;
         if(s0.equals("I-NTREAD"))  NTread=in2;
         if(s0.equals("I-FSTYPE"))  FStype=in2;
         if(s0.equals("I-JETTYPE")) JetType=in2;
         if(s0.equals("I-NJETS"))   JetNfixed=in2;
         if(s0.equals("I-ANGLE"))   JetAngle=in2;
         if(s0.equals("I-RECOMB"))  JetRecomb=in2;
         if(s0.equals("I-STOP"))    Stop=in2;
         if(s0.equals("I-RENICE"))  Renice=in2;
         if(s0.equals("I-STEER"))   Steering=in2;
         } };
     
      
 
// double numbers
        if (s0.startsWith("R-") && n>1) {
         String s1=sword[1]; s1=s1.trim();
         if (s1.length()>0) {
         dd1=Utility.GetDouble(s1);
         if(s0.equals("R-ENERGY1"))  Energy1=dd1;
         if(s0.equals("R-ENERGY2"))  Energy2=dd1;
         if(s0.equals("R-Q2MIN"))    Q2min=dd1;
         if(s0.equals("R-Q2MAX"))    Q2max=dd1;
         if(s0.equals("R-XMIN"))     Xmin=dd1;
         if(s0.equals("R-XMAX"))     Xmax=dd1;
         if(s0.equals("R-YMIN"))     Ymin=dd1;
         if(s0.equals("R-YMAX"))     Ymax=dd1;
         if(s0.equals("R-WMIN"))     Wmin=dd1;
         if(s0.equals("R-WMAX"))     Wmax=dd1;
         if(s0.equals("R-ETMIN"))    ETmin=dd1;
         if(s0.equals("R-ETMAX"))    ETmax=dd1;
         if(s0.equals("R-ETAMIN"))   ETAmin=dd1;
         if(s0.equals("R-ETAMAX"))   ETAmax=dd1;
         if(s0.equals("R-YCUT"))     JetYcut=dd1;
         if(s0.equals("R-NTlumi"))   NTlumi=dd1;      
         } };

      
// get options     
       if (s0.startsWith("OPTIONS")) {
             for (int i=1; i<n; i++) {
             //System.out.println(sword[i]);
             int k=i-1;  
             HistoOptions[k]=Utility.GetInt(sword[i]);
             //System.out.println("i="+k+" "+HistoOptions[k]);          
             };  
        };

// get histogram names       
       if (s0.startsWith("H-NAME") && n>1) {
           HistoType[k1]=k1+1; 
           HistoName[k1]=sword[1];
           String scom="";
           for (int i=2; i<n; i++) {
           scom =scom +sword[i];
           scom =scom+" "; };
           HistoComm[k1]=scom;
           k1++;
        }; 
 
       if (s0.startsWith("H-INFO") && n>4) {
           if (sword[1].length()>0) Histo2D[k2]=Utility.GetInt(sword[1]);            
           if (sword[2].length()>0) HistoMin[k2]=Utility.GetDouble(sword[2]);
           if (sword[3].length()>0) HistoMax[k2]=Utility.GetDouble(sword[3]);
           if (sword[4].length()>0) HistoBins[k2]=Utility.GetInt(sword[4]);
           if (sword[5].length()>0) HistoWeight[k2]=Utility.GetDouble(sword[5]); 
           k2++;
        };      
       
     
        } // end of if (starts not with #)  
      } // end of while (file)
      
       
      if ( k1 == k2) {  
        HistoN=k1;
       // System.out.println(HistoN);
       }  else {
       System.out.println("Inconsistent histogram definition "+k1+" "+k2);}        
        
     SetEnv.ReadMCdone=true;          
     inF.close();
      } // end this class
    
     
      
      
      
      // write from MC file ----------------------------------------
   public static void FileWriteMC(String S1) throws Exception {
  
   HistoNcurrent=0;  
   FileOutputStream f1 = new  FileOutputStream (S1);
   PrintStream tx = new PrintStream(f1);
   tx.println("# RunMC v3.3: Feb 2005:  created by JRunMC GUI");
   tx.println("# input file for RunMC. Use # to put your comments in any place");
   tx.println("# I-, R-, S- mean integer, real and string values");
   tx.println("# H- means histogram info, O-mean options");
   tx.println("#");
   tx.println("# Name of the project:");
   tx.println("S-PROJECT "+MOutput);
   tx.println("#");
   tx.println("# Number of Monte Carlo events requested:");
   tx.println("I-EVENTS "+Nevents);
   tx.println("#");
   tx.println("# Select Monte Carlo model:");
   tx.println("I-MCTYPE "+MCtype ); 
   tx.println("# " );
   tx.println("# Select Monte Carlo process:");
   tx.println("I-PROCESS "+MCprocess );
   tx.println("# " );
   tx.println("# Type of first particle (1):");
   tx.println("I-ID1 "+IDparticle1);
   tx.println("# " );
   tx.println("# Type of second  particle (2):");
   tx.println("I-ID2 "+IDparticle2 );
   tx.println("# " );
   tx.println("# Beam energy of first particle (1):");
   tx.println("R-ENERGY1 "+Energy1);
   tx.println("# " );
   tx.println("# Beam energy of second particle (2):");
   tx.println("R-ENERGY2 "+Energy2);
   tx.println("# " );
   tx.println("# PDF of first particle (1):");
   tx.println("I-PDF1 "+PDFparticle1  );
   tx.println("# " );
   tx.println("# PDF of second particle (2):");
   tx.println("I-PDF2 "+PDFparticle2);
   tx.println("# " );
   tx.println("# Which type of ntuple to read?:");
   tx.println("I-NTTYPE "+NTwhat);
   tx.println("# " );
   tx.println("# Read only this file (0) or all files in this directory (1)?:");
   tx.println("I-NTREAD "+NTread);
   tx.println("# " );
   tx.println("# Ntuple name:");
   tx.println("S-NTNAME "+NTname );
   tx.println("# " );
   tx.println("# Ntuple directory:" );
   tx.println("S-NTDIR "+NTdir  );
   tx.println("# " );
   tx.println("# Luminosity for this ntuple(s) in pb-1:" );
   tx.println("R-NTlumi "+NTlumi  );
   tx.println("# " );
   tx.println("# --- Type of final state (partons or stable final state):" );
   tx.println("I-FSTYPE "+FStype   );
   tx.println("# " );
   tx.println("# --- Type of calculations (particles or jets):" );
   tx.println("I-JETTYPE "+JetType   );
   tx.println("# " );
   tx.println("# --- Ycut for jet definitions :" );
   tx.println("R-YCUT "+JetYcut   );
   tx.println("# " );
   tx.println("# --- Number of jets for this jet definition:" );
   tx.println("I-NJETS "+JetNfixed   );
   tx.println("# ");
   tx.println("# --- Angle for the jet definition (only for KT algorithm):" );
   tx.println("I-ANGLE "+JetAngle   );
   tx.println("# " );
   tx.println("# --- Recombination scheme for the jet definition (only for KT algorithm):" );
   tx.println("I-RECOMB "+JetRecomb   );
   tx.println("# " );
   tx.println("# --- Frame type: 1-Lab;   2-HCM;   3-Breit:" );
   tx.println("I-FRAME "+Frame   );
   tx.println("# " );
   tx.println("# --------- Q2_min for DIS:" );
   tx.println("R-Q2MIN "+Q2min   );
   tx.println("# " );
   tx.println("# --------- Q2_max for DIS:" );
   tx.println("R-Q2MAX "+Q2max   );
   tx.println("# " );
   tx.println("# --------- X_min (minimum Bjorken x) for DIS:" );
   tx.println("R-XMIN "+Xmin   );
   tx.println("# " );
   tx.println("# --------- X_max for DIS:" );
   tx.println("R-XMAX "+Xmax   );
   tx.println("# " );
   tx.println("# --------- Y_min:" );
   tx.println("R-YMIN "+Ymin   );
   tx.println("# " );
   tx.println("# --------- Y_max:" );
   tx.println("R-YMAX "+Ymax   );
   tx.println("# " );
   tx.println("# --------- W_min:" );
   tx.println("R-WMIN "+Wmin   );
   tx.println("# " );
   tx.println("# --------- W_max:" );
   tx.println("R-WMAX "+Wmax   );
   tx.println("# " );
   tx.println("# --------- ET_min:" );
   tx.println("R-ETMIN "+ETmin   );
   tx.println("# " );
   tx.println("# --------- ET_max:" );
   tx.println("R-ETMAX "+ETmax   );
   tx.println("# " );
   tx.println("# --------- ETA_min (minimum pseudorapidy) :" );
   tx.println("R-ETAMIN "+ETAmin   );
   tx.println("# " );
   tx.println("# --------- ETA_max:" );
   tx.println("R-ETAMAX "+ETAmax   );
   tx.println("# " );
   tx.println("# RUNMC options:" );
   tx.println("# ---------Stop, (do not modify!):" );
   tx.println("I-STOP "+Stop );
   tx.println("# ---------Renice RUNMC (do not modify!):" );
   tx.println("I-RENICE "+Renice );
   tx.println("# " );
   tx.println("# RUNMC option; use user-defined steering card? (0-no, 1-yes):" );
   tx.println("I-STEER "+Steering );
   tx.println("# " );
   tx.println("# RUNMC option; Name of the pipe file in $RUNMC/pipes directory:" );
   tx.println("# " );
   tx.println("S-PIPE "+PipeName );
   tx.println("# " );
   tx.println("# ----------------Options to display histogrsms-------" );
   tx.print("OPTIONS");
   for (int i=0; i<20; i++) {
     tx.print(" "+HistoOptions[i]); }
   tx.println("\n# ");
   tx.println("# ---------------- Output histograms --------------------");
   tx.println("# No____Type_______Min________Max______NoBins___Weight");
    for (int i=0; i<HistoN; i++ ) {
    //    System.out.println(HistoType[i]+" "+HistoN);
    if (HistoType[i]  > 0 ) {
      HistoNcurrent++;
      tx.println("# new histogram No="+HistoNcurrent);
      tx.print("H-NAME "+HistoName[i]);
     // System.out.println("Put to the file= "+HistoName[HistoNcurrent]);
      tx.println("      "+HistoComm[i]); 
      tx.print("H-INFO "+Histo2D[i]+" "+
               HistoMin[i]+" "+HistoMax[i]+" "+HistoBins[i]+" "+HistoWeight[i]+"\n"); }
    } // end loop over histograms
    

   f1.close();
   }
   
   
   }

                  
                  
 
