#include<iostream>
#include<fstream>
#include<stdlib.h>
#include<math.h>
#include<stdio.h>
#include<string>
#include<unistd.h> // standard unix function for getpid 
#include<sys/types.h>
#include<sys/stat.h>
#include<signal.h>

// for fortran linkage
#include<myroot.h> // for my root files 

// structure for MC common blocks
// #include<heplist.h>
#include<getevkin.h> // put kinematic cuts here  
#include<getseeds.h> // put seeds here 

#include"hepevt_pythia62.h"

#include<hepevt_local.h> // to get local hepevt to write into file
#include<hepevt_runmc.h> // to get RUNMC hepevt to write into file

#include<vector>
#include<time.h>
#include<SetIni.h>    // include class containing initializations for M
#include<SetHisto.h>  // initialization of histograms


/** Need to include these KtJet Headers */
#include "KtJet/KtEvent.h"
#include "KtJet/KtLorentzVector.h"


using namespace std;


extern Int_t charge3( Int_t );


// main program ------------------------------------------------------------ 
int  main(int argc, char **argv) {


// initiation 
   cout << "********** TEST OF CLHEP************************" <<  endl;

   cout << "-->First, testing KTjets                        " <<  endl;


 /** Open input file */
  const char* filename = "inputParticles.dat";
  ifstream infile(filename);
  if (!infile) {
    std::cerr << "Unable to open file!!!!" << filename << std::endl;
    return -1;
  }
  /** Make a std::vector of KtJet::KtLorentzVectors which will be the
      input particles */
  std::vector<KtJet::KtLorentzVector> avec;
  /** read in 4-vectors and fill std::vector */
  double value[4];
   

  while(infile >> value[0]){
    infile >> value[1];
    infile >> value[2];
    infile >> value[3];
    KtJet::KtLorentzVector p(value[0],value[1],value[2],value[3]);
    avec.push_back(p);
  }


 /** set KtEvent flags */
  int type  = 4; // PP
  int angle = 1; //Angular
  int recom = 1; // E
  double rparameter = 1.0;

  /** Construct the KtEvent object */
  KtJet::KtEvent ev(avec,type,angle,recom,rparameter);

  /** Print out the number of final state jets */
  std::cout << "Number of final state jets: " << ev.getNJets() << std::endl;

  /** Retrieve the final state jets from KtEvent sorted by Et*/
  std::vector<KtJet::KtLorentzVector> jets = ev.getJetsEt();

  /** Print out jets 4-momentum and Pt */
  std::vector<KtJet::KtLorentzVector>::const_iterator itr = jets.begin();
  for( ; itr != jets.end() ; ++itr) {
    std::cout << "Jets 4 vector: "
              << (*itr).px() << " "
              << (*itr).py() << " "
              << (*itr).pz() << " "
              << (*itr).e() << std::endl;
    std::cout << "Jets Pt: " << (*itr).perp() << std::endl;
  }




   if (charge3(11) != -3)  cout << "Error in calling charge3" << endl;  
   if (charge3(-11) != 3)  cout << "Error in calling charge3" << endl;

//   cout << " charge " << charge3(12) << endl;
   if (charge3(12) != 0)  cout << "Error in calling charge3" << endl;
//   cout << " charge " << charge3(2212) << endl;
   if (charge3(2212) != 3)  cout << "Error in calling charge3" << endl;

//     cout << " charge " << charge3(-2212) << endl;
   if (charge3(13) != -3)  cout << "Error in calling charge3" << endl;
   if (charge3(-13) != 3)  cout << "Error in calling charge3" << endl;

   
   cout << "\nCLHEPtest is done!" << endl;
 
   return 0;
}
