// root stuff
#include <stdio.h>
#include <stdlib.h>
#include <TROOT.h>
#include "TH1.h"
#include "TF1.h"
#include "TCanvas.h"
#include "TApplication.h"
#include "TFile.h"
#include "TRint.h"
#include "TStyle.h"
#include "TPaveText.h"
#include "TSystem.h"
#include <TTree.h>
#include <TChain.h>

int main() { 
                 // definition of RUNMC HEPEVT 
                 const int hepevt_runmc_max =4000;
                 int NHEP;                     // total number  
                 int IDHEP[hepevt_runmc_max];
                 int ISTCHA[hepevt_runmc_max]; // 100*ISTHEP+10 + charge times 3 
                 int JMOHEP[hepevt_runmc_max];
                 int JDAHEP[hepevt_runmc_max];
                 float PX[hepevt_runmc_max];
                 float PY[hepevt_runmc_max];
                 float PZ[hepevt_runmc_max];
                 float E[hepevt_runmc_max];
  

  TChain *chain = new TChain("trunmc");
  chain->Add("analmc.rtup");    
  chain->SetBranchAddress("NHEP",&NHEP);
  chain->SetBranchAddress("IDHEP",&IDHEP);
  chain->SetBranchAddress("ISTCHA",&ISTCHA);
  chain->SetBranchAddress("JMOHEP",&JMOHEP);
  chain->SetBranchAddress("JDAHEP",&JDAHEP);
  chain->SetBranchAddress("PX",&PX);
  chain->SetBranchAddress("PY",&PY);
  chain->SetBranchAddress("PZ",&PZ);
  chain->SetBranchAddress("E",&E);


  int nentries = (long int)chain->GetEntries();
  printf("Total number of events %d \n", nentries);
  int nbytes = 0;

//----------------------------- Loop over events -----------------------------

  for ( int i=0; i<nentries;i++) {

    if (i%100==0 && i>0 ) {printf("%d events processed\n ",i);}
    nbytes += chain->GetEntry(i);
    
    printf("NHEP = %d (particles in event)\n ",NHEP); 
    
// loop over all particles !
    for (int j=0; j<NHEP;j++) {
    printf("%4d IDHEP=%5d JMOHEP=%5d JDAHEP=%5d \n",
    j,IDHEP[j],JMOHEP[j],JDAHEP[j] );
    printf("     Px=%6.3f  Py=%6.3f  Pz=%6.3f  E=%6.3f  ISTCHA=%2d  \n",
    PX[j], PY[j], PZ[j], E[j], CHA3[j] );

    } // end loop over particles  

    } // end loop over events 

   printf(" ok %d \n",nentries);
 
 return 0;
}
