// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.
package JRunMC.ui;

import JRunMC.util.*;

// Imports
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.util.*;
import java.util.prefs.*;
import java.text.*;
import javax.swing.table.*;

class RMCLoader 
                   extends  JDialog
 {

    public static final long serialVersionUID = 123;

    private JButton jB0;
    private JButton jB1;
    private JButton jB2;
    private JComboBox jGroup;

    public JTextField jTitle;
    public JTextField jShortDescription;
    public JTextField jAuthor;
    public JTextField jContact;
    public JTextField jLastModified;
    private JTextArea jDescription;
    private static final int rows=20; 
    private static final int columns=40;
    private static Preferences prefs;

    // text 
    private static String texjTitle="";
    private static String texjShortDescription="";
    private static String textjAuthor="";
    private static String textjContact="";
    private static String textjLastModified="";
    private static String textjDescription="";

    private JTable   RMClist;
    private MyTableModelInfo  model;
    private static int HoldIndex[]; 


 
        // Instance attributes used in this dialog
   public RMCLoader() {

   super( Global.mainFrame );
   this.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
   setTitle( "RMC project modules");

// this just to hold the index when you do the selection
   HoldIndex = new int[ SetRMC.files.size() ];

  JPanel topPanel = new JPanel();
  JPanel lowerPanel = new JPanel();
  lowerPanel.setPreferredSize(new Dimension(650, 35));


       String[] array = (String[])SetEnv.ListGroup.toArray(new String[SetEnv.ListGroup.size()]);
       jGroup = new JComboBox(array);
       jGroup.setFont(SetEnv.FontBold);
       jGroup.setPreferredSize(new java.awt.Dimension(300, 30));

    // Get number of items
    int inig=-1;
    for (int i=0; i<jGroup.getItemCount(); i++) {
        String item = jGroup.getItemAt(i).toString();
        if (item.equals("All categories") ) inig=i; 
    }
    jGroup.setSelectedIndex(inig);


        jB0 = new JButton();
        jB0.setText("Update");


        jB1 = new JButton();
        jB1.setText("Load");
 
        jB2 = new JButton();
        jB2.setText("Exit");
        jB2.addActionListener(new java.awt.event.ActionListener() {
           public void actionPerformed(java.awt.event.ActionEvent evt) {
           setVisible(false); dispose();} } ); 

       lowerPanel.add(jB0,null);
       lowerPanel.add(jGroup,null);        
       lowerPanel.add(jB1, null);
       lowerPanel.add(jB2, null);
       this.getContentPane().add( topPanel, java.awt.BorderLayout.CENTER );
       this.getContentPane().add( lowerPanel, java.awt.BorderLayout.SOUTH );
 

       topPanel.setLayout(new BoxLayout(topPanel,BoxLayout.Y_AXIS));


 // comments
       JScrollPane jScrollPane1 = new JScrollPane();
       model = new MyTableModelInfo();
       RMClist = new JTable( model )
       {  
          public static final long serialVersionUID = 125;

          public Component prepareRenderer(TableCellRenderer renderer,
                                              int rowIndex, int vColIndex) {


            Component c = super.prepareRenderer(renderer, rowIndex, vColIndex);

            Color colcell = new  Color(240, 255, 255);

            if (rowIndex % 2 == 0 && !isCellSelected(rowIndex, vColIndex)) {
                c.setBackground(colcell);
            } else {
                // If not shaded, match the table's background
                c.setBackground(getBackground());
            }

          // colom
          c.setForeground(Color.black);
          if (isCellSelected(rowIndex, vColIndex))  {c.setBackground(Color.blue);
                                                     c.setForeground(Color.white);}
            return c;
        }
    };


       RMClist.setRowHeight(24);
       RMClist.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    //   RMClist.setShowGrid(false);

       model.addColumn("No");
       model.addColumn("File");
       model.addColumn("Name");
       model.addColumn("Description");
       RMClist.setFont(SetEnv.FontBold);


       RMClist.setShowHorizontalLines( true );
       RMClist.setShowVerticalLines( true );
       RMClist.setRowSelectionAllowed( true );
       RMClist.setColumnSelectionAllowed( false );


       RMClist.addMouseListener(new MouseAdapter()
      {
       public void mouseClicked(MouseEvent e)
        {
        if (e.getClickCount() == 2)
        {
            Point p = e.getPoint();
            int row = RMClist.rowAtPoint(p);
            int column = RMClist.columnAtPoint(p); // This is the view column!

             row=HoldIndex[row]; // recalculate correct raw
            // System.out.println("Debug Raw="+row); 
             new EditorInfoShow( row );
        } } } );  

     //    RMClist.setEditable(false);
         jScrollPane1.getViewport().add( RMClist );
         topPanel.add(jScrollPane1,null);


// channge size
          TableColumn column = null;
          column = RMClist.getColumnModel().getColumn(0);
          column.setPreferredWidth(30);
          column.setMinWidth(20);
          column.setMaxWidth(50);
          column = RMClist.getColumnModel().getColumn(1);
          column.setPreferredWidth(130);
          column.setMinWidth(70);
          column.setMaxWidth(300);
          column = RMClist.getColumnModel().getColumn(2);
          column.setPreferredWidth(200);
          column.setMinWidth(30);
          column.setMaxWidth(500);
          column = RMClist.getColumnModel().getColumn(3);
          column.setPreferredWidth(350);
          column.setMinWidth(100);
          column.setMaxWidth(3000);

          FillTable(0);



        jB0.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {

          JOptionPane dialog1 = new JOptionPane();
          String mess1="<html><b>This will load most recent RMC files from HEPforge. <br>"; 
          mess1=mess1+"All RMC files in the archive/ directory will be overwritten <br>"; 
          mess1=mess1+"Then you have to restart this window.  Do you want to continue? </b></html>"; 

          int ask=dialog1.showConfirmDialog(dialog1, mess1, "Question",  
           JOptionPane.YES_NO_OPTION, 
           JOptionPane.QUESTION_MESSAGE, null );
           if (ask == JOptionPane.YES_OPTION) {
               //   System.out.println("Load "+s1+".rmc");
                   Global.mainFrame.ShowMess("Loading RMC files from the HEPforge"); 
                   RMCwebLoader.init();
               } // end if 
         }  });



        jB1.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {

          int selected= RMClist.getSelectedRow();
          selected=HoldIndex[selected]; // recalculate correct raw  
          String s1=(String)SetRMC.files.elementAt( selected );

          JOptionPane dialog1 = new JOptionPane();
          int ask=dialog1.showConfirmDialog(dialog1, 
          "<html><b>Load \""+s1+".rmc\" file?</html></b>",
          "Question", JOptionPane.YES_NO_OPTION,
           JOptionPane.QUESTION_MESSAGE, null );
           if (ask == JOptionPane.YES_OPTION) {
               //   System.out.println("Load "+s1+".rmc");
                  Global.mainFrame.OpenRMCfile(s1+".rmc");
                 } 
          
         }  });






    jGroup.addActionListener(new ActionListener() { 
        public void actionPerformed(ActionEvent e) {    
            JComboBox combo = (JComboBox)e.getSource();
            int nn  = combo.getSelectedIndex();
             FillTable( nn ); 
       } } ); 



// read preferences and set
        Show();


        }   



// create about
   public void Show() {

// store mainframe dimensions
    Dimension dim = Global.mainFrame.getSize();
    int w=dim.width;
    int h=dim.height;
 // Get the system resolution
    Dimension res = Toolkit.getDefaultToolkit().getScreenSize();
   // make sure the dialog is not too big
    Dimension size = new Dimension(Math.min(600,res.width),
                        Math.min((int)(1.0*h), res.height) );
    this.setSize(size);
    Util.rightWithin ( Global.mainFrame, this );

 //   Util.centreWithin( Global.mainFrame, this );
    this.setVisible(true); 

   }



// create table  
 public void FillTable(int isel ) {

   
// first remove 
    model.setRowCount(0);


    Object newItem = jGroup.getSelectedItem();
    String sgroup=newItem.toString().trim(); 



 int n=0;
 for (int i=0; i<SetRMC.files.size();  i++) {

         String s0=(String)SetRMC.group.elementAt(i);
         String s1=(String)SetRMC.files.elementAt(i);
         String s2=(String)SetRMC.title.elementAt(i);
         String s3=(String)SetRMC.sdescribe.elementAt(i);


         if ( isel == 0 )  { 
            n++;
            HoldIndex[n-1]=i; 
            model.addRow(
            new Object[]{new Integer(n), 
            new String(s1), 
            new String(s2), 
            new String(s3) });
         } 

            if (isel > 0 && sgroup.equals( s0  ) ) { 
            n++;
            HoldIndex[n-1]=i;
            model.addRow(
            new Object[]{new Integer(n),
            new String(s1),
            new String(s2),
            new String(s3) });
            }


    }


 } // FillTable



}
