CDECK  ID>, HWD3MA.
*CMZ :-        -08/04/02  14:48:42  by  Peter Richardson
*-- Author :    Peter Richardson
C-----------------------------------------------------------------------
      SUBROUTINE HWD3MA(ID,ME)
C-----------------------------------------------------------------------
C  Subroutine to calculate the helicity amplitudes for 3rd 3 body RPV
C  diagram f --> fbar fbar f
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      DOUBLE COMPLEX ME(2,2,2,2),S,D,F0(2,2,8),F1(2,2,8),F01(2,2,8,8),
     &     F0M(2,2,8),F2(2,2,8),PRE,ZI,V1(2,2),V2(2,2),F1M(2,2,8),
     &     F3(2,2,8)
      DOUBLE PRECISION A,B,MS,MWD,MA,MB,MA2,MB2,M342,M232,M242,MR,
     &P(5,4),PM(5,4),CFTHRE(NCFMAX,NCFMAX)
      INTEGER P0,P1,P2,P3,ID,O(2),IDP(4+NDIAGR),DRTYPE(NDIAGR),NCTHRE,
     &     DRCF(NDIAGR)
      COMMON/HWHEWS/S(8,8,2),D(8,8)
      COMMON/HWD3BY/F0,F0M,F1M,F1,F2,F3,F01,A(2,NDIAGR),B(2,NDIAGR),
     &     MS(NDIAGR),MWD(NDIAGR),MR(NDIAGR),MA(4),MA2(4),MB(4),MB2(4),
     &     M342,M232,M242,P,PM,CFTHRE,IDP,DRTYPE,NCTHRE,DRCF
      PARAMETER(ZI=(0.0D0,1.0D0))
      DATA O/2,1/
C--decide whether to do the diagram
      IF(MB(4)+MR(ID).LT.MB(1).AND.MR(ID).GT.MB(2)+MB(3)) THEN
        DO 5 P0=1,2
        DO 5 P1=1,2
        DO 5 P2=1,2
        DO 5 P3=1,2
 5      ME(P0,P1,P2,P3) = (0.0D0,0.0D0)
        RETURN
      ENDIF
C--compute the propagator factor
      PRE = 0.25D0/(M232-MS(ID)+ZI*MWD(ID))
C--compute the factors for the two vertices
      DO 10 P1=1,2
      DO 10 P2=1,2
      V1(P1,P2) = PRE*( A(  P1 ,ID)*F3(O(P2),  P1 ,1)*S(1,5,P1)
     &                 +A(O(P1),ID)*F3(O(P2),O(P1),5)*MA(1))
 10   V2(P1,P2) =       B(  P2 ,ID)*F1(  P1 ,  P2 ,3)*S(3,7,P2)
     &                 -B(O(P2),ID)*F1(  P1 ,O(P2),7)*MA(3)
C--now compute the matrix element
      DO 20 P0=1,2
      DO 20 P1=1,2
      DO 20 P2=1,2
      DO 20 P3=1,2
 20   ME(P0,P1,P2,P3) = V1(P0,P3)*V2(P1,P2)
      END
