C
C
      DOUBLE PRECISION FUNCTION GLUSPL(ZMIN)
C*********************************************************************
C
C     calculate quark - antiquark light cone momentum fractions
C     according to Altarelli-Parisi g->q aq splitting function
C     (symmetric z interval assumed)
C
C     input: ZMIN    minimal Z value allowed,
C                    1-ZMIN maximal Z value allowed
C
C********************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE
C
      PARAMETER (ZERO = 0.D0,
     &           ALEXP= 0.3333333333D0,
     &           OHALF= 0.5D0,
     &           DEPS = 1.D-10,
     &           ONE  = 1.D0)
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
C
      IF(ZMIN.GE.OHALF) THEN
        IF(IDEB(69).GT.2) THEN
          WRITE(6,'(1X,A,E12.4)') 'GLUSPL:WARNING:ZMIN>=0.5',ZMIN
        ENDIF
        ZZ=ZERO
        GOTO 1000
      ELSE IF(ZMIN.LE.ZERO) THEN
        IF(IDEB(69).GT.2) THEN
          WRITE(6,'(1X,A,E12.4)') 'GLUSPL:WARNING:ZMIN<=0',ZMIN
        ENDIF
        ZMINL = DEPS
      ELSE
        ZMINL = ZMIN
      ENDIF
C
      ZMAX = ONE-ZMINL
      XI   = RNDM(ZMAX)
      ZZ   = ((ONE-XI)*ZMINL**3+XI*ZMAX**3)**ALEXP
      IF(RNDM(ZZ).LT.OHALF) ZZ = ONE-ZZ
C
 1000 CONTINUE
      IF(IDEB(69).GE.10) THEN
        WRITE(6,'(1X,A,2E12.4)') 'GLUSPL:DEBUG:ZMIN,Z ',ZMIN,ZZ
      ENDIF
      GLUSPL = ZZ
      END
