C
C
      SUBROUTINE MASCOR(IREJ)
C********************************************************************
C
C    check and adjust parton momenta for fragmentation
C
C    input:      COMMON  HEPEVS
C                COMMON  STRING
C                IREJ    -1          initialization
C                        -2          output of statistics
C
C    output:     COMMON  HEPEVS
C                COMMON  STRING
C                IREJ    0  successful
C                        1  failure
C
C    in case of very small chain mass:
C       - direct manipulation of COMMON HEPEVS and HEPEVE
C       - chain will be deleted from COMMON STRING (label -99)
C
C********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER (ZERO   =  0.D0,
     &           ONE    =  1.D0,
     &           TWO    =  2.D0,
     &           OHALF  =  0.5D0,
     &           EPS    =  1.D-10,
     &           EMIN   =  0.3D0,
     &           DEPS   =  1.D-40)
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
C
      PARAMETER (NMXJ=40)
      CHARACTER*10 REJTIT
      COMMON /REJSTA/ IFAIL(NMXJ),REJTIT(NMXJ)
C
      CHARACTER*8 MDLNA
      COMMON /MODELS/ MDLNA(50),ISWMDL(50),PARMDL(200),IPAMDL(200)
C
      PARAMETER (NMXHEP=2000)
      COMMON/HEPEVS/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     &JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
      COMMON/HEPEVE/IMPART(NMXHEP),IPHIST(2,NMXHEP),ICOLOR(2,NMXHEP)
C
      PARAMETER (MSTR=100)
      COMMON /STRING/ GAMBET(4,MSTR),NPOS(3,MSTR),NCODE(MSTR),
     &     IPAR1(MSTR),IPAR2(MSTR),IPAR3(MSTR),IPAR4(MSTR),
     &     NNCH(MSTR),IBHAD(MSTR),ISTR
C
      DIMENSION PC1(4),PC2(4),P1(4),PTR(4),GAM(3),GAMB(3)
C
      IF(IREJ.EQ.-1) THEN
        ICTOT = 0
        ICCOR = 0
        RETURN
      ELSE IF(IREJ.EQ.-2) THEN
        WRITE(6,'(/1X,A,2I8/)')
     &    'MASCOR:DEBUG:TOTAL/CONVERTED CHAINS',ICTOT,ICCOR
        RETURN
      ENDIF

      IREJ = 0
      NITER = 100
      ITER = 0
      ICTOT = ICTOT+ISTR
      IF(ISWMDL(7).EQ.-1) RETURN
C  debug chain common
      IF(IDEB(42).GE.25) CALL POPRST
C
      ITOUCH = 0
 50   CONTINUE
      ITER = ITER+1
      IF(ITER.GE.NITER) THEN
        IREJ = 1
        IF(IDEB(42).GE.2) THEN
          WRITE(6,'(1X,A,2I5)') 'MASCOR:WARNING:REJECTION',ITER,NITER
          IF(IDEB(42).GE.10) CALL POPREV(0)
        ENDIF
        RETURN
      ENDIF
C
C  check mass limits
      IF(RNDM(CMASS0).LT.0.5D0) THEN
        IM1 = 1
        IM2 = ISTR
        IST = 1
      ELSE
        IM1 = ISTR
        IM2 = 1
        IST = -1
      ENDIF
      DO 100 I=IM1,IM2,IST
        J1 = NPOS(1,I)
        CMASS0 = PHEP(5,J1)
C  get masses
        IF(NCODE(I).EQ.3) THEN
          CALL POMEMA(IPAR1(I),IPAR2(I),AM1,AM2,AM3,AM4,IP1,IP2)
        ELSE IF((NCODE(I).EQ.4).OR.(NCODE(I).EQ.6)) THEN
          CALL POBAMA(IPAR1(I),IPAR2(I),IPAR3(I),
     &                AM1,AM2,AM3,AM4,IP1,IP2)
        ELSE IF(NCODE(I).EQ.5) THEN
          CALL PODIMA(IPAR1(I),IPAR2(I),IPAR3(I),IPAR4(I),
     &              AM1,AM2,AM3,AM4,IP1,IP2)
        ELSE IF(NCODE(I).LT.0) THEN
          GOTO 90
        ELSE
          WRITE(6,'(/,1X,A,2I5)') 'MASCOR:ERROR:CHAIN NO,NCODE ',
     &                            J1,NCODE(I)
          CALL POABRT
        ENDIF
        IF(IDEB(42).GE.20)
     &    WRITE(6,'(1X,A,/3X,I3,5E11.3,2I5)')
     &      'MASCOR:DEBUG:CHAIN NO, CHMASS,AM1,AM2,AM3,AM4,IP1,IP2 ',
     &      I,CMASS0,AM1,AM2,AM3,AM4,IP1,IP2
C  select masses to correct
        IBHAD(I) = 0
        NNCH(I) = 0
C  correction needed?
C  no resonances for diquark-anti-diquark chains
        IF(NCODE(I).EQ.5) THEN
          IF(CMASS0.LT.1.1D0*AM1) THEN
            IF(ISWMDL(7).LE.2) THEN
              IBHAD(I) = 8888
              NNCH(I)  = -1
              CHMASS   = AM1*1.3D0
            ELSE
              IREJ = 1
              RETURN
            ENDIF
          ENDIF
        ELSE
          INEED = 0
C  resonances possible
          IF(ISWMDL(7).EQ.0) THEN
            IF(CMASS0.LT.AM1*0.99D0) THEN
              IBHAD(I) = IP1
              NNCH(I)  = -1
              CHMASS   = AM1
              INEED = 1
            ELSE IF(CMASS0.LT.MIN(AM2,AM4)*1.2D0) THEN
              DELM1 = ONE/((CMASS0-AM1)**2+EPS)
              DELM2 = ONE/((CMASS0-AM3)**2+EPS)
              IF(RNDM(DELM1).LT.DELM1/(DELM1+DELM2)) THEN
                IBHAD(I) = IP1
                NNCH(I)  = -1
                CHMASS   = AM1
              ELSE
                IBHAD(I) = IP2
                NNCH(I)  = 1
                CHMASS   = AM3
              ENDIF
            ENDIF
          ELSE IF((ISWMDL(7).EQ.1).OR.(ISWMDL(7).EQ.2)) THEN
            IF(CMASS0.LT.AM1*0.99) THEN
              IBHAD(I) = IP1
              NNCH(I) = -1
              CHMASS = AM1
              INEED = 1
            ENDIF
          ELSE IF(ISWMDL(7).EQ.3) THEN
            IF(CMASS0.LT.AM1) THEN
              IREJ = 1
              RETURN
            ENDIF
          ELSE
            WRITE(6,'(/1X,A,I5)')
     &        'MASCOR:ERROR:UNSUPPORTED ISWMDL(7)',ISWMDL(7)
            CALL POABRT
          ENDIF
        ENDIF
C
C  correction necessary?
        IF(IBHAD(I).NE.0) THEN
C  find largest invar. mass
          IPOS = 0
          CMASS1 = -1.D0
          DO 200 J2=NHEP,3,-1
            IF((ABS(ISTHEP(J2)).EQ.1)
     &         .AND.(NCODE(IPHIST(1,J2)).GT.0)) THEN
              CMASS2= (PHEP(4,J1)+PHEP(4,J2))**2
     &               -(PHEP(1,J1)+PHEP(1,J2))**2
     &               -(PHEP(2,J1)+PHEP(2,J2))**2
     &               -(PHEP(3,J1)+PHEP(3,J2))**2
              IF(CMASS2.GT.CMASS1) THEN
                IPOS=J2
                CMASS1=CMASS2
              ENDIF
            ENDIF
 200      CONTINUE
          J2 = IPOS
          IF((J1.EQ.J2).OR.(CMASS1.LE.EMIN)) THEN
            IF(INEED.EQ.1) THEN
              IREJ = 1
              RETURN
            ELSE
              IBHAD(I) = 0
              NNCH(I) = 0
              GOTO 90
            ENDIF
          ENDIF
          ISTA = ISTHEP(J1)
          ISTB = ISTHEP(J2)
          CMASS1 = SQRT(CMASS1)
          CMASS2 = PHEP(5,J2)
          IF(CMASS1.LT.(CMASS2+CHMASS)) CMASS2 = CMASS1-1.1D0*CHMASS
          IREJ = 1
          IF(CMASS2.GT.0.D0) CALL MSHELL(PHEP(1,J1),PHEP(1,J2),
     &      CHMASS,CMASS2,PC1,PC2,IREJ)
          IF(IREJ.NE.0) THEN
            IFAIL(24) = IFAIL(24)+1
            IF(IDEB(42).GE.2) THEN
              WRITE(6,'(1X,A,2I4)')
     &          'MASCOR:WARNING:MSHELL REJECTION:J1,J2',J1,J2
              IF(IDEB(42).GE.10) CALL POPREV(0)
            ENDIF
            IREJ = 1
            RETURN
          ENDIF
C  momentum transfer
          DO 210 II=1,4
            PTR(II) = PHEP(II,J2)-PC2(II)
 210      CONTINUE
          IF(IDEB(42).GE.10) WRITE(6,'(1X,A,/5X,2I3,4E12.3)')
     &      'MASCOR:DEBUG:J1,J2,TRANSFER',J1,J2,PTR
C  copy parents of chains
C  register partons belonging to first chain
          IF(IDHEP(J1).EQ.8888) THEN
            K1 = JMOHEP(1,J1)
            K2 = MAX(JMOHEP(1,J1),-JMOHEP(2,J1))
            ESUM = ZERO
            DO 500 II=K1,K2
              ESUM = ESUM+PHEP(4,II)
 500        CONTINUE
            IF(JMOHEP(2,J1).GT.0) ESUM = ESUM+PHEP(4,JMOHEP(2,J1))
            DO 600 II=K1,K2
              FAC = PHEP(4,II)/ESUM
              DO 650 K=1,4
                P1(K) = PHEP(K,II)+FAC*PTR(K)
 650          CONTINUE
              CALL REGPAR(-1,IDHEP(II),0,J1,J2,P1(1),P1(2),P1(3),P1(4),
     &                    IPHIST(1,II),IPHIST(2,II),ICOLOR(1,II),
     &                    ICOLOR(2,II),IPOS,1)
 600        CONTINUE
            K1A = IPOS+K1-K2
            IF(JMOHEP(2,J1).GT.0) THEN
              II = JMOHEP(2,J1)
              FAC = PHEP(4,II)/ESUM
              DO 675 K=1,4
                P1(K) = PHEP(K,II)+FAC*PTR(K)
 675          CONTINUE
              CALL REGPAR(-1,IDHEP(II),0,J1,J2,P1(1),P1(2),P1(3),P1(4),
     &                    IPHIST(1,II),IPHIST(2,II),ICOLOR(1,II),
     &                    ICOLOR(2,II),IPOS,1)
            ENDIF
            K2A = -IPOS
          ELSE
            K1A = J1
            K2A = J2
          ENDIF
C  register partons belonging to second chain
          IF(IDHEP(J2).EQ.8888) THEN
            CALL GETLTR(PHEP(1,J2),PC2,GAM,GAMB,DELE,IREJL)
            K1 = JMOHEP(1,J2)
            K2 = MAX(JMOHEP(1,J2),-JMOHEP(2,J2))
            ESUM = ZERO
            DO 300 II=K1,K2
              ESUM = ESUM+PHEP(4,II)
 300        CONTINUE
            IF(JMOHEP(2,J2).GT.0) ESUM = ESUM+PHEP(4,JMOHEP(2,J2))
            DO 400 II=K1,K2
              FAC = PHEP(4,II)/ESUM
              IF(IREJL.EQ.0) THEN
                CALL MKSLTR(PHEP(1,II),P1,GAM,GAMB)
                P1(4) = P1(4)+FAC*DELE
              ELSE
                DO 450 K=1,4
                  P1(K) = PHEP(K,II)-FAC*PTR(K)
 450            CONTINUE
              ENDIF
              CALL REGPAR(-1,IDHEP(II),0,J1,J2,P1(1),P1(2),P1(3),P1(4),
     &                    IPHIST(1,II),IPHIST(2,II),ICOLOR(1,II),
     &                    ICOLOR(2,II),IPOS,1)
 400        CONTINUE
            K1B = IPOS+K1-K2
            IF(JMOHEP(2,J2).GT.0) THEN
              II = JMOHEP(2,J2)
              FAC = PHEP(4,II)/ESUM
              IF(IREJL.EQ.0) THEN
                CALL MKSLTR(PHEP(1,II),P1,GAM,GAMB)
                P1(4) = P1(4)+FAC*DELE
              ELSE
                DO 475 K=1,4
                  P1(K) = PHEP(K,II)-FAC*PTR(K)
 475            CONTINUE
              ENDIF
              CALL REGPAR(-1,IDHEP(II),0,J1,J2,P1(1),P1(2),P1(3),P1(4),
     &                    IPHIST(1,II),IPHIST(2,II),ICOLOR(1,II),
     &                    ICOLOR(2,II),IPOS,1)
            ENDIF
            K2B = -IPOS
          ELSE
            K1B = J1
            K2B = J2
          ENDIF
C  register first chain/collapsed to hadron
          IF((ISWMDL(7).EQ.0).OR.(ISWMDL(7).EQ.1)) THEN
            IF(NCODE(I).NE.5) THEN
              CALL REGPAR(1,0,IBHAD(I),K1A,K2A,PC1(1),PC1(2),PC1(3),
     &          PC1(4),IPHIST(1,J1),IPHIST(2,J1),0,0,IPOS,1)
C  label chain as collapsed to hadron/resonance
              NCODE(I)  = -99
              IDHEP(J1) = 6666
            ELSE
              CALL REGPAR(-1,8888,0,K1A,K2A,PC1(1),PC1(2),PC1(3),
     &          PC1(4),IPHIST(1,J1),IPHIST(2,J1),0,0,IPOS,1)
              IDHEP(J1) = 7777
            ENDIF
            NPOS(1,I) = IPOS
            NPOS(2,I) = K1A
            NPOS(3,I) = K2A
          ELSE
            CALL REGPAR(ISTA,IDHEP(J1),IMPART(J1),K1A,K2A,PC1(1),
     &        PC1(2),PC1(3),PC1(4),IPHIST(1,J1),IPHIST(2,J1),
     &        ICOLOR(1,J1),ICOLOR(2,J1),IPOS,1)
            IF(IDHEP(J1).EQ.8888) THEN
              NPOS(1,IPHIST(1,J1)) = IPOS
              NPOS(2,IPHIST(1,J1)) = K1A
              NPOS(3,IPHIST(1,J1)) = K2A
C  label chain as collapsed to resonance-chain
              IDHEP(J1) = 7777
            ELSE IF((IPHIST(1,J1).GE.1).AND.(IPHIST(1,J1).LE.ISTR)) THEN
              IF(NPOS(1,IPHIST(1,J1)).EQ.J1) NPOS(1,IPHIST(1,J1))=IPOS
            ENDIF
          ENDIF
C  register second chain/hadron/parton
          CALL REGPAR(ISTB,IDHEP(J2),IMPART(J2),K1B,K2B,PC2(1),PC2(2),
     &      PC2(3),PC2(4),IPHIST(1,J2),IPHIST(2,J2),ICOLOR(1,J2),
     &      ICOLOR(2,J2),IPOS,1)
          IF(IDHEP(J2).EQ.8888) THEN
            NPOS(1,IPHIST(1,J2))=IPOS
            NPOS(2,IPHIST(1,J2))=K1B
            NPOS(3,IPHIST(1,J2))=K2B
C  label chain touched by momentum transfer
            IDHEP(J2) = 7777
          ELSE IF((IPHIST(1,J2).GE.1).AND.(IPHIST(1,J2).LE.ISTR)) THEN
            IF(NPOS(1,IPHIST(1,J2)).EQ.J2) NPOS(1,IPHIST(1,J2))=IPOS
          ENDIF
          ICCOR = ICCOR+1
          ITOUCH = ITOUCH+1
C  consistency checks
          IF(IDEB(42).GE.5) THEN
            CALL POQCHK(-1,IDEV)
            IF(IDEB(42).GE.25) CALL POPREV(0)
          ENDIF
C  jump to next iteration
          GOTO 50
        ENDIF
 90     CONTINUE
 100  CONTINUE
C  debug output
      IF(IDEB(42).GE.15) THEN
        IF((ITOUCH.GT.0).OR.(IDEB(42).GE.25)) THEN
          WRITE(6,'(1X,A,I5)') 'MASCOR:DEBUG:ITERATIONS:',ITER
          CALL POPREV(1)
        ENDIF
      ENDIF
      END
