C
C
      SUBROUTINE POSFTU(IDPDG,SCALE2,PMASS)
C*********************************************************************
C
C     structure function test utility
C
C     input:    IDPDG    PDG ID of particle
C               SCALE2   scale (squared)
C               PMASS    mass of particle (neg. possible for photons)
C
C     output:   tables of PDF, sum rule checking, table of F2
C
C*********************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE
C
      PARAMETER (ZERO = 0.D0)
C
      CHARACTER*8 PDFNAM
      COMMON /PARPDF/ PDFLAM(2),PDFQ2M(2),PDFNAM(2),IPARID(2),PARVI(2),
     &                IPAVA(2),ITYPE(2),IGRP(2),ISET(2),IEXT(2),NPAOLD
C
      PARAMETER (IZERO=0)
      DIMENSION PD(-6:6),PDSUM(-6:6),PDAVE(-6:6),FXP(4)
      CHARACTER*8 PDFNA
C
      CALL ACTPDF(IDPDG,PMASS,1)
      CALL GETPDF(1,PDFNA,ALA,Q2MI,Q2MA,XMI,XMA)
C
      WRITE(6,'(/,A)') ' *** Structure Function Test Utility ***'
      WRITE(6,'(A)') ' ======================================='
C
      WRITE(6,'(/,A,3I10)')
     &  ' used structure function:',ITYPE(1),IGRP(1),ISET(1)
      WRITE(6,'(A,A)')     ' corresponds to ',PDFNA
      WRITE(6,'(A,E12.3)') '  used squared scale:',SCALE2
      WRITE(6,'(A,E12.3)') ' particle virtuality:',PMASS
      WRITE(6,'(/1X,A)') 'x times parton densities'
      WRITE(6,'(1X,A)') '    X         PD(-4 - 4)'
      WRITE(6,'(1X,A)')
     &   ' ============================================================'
 10   FORMAT(1X,10E11.4)
C  logarithmic loop over x values
C  upper bound
      XUPPER=0.9999D0
C  lower bound
      XLOWER=1.D-4
C  number of steps
      NSTEP=50
C
      XFIRST=LOG(XLOWER)
      XDELTA=LOG(XUPPER/XLOWER)/DBLE(NSTEP-1)
      DO 100 I=1,NSTEP
        X=EXP(XFIRST)
        XCONTR=X
        CALL PDIS(X,SCALE2,1,PD)
        IF(X.NE.XCONTR) THEN
          WRITE(6,*) ' x changed! old: ',XCONTR,' new: ',X
        ENDIF
        WRITE(6,10) XCONTR,(PD(K),K=-4,4)
        XFIRST=XFIRST+XDELTA
 100  CONTINUE
C
      IF(IDPDG.EQ.22) THEN
        WRITE(6,'(/1X,A)') 
     &   'comparison PDF to contribution due to box diagram'
        WRITE(6,'(1X,A)') '    X   PD(1),PB(1), .... ,PD(4),PB(4)'
        WRITE(6,'(1X,A)')
     &   ' ============================================================'
        XFIRST=LOG(XLOWER)
        XDELTA=LOG(XUPPER/XLOWER)/DBLE(NSTEP-1)
        DO 110 I=1,NSTEP
          X=EXP(XFIRST)
          CALL PDIS(X,SCALE2,1,PD)
          DO 120 K=1,4
            CALL POPDFB(K,X,SCALE2,PMASS,FXP(K))
 120      CONTINUE
          WRITE(6,'(1X,9E11.4)') X,(PD(K),FXP(K),K=1,4)
          XFIRST=XFIRST+XDELTA
 110    CONTINUE
      ENDIF
C
C  check momentum sum rule
      WRITE(6,'(/1X,A)') 'POSFTU: ESTIMATE OF QUARK SUM RULES'
      DO 199 I=-6,6
        PDSUM(I) = ZERO
        PDAVE(I) = ZERO
 199  CONTINUE
      ITER=5000
      DO 200 I=1,ITER
        XX=DBLE(I)/DBLE(ITER)
        IF(XX.EQ.1.D0) XX = 0.999999D0
        CALL PDIS(XX,SCALE2,1,PD)
        DO 202 K=-6,6
          PDSUM(K) = PDSUM(K)+PD(K)/XX
          PDAVE(K) = PDAVE(K)+PD(K)
 202    CONTINUE
 200  CONTINUE
      WRITE(6,'(1X,A)') 
     &  'POSFTU:PARTON-ID,DX-INTEGRAL: Q(X,Q**2), X*Q(X,Q**2)'
      XSUM = ZERO
      DO 204 I=-6,6
        PDSUM(I) = PDSUM(I)/DBLE(ITER)
        PDAVE(I) = PDAVE(I)/DBLE(ITER)
        XSUM = XSUM+PDAVE(I)
        WRITE(6,'(9X,I3,3X,2E15.4)') I,PDSUM(I),PDAVE(I)
 204  CONTINUE
      WRITE(6,'(1X,A)') 'NUMBER OF VALENCE FLAVOURS'
      DO 205 I=1,6
        WRITE(6,'(9X,I3,E12.4)') I,PDSUM(I)-PDSUM(-I)
 205  CONTINUE
      WRITE(6,'(1X,A,E12.4)') 'MOMENTUM SUM RULE',XSUM
      WRITE(6,'(A/)') ' ============================================='
C
C  table of F2
      WRITE(6,'(/1X,A,E12.4,/1X,A)')
     &  'POSFTU: TABLE OF X, F2(X,Q**2) FOR Q**2',SCALE2,
     &  '-----------------------------------------------------'
      ITER=100
      DO 300 I=1,ITER
        XX=DBLE(I)/DBLE(ITER)
        IF(XX.EQ.1.D0) XX = 0.9999D0
        CALL PDIS(XX,SCALE2,1,PD)
        F2 = ZERO
        DO 302 K=-6,6
          IF(K.NE.0) F2 = F2 + (4.D0-3.D0*MOD(ABS(K),2))*PD(K)
 302    CONTINUE
        WRITE(6,'(5X,2E14.5)') XX,F2/9.D0
 300  CONTINUE
      WRITE(6,'(A/)') ' ============================================='
      END
