C
C
      SUBROUTINE QGRAPH(ILOGX,ILOGY,N,IARG,X,Y1,Y2)
C***********************************************************************
C
C     calculate quasi graphic picture with 25 lines and 79 columns
C     ranges will be chosen automatically
C
C     input     ILOGX      0   linear scale in x
C                          1   logarithmic scale in x
C               ILOGY      0   linear scale in y
C                          1   logarithmic scale in y
C               N          dimension of input fields
C               IARG       number of curves (fields) to plot
C               X          field of X
C               Y1         field of Y1
C               Y2         field of Y2
C
C***********************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE
C
      PARAMETER (EPS = 1.D-10, DEPS=1.D-30)
C
      DIMENSION X(N),Y1(N),Y2(N)
      PARAMETER (IYRAST=5,IXRAST=10,IBREIT=79,IZEIL=20)
      CHARACTER SYMB(5)
      CHARACTER COL(0:149,0:49)
C
      DATA SYMB /'0','e','z','#','x'/
C
      ISPALT=IBREIT-10
C
C***  automatic range fitting
C
      XMAX=X(1)
      XMIN=X(1)
      DO 600 I=1,N
        XMAX=MAX(X(I),XMAX)
        XMIN=MIN(X(I),XMIN)
 600  CONTINUE
      IF(ILOGX.EQ.1) THEN
        IF(XMIN.LE.0.D0) THEN
          WRITE(6,'(/1X,A,2E12.5)') 
     &      'QGRAPH:ERROR:INVALID RANGE FOR LOG-X PLOT',XMIN,XMAX
          RETURN
        ENDIF
        XMAX = LOG(XMAX)
        XMIN = LOG(XMIN)
      ENDIF
      XZOOM=(XMAX-XMIN)/DBLE(ISPALT)
C
      ITEST=0
      DO 1100 K=0,IZEIL-1
        ITEST=ITEST+1
        IF(ITEST.EQ.IYRAST) THEN
          DO 1010 L=1,ISPALT-1
            COL(L,K)='-'
 1010     CONTINUE
          COL(ISPALT,K)='+'
          ITEST=0
          DO 1020 L=0,ISPALT-1,IXRAST
            COL(L,K)='+'
 1020     CONTINUE
        ELSE
          DO 1030 L=1,ISPALT-1
            COL(L,K)=' '
 1030     CONTINUE
          DO 1040 L=0,ISPALT-1,IXRAST
            COL(L,K)='|'
 1040     CONTINUE
          COL(ISPALT,K)='|'
        ENDIF
 1100 CONTINUE
C
C***  plot curve Y1
C
      YMAX=Y1(1)
      IF(ILOGY.EQ.0) THEN
        YMIN=Y1(1)
      ELSE
        YMIN=MAX(Y1(1),DEPS)
      ENDIF
      DO 500 I=1,N
        YMAX=MAX(Y1(I),YMAX)
        IF(ILOGY.EQ.0) THEN
          YMIN=MIN(Y1(I),YMIN)
        ELSE
          YMAX =MAX(Y1(I),YMAX)
          IF(Y1(I).GT.DEPS) THEN
            IF(YMIN.EQ.DEPS) THEN
              YMIN = Y1(I)/10.D0
            ELSE
              YMIN = MIN(Y1(I),YMIN)
            ENDIF
          ENDIF
        ENDIF
 500  CONTINUE
C
      IF(IARG.GT.1) THEN
        DO 550 I=1,N
          YMAX=MAX(Y2(I),YMAX)
          IF(ILOGY.EQ.0) THEN
            YMIN=MIN(Y2(I),YMIN)
          ELSE
            YMAX =MAX(Y2(I),YMAX)
            IF(Y2(I).GT.DEPS) THEN
              IF(YMIN.EQ.DEPS) THEN
                YMIN = Y2(I)/10.D0
              ELSE
                YMIN = MIN(Y2(I),YMIN)
              ENDIF
            ENDIF
          ENDIF
 550    CONTINUE
      ENDIF
C
      IF(ILOGY.EQ.1) THEN
        DO 560 I=1,N
          Y1(I) = MAX(Y1(I),YMIN)
 560    CONTINUE
        IF(IARG.GT.1) THEN
          DO 570 I=1,N
            Y2(I) = MAX(Y2(I),YMIN)
 570      CONTINUE
        ENDIF
      ENDIF
C
      IF(ILOGY.EQ.0) THEN
        YMA=(YMAX-YMIN)/20.0D0+YMAX
        YMI=YMIN-(YMAX-YMIN)/20.0D0
        YZOOM=(YMA-YMI)/DBLE(IZEIL)
      ELSE
        YMA=LOG(YMAX/YMIN)/20.0D0+LOG(YMAX)
        YMI=LOG(YMIN)-LOG(YMAX/YMIN)/20.0D0
        YZOOM=(YMA-YMI)/DBLE(IZEIL)
      ENDIF
C
      IF(YZOOM.LT.EPS) THEN
        WRITE(6,'(/1X,A,2E12.5)')
     &    'QGRAPH:WARNING: YMIN = YMAX, OUTPUT SUPPRESSED',YMIN,YMAX
        RETURN
      ENDIF
C
C***  plot curve Y1
C
      ILAST=-1
      LLAST=-1
      DO 1200 K=1,N
        IF(ILOGX.EQ.0) THEN
          L=NINT((X(K)-XMIN)/XZOOM)
        ELSE
          L=NINT((LOG(X(K))-XMIN)/XZOOM)
        ENDIF
        IF(ILOGY.EQ.0) THEN
          I=NINT((YMA-Y1(K))/YZOOM)
        ELSE
          I=NINT((YMA-LOG(Y1(K)))/YZOOM)
        ENDIF
        IF(ILAST.GE.0) THEN
          LD = L-LLAST
          ID = I-ILAST
          DO 55 II=0,LD,SIGN(1,LD)
            DO 66 KK=0,ID,SIGN(1,ID)
              COL(II+LLAST,KK+ILAST)=SYMB(1)
 66         CONTINUE
 55       CONTINUE
        ELSE
          COL(L,I)=SYMB(1)
        ENDIF
        ILAST = I
        LLAST = L
 1200 CONTINUE
C
      IF(IARG.GT.1) THEN
C
C***  plot curve Y2
C
        DO 1250 K=1,N
          IF(ILOGX.EQ.0) THEN
            L=NINT((X(K)-XMIN)/XZOOM)
          ELSE
            L=NINT((LOG(X(K))-XMIN)/XZOOM)
          ENDIF
          IF(ILOGY.EQ.0) THEN
            I=NINT((YMA-Y2(K))/YZOOM)
          ELSE
            I=NINT((YMA-LOG(Y2(K)))/YZOOM)
          ENDIF
          COL(L,I)=SYMB(2)
 1250   CONTINUE
      ENDIF
C
C***  write it
C
      IF(ILOGX.EQ.1) WRITE(6,'(2X,A)') '(LOGARITHMIC X AXIS ASSUMED)'
      IF(ILOGY.EQ.1) WRITE(6,'(2X,A)') '(LOGARITHMIC Y AXIS)'
      WRITE(6,'(1X,79A)') ('-',I=1,IBREIT)
C
C***  write range of X
C
      XZOOM = (XMAX-XMIN)/DBLE(7)
      IF(ILOGX.EQ.0) THEN
        WRITE(6,120) (XZOOM*DBLE(I-1)+XMIN,I=1,7)
      ELSE
        WRITE(6,120) (EXP(XZOOM*DBLE(I-1)+XMIN),I=1,7)
      ENDIF
C
      DO 1300 K=0,IZEIL-1
        IF(ILOGY.EQ.0) THEN
          YPOS=YMA-((DBLE(K)+0.5D0)*YZOOM)
        ELSE
          YPOS=EXP(YMA-((DBLE(K)+0.5D0)*YZOOM))
        ENDIF
        WRITE(6,110) YPOS,(COL(I,K),I=0,ISPALT)
 110    FORMAT(1X,1PE9.2,70A1)
 1300 CONTINUE
C
C***  write range of X
C
      XZOOM = (XMAX-XMIN)/DBLE(7)
      IF(ILOGX.EQ.0) THEN
        WRITE(6,120) (XZOOM*DBLE(I-1)+XMIN,I=1,7)
      ELSE
        WRITE(6,120) (EXP(XZOOM*DBLE(I-1)+XMIN),I=1,7)
      ENDIF
      WRITE(6,'(1X,79A)') ('-',I=1,IBREIT)
 120  FORMAT(6X,7(1PE10.3))
      END
