C
C
      SUBROUTINE SELSXS(MSOFT,MSMIN,XPOT1,XPOT2,XS1,XS2,XMAX1,XMAX2,
     &                  XSOFT1,XSOFT2,IREJ)
C***********************************************************************
C
C    select x values of soft chain ends (rescaling method)
C
C***********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      DIMENSION XPOT1(50),XPOT2(50),XSOFT1(50),XSOFT2(50)
      PARAMETER (ZERO   =  0.D0,
     &           ONE    =  1.D0,
     &           TWO    =  2.D0,
     &           OHALF  =  0.5D0)
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
C
      COMMON /HASCA / PTWANT,AS,AH,ALNS,ALNH,Z1MAX,Z1DIF,Z2MAX,Z2DIF,
     &                PT,ETAC,ETAD,X1,X2,V,U,QQPD,QQAL,
     &                W,W1,AXX,WEIGHT,MSPR,IREJSC
      COMMON /GLOCMS/ ECM,PCM,PMASS(2),PVIRT(2),IFPAP(2),IFPAB(2)
      COMMON /CUTOFF/ PTCUT(4),CUTMU(4),FPS(4),FPH(4),PSOMIN,XSOMIN
C
      DIMENSION XLDIF(2,50),XLMIN(2,50),REVP(2,50),POT(2,50)
C
      IREJ = 0
C
      IF(IDEB(14).GE.10) THEN
        WRITE(6,'(1X,A)') 'SELSXS:DEBUG:'
        WRITE(6,'(5X,A,I4,4E12.3)') 'MSOFT,XS1,XS2,XMAX1,2',
     &    MSOFT,XS1,XS2,XMAX1,XMAX2
        DO 40 I=1,MSOFT
          WRITE(6,'(5X,A,I4,2E12.3)') 'EXPONENTS',I,XPOT1(I),XPOT2(I)
 40     CONTINUE
      ENDIF
C
 10   CONTINUE
C
      IF(MSOFT.EQ.1) THEN
        XSOFT1(1) = ONE-XS1
        XSOFT1(2) = ZERO
        XSOFT2(1) = ONE-XS2
        XSOFT2(2) = ZERO
        RETURN
      ENDIF
      XMIN = MAX(PSOMIN/ECM*TWO,XSOMIN)
      XMIN1 = MAX(AS/XMAX2,XMIN)
      XMIN2 = MAX(AS/XMAX1,XMIN)
      IF((XMIN1.GE.XMAX1).OR.(XMIN2.GE.XMAX2)) THEN
        IF(IDEB(14).GE.1) THEN
          WRITE (6,'(1X,A,4E10.3)')
     &      'SELSXS:WARNING:XMIN>XMAX (XMIN1,2/XMAX1,2)',
     &      XMIN1,XMIN2,XMAX1,XMAX2
          CALL POPREV(-1)
        ENDIF
        IREJ = 1
        RETURN
      ENDIF
C
      DO 50 I=1,MSOFT
        POT(1,I) = XPOT1(I)+ONE
        POT(2,I) = XPOT2(I)+ONE
        REVP(1,I) = ONE/POT(1,I)
        REVP(2,I) = ONE/POT(2,I)
        XLMIN(1,I) = XMIN1**POT(1,I)
        XLMAX = XMAX1**POT(1,I)
        XLDIF(1,I) = XLMAX-XLMIN(1,I)
        XLMIN(2,I) = XMIN2**POT(2,I)
        XLMAX = XMAX2**POT(2,I)
        XLDIF(2,I) = XLMAX-XLMIN(2,I)
 50   CONTINUE
C
      IITRY = 0
 5    CONTINUE
      IITRY = IITRY + 1
      IF(IITRY.GE.200) THEN
        IF(MSOFT-MSMIN.GE.4) THEN
          MSOFT= MSMIN
          GOTO 10
        ENDIF
        IF(IDEB(14).GT.2) THEN
          WRITE(6,'(1X,A,I4)') 'SELSXS:WARNING:REJECTION',IITRY
          WRITE(6,'(1X,A,I4,5E10.3)') 'MS,XMIN1/2,XMAX1/2,AS:',
     &      MSOFT,XMIN1,XMIN2,XMAX1,XMAX2,AS
        ENDIF
        IREJ = 1
        RETURN
      ENDIF
      XSUM1 = ZERO
      XSUM2 = ZERO
      DO 100 I=1,MSOFT
 20     CONTINUE
        Z1 = XLDIF(1,I)*RNDM(XS1)+XLMIN(1,I)
        Z2 = XLDIF(2,I)*RNDM(XS2)+XLMIN(2,I)
        XSOFT1(I) = Z1**REVP(1,I)
        XSOFT2(I) = Z2**REVP(2,I)
        IF( (XSOFT1(I)*XSOFT2(I)).LT.AS ) GOTO 20
        XSUM1 = XSUM1+XSOFT1(I)
        XSUM2 = XSUM2+XSOFT2(I)
 100  CONTINUE
      FAC1 = (ONE-XS1)/XSUM1
      FAC2 = (ONE-XS2)/XSUM2
      DO 200 I=1,MSOFT
        XSOFT1(I) = XSOFT1(I)*FAC1
        XSOFT2(I) = XSOFT2(I)*FAC2
        IF(XSOFT1(I)*XSOFT2(I).LT.AS) GOTO 5
 200  CONTINUE
C
      XS1 = ONE-XSOFT1(1)
      XS2 = ONE-XSOFT2(1)
C  debug output
      IF(IDEB(14).GE.10) THEN
        WRITE(6,'(1X,A,2E12.4)') 'XSUM 1,2:',XS1,XS2
        DO 30 I=1,MSOFT
          WRITE(6,'(5X,A,I4,2E12.3)') 'XSOFT',I,XSOFT1(I),XSOFT2(I)
 30     CONTINUE
      ENDIF
      END
