C
C
      SUBROUTINE SETPAR(ISIDE,IDPDG,IDBAM,PVIR)
C**********************************************************************
C
C     assign a particle to side 1 or 2
C     (also special treatment for remnants)
C
C     input:    ISIDE      1,2  side selected for the particle
C                          -2   output of current settings
C               IDPDG      PDG number
C               IDBAM      CPC number
C                          0     CPC determination in subroutine
C                          -1    special particle remnant, IDPDG
C                                is the particle number the remnant
C                                corresponds to (see /HADVAL/)
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE
C
      PARAMETER (DEPS = 1.D-20,
     &           ZERO = 0.D0)
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
C  global energy
      COMMON /GLOCMS/ ECM,PCM,PMASS(2),PVIRT(2),IFPAP(2),IFPAB(2)
      COMMON /HADVAL/ ECMN,PCMN,SECM,SPCM,XPSUB,XTSUB,
     &                IDEQP(2),IDEQB(2),IHFLD(2,2),IHFLS(2)
C
      CHARACTER*8 ANAME
      COMMON/POPART/ANAME(187),AM(187),GA(187),TAU(187),ICH(187),
     &              IBAR(187),K1(187),K2(187)
C
      IF((ISIDE.EQ.1).OR.(ISIDE.EQ.2)) THEN
        IDBAMN = IDBAM
C  remnant?
        IF(IDBAM.EQ.-1) THEN
          IF(ISIDE.EQ.1) THEN
            IDBAMR = 186
            IDPDGR = 777
          ELSE
            IDBAMR = 187
            IDPDGR = 888
          ENDIF
          IDEQB(ISIDE) = MCIHAD(IDPDG)
          IDEQP(ISIDE) = IDPDG
          IDB = IDEQB(ISIDE)
          AM(IDBAMR)  = AM(IDB)
          GA(IDBAMR)  = GA(IDB)
          TAU(IDBAMR) = TAU(IDB)
          IF(IHFLS(ISIDE).EQ.1) THEN
            ICH(IDBAMR)  = ICH(IDB)
            IBAR(IDBAMR) = IBAR(IDB)
            K1(IDBAMR) = K1(IDB)
            K2(IDBAMR) = K2(IDB)
          ELSE
            ICH(IDBAMR)  = 0
            IBAR(IDBAMR) = 0
            K1(IDBAMR) = K1(111)
            K2(IDBAMR) = K2(111)
          ENDIF
          IFL1 = IHFLD(ISIDE,1)
          IFL2 = IHFLD(ISIDE,2)
          IFL3 = 0
          IF(IHFLS(ISIDE).EQ.1) THEN
            IF(ABS(IHFLD(ISIDE,1)).GT.1000) THEN
              IFL1 = IHFLD(ISIDE,1)/1000
              IFL2 = MOD(IHFLD(ISIDE,1)/100,10)
              IFL3 = IHFLD(ISIDE,2)
            ELSE IF(ABS(IHFLD(ISIDE,2)).GT.1000) THEN
              IFL1 = IHFLD(ISIDE,1)
              IFL2 = IHFLD(ISIDE,2)/1000
              IFL3 = MOD(IHFLD(ISIDE,2)/100,10)
            ENDIF
          ENDIF
          IFL1 = ICONV3(IFL1)
          IFL2 = ICONV3(IFL2)
          IFL3 = ICONV3(IFL3)
          IDUM = IBAMQU(-1,IDBAMR,IFL1)
          IDUM = IBAMQU(-2,IDBAMR,IFL2)
          IDUM = IBAMQU(-3,IDBAMR,IFL3)
          IDBAMN = IDBAMR
          IDPDGN = IDPDGR
          IF(IDEB(87).GE.5) THEN
            WRITE(6,'(1X,A,I2,/5X,A,I7,4I6)')
     &        'SETPAR:DEBUG:REMNANT ASSIGNMENT SIDE',ISIDE,
     &        'IDPDG,IFL1,2,3,IVAL',IDPDGN,IFL1,IFL2,IFL3,IHFLS(ISIDE)
          ENDIF
        ELSE IF(IDBAM.EQ.0) THEN
          IHFLS(ISIDE) = 1
          IHFLD(ISIDE,1) = 0
          IHFLD(ISIDE,2) = 0
          IDBAMN = MCIHAD(IDPDG)
          IDPDGN = IDPDG
        ENDIF
C initialize COMMON /GLOCMS/
        IFPAP(ISIDE) = IDPDGN
        IFPAB(ISIDE) = IDBAMN
        PMASS(ISIDE) = POPAMA(IDBAMN,0)
        IF(IFPAP(ISIDE).EQ.22) THEN
          PVIRT(ISIDE) = ABS(PVIR)
        ELSE
          PVIRT(ISIDE) = ZERO
        ENDIF
      ELSE IF(ISIDE.EQ.-2) THEN
C  output of current settings
        DO 100 I=1,2
          WRITE(6,'(1X,A,I2,2X,A,I7,I4,2E11.4)') 'SETPAR:DEBUG:SIDE',
     &      I,'IDPDG,IDBAM,PMASS,PVIRT',IFPAP(I),IFPAB(I),PMASS(I),
     &      PVIRT(I)
          IF((IFPAP(I).EQ.777).OR.(IFPAP(I).EQ.888)) THEN
            WRITE(6,'(5X,A,I7,I4,I2,3I5)')
     &        'REMNANT:IDPDG,IDBAM,IVAL,IFLA1,2',IDEQP(I),IDEQB(I),
     &        IHFLS(I),IHFLD(I,1),IHFLD(I,2)
          ENDIF
 100    CONTINUE
      ELSE
        WRITE(6,'(/1X,A,I8)') 'SETPAR:WARNING:INVALID ISIDE',ISIDE
      ENDIF
      END
