// * This code is licensed under:
// * RunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de).
// * All rights reserved.

#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <string.h>
#include <time.h>
using namespace std;

//******************************************************************************

int decomment ( char file_in_name[], char file_out_name[], char comment[] )

//******************************************************************************
//
//  Purpose:
//
//    handles a single file.
//
//  Discussion:
//
//    The routine reads a line, and if it does not begin with 
//    'comment' it copies
//    it to the output file.
//
//  Modified:
//
//    08 December 2003
//
//  Author:
//
//    John Burkardt
//    S. Chekanov (modified) 
//
//  Parameters:
//
//    Input, char FILE_IN_NAME[], the name of the input file.
//    Input, char FILE_OUT_NAME[], the name of the output file.
//    Input, char comment - any character. If line begins with this
//    character -  this line will be removed;   
//  
{
  int comment_count;
  ifstream file_in;
  ofstream file_out;
  char line[255];
//
// Open the input file.
//
  file_in.open ( file_in_name );

  if ( !file_in ) 
  {
    cout << "\n";
    cout << "HANDLE - Fatal error!\n";
    cout << "  Cannot open \"" << file_in_name << "\"\n";
    return 1;
  }
//
// Open the output file.
//
  file_out.open ( file_out_name );

  if ( !file_out ) 
  {
    cout << "\n";
    cout << "HANDLE - Fatal error!\n";
    cout << "  Cannot open \"" << file_out_name << "\"\n";
    return 1;
  }

  comment_count = 0;

  while ( 1 )
  {
    file_in.getline ( line, sizeof ( line ) );

    if ( file_in.eof() )
    {
      break;
    }
    if ( *line != *comment )
    {
      file_out << line << "\n";
    }
    else
    {
      comment_count = comment_count + 1;
    }
  }
//
// Close the files.
//
  file_in.close ( );
  file_out.close ( );

//  cout << file_in_name << " contained " << comment_count << " comments.\n";

  return 0;
}
