CDECK  ID>, HWISPN.
*CMZ :-        -12/10/01  17.22.48  by  Peter Richardson
*-- Author :    Peter Richardson
C-----------------------------------------------------------------------
      SUBROUTINE HWISPN
C-----------------------------------------------------------------------
C     Initialise all the decay modes for three/four body MEs and spin
C     correlations
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      INTEGER I,J,K,NDKYST
C--set the number of two and three body modes to zero
      N2MODE = 0
      N3MODE = 0
      NBMODE = 0
      N4MODE = 0
C--if not reading in decay info calculate it
      IF(LRDEC.EQ.0) THEN
C--initialise the couplings for the various decay modes
        CALL HWISPC
C--Top decays and SUSY three body decays (including SUSY gauge
C--boson 2 body modes which are treated as three body)
        IF(THREEB) CALL HWISP3
        IF(IERROR.NE.0) RETURN
C--then four body modes if needed
        IF(FOURB)  CALL HWISP4
        IF(IERROR.NE.0) RETURN
C--Two body modes if needed for spin correlations
        IF(SYSPIN) CALL HWISP2
        IF(IERROR.NE.0) RETURN
C--otherwise read it in
      ELSEIF(LRDEC.GT.0) THEN
C--open the unit
        IF (IPRINT.NE.0) WRITE (6,1) LRDEC
   1    FORMAT(/10X,'READING MATRIX ELEMENT TABLE ON UNIT',I4)
        OPEN(UNIT=LRDEC,FORM='UNFORMATTED',STATUS='UNKNOWN')
C--read  options
        READ(UNIT=LRDEC) NDKYST
        IF(NDKYS.NE.NDKYST) CALL HWWARN('HWISPN',501,*999)
        READ(UNIT=LRDEC) SYSPIN,THREEB,FOURB
C--read two body decays
        IF(SYSPIN) THEN
          READ(UNIT=LRDEC) N2MODE
          DO 2 I=1,N2MODE
 2        READ(UNIT=LRDEC) (A2MODE(J,I),J=1,2),P2MODE(I),WT2MAX(I),
     &                     ID2PRT(I),I2DRTP(I)
        ENDIF
C--read three body decays
        IF(SYSPIN.OR.THREEB) THEN
          READ(UNIT=LRDEC) N3MODE
          DO 3 I=1,N3MODE
          READ(UNIT=LRDEC) P3MODE(I),WT3MAX(I),ID3PRT(I),NDI3BY(I),
     &            ((SPN3CF(J,K,I),J=1,NCFMAX),K=1,NCFMAX),N3NCFL(I)
          DO 3 J=1,NDI3BY(I)
 3        READ(UNIT=LRDEC) (A3MODE(K,J,I),K=1,2),(B3MODE(K,J,I),K=1,2),
     &                      I3DRTP(J,I),I3MODE(J,I),I3DRCF(J,I)
C--read two body gauge boson modes
          READ(UNIT=LRDEC) NBMODE
          DO 4 I=1,NBMODE
 4        READ(UNIT=LRDEC) (ABMODE(J,I),J=1,2),
     &            ((BBMODE(J,K,I),J=1,2),K=1,12),(PBMODE(K,I),K=1,12),
     &            (WTBMAX(K,I),K=1,12),IDBPRT(I),IBMODE(I),IBDRTP(I)
        ENDIF
C--read four body decays
        IF(FOURB) THEN
          READ(UNIT=LRDEC) N4MODE
          DO 5 I=1,N4MODE
 5        READ(UNIT=LRDEC) ((A4MODE(J,K,I),J=1,2),K=1,12),
     &            ((B4MODE(J,K,I),J=1,2),K=1,12),
     &            ((P4MODE(J,K,I),J=1,12),K=1,12),
     &            ((WT4MAX(J,K,I),J=1,12),K=1,12),ID4PRT(I),
     &            (I4MODE(J,I),J=1,2)
        ENDIF
C--finally read in the matrix element codes
        READ(UNIT=LRDEC) NME
      ELSE
        CALL HWWARN('HWISPN',500,*999)
      ENDIF
C--write the decay information if needed
      IF(LWDEC.GT.0) THEN
C--open the file
        IF (IPRINT.NE.0) WRITE (6,6) LWDEC
 6      FORMAT(/10X,'WRITING MATRIX ELEMENT TABLE ON UNIT',I4)
        OPEN(UNIT=LWDEC,FORM='UNFORMATTED',STATUS='UNKNOWN')
C--write  options
        WRITE(UNIT=LWDEC) NDKYS
        WRITE(UNIT=LWDEC) SYSPIN,THREEB,FOURB
C--write two body decays
        IF(SYSPIN) THEN
          WRITE(UNIT=LWDEC) N2MODE
          DO 7 I=1,N2MODE
 7        WRITE(UNIT=LWDEC) (A2MODE(J,I),J=1,2),P2MODE(I),WT2MAX(I),
     &                     ID2PRT(I),I2DRTP(I)
        ENDIF
C--write three body decays
        IF(SYSPIN.OR.THREEB) THEN
          WRITE(UNIT=LWDEC) N3MODE
          DO 8 I=1,N3MODE
          WRITE(UNIT=LWDEC) P3MODE(I),WT3MAX(I),ID3PRT(I),NDI3BY(I),
     &            ((SPN3CF(J,K,I),J=1,NCFMAX),K=1,NCFMAX),N3NCFL(I)
          DO 8 J=1,NDI3BY(I)
 8        WRITE(UNIT=LWDEC) (A3MODE(K,J,I),K=1,2),(B3MODE(K,J,I),K=1,2),
     &                      I3DRTP(J,I),I3MODE(J,I),I3DRCF(J,I)
C--write two body gauge boson modes
          WRITE(UNIT=LWDEC) NBMODE
          DO 9 I=1,NBMODE
 9        WRITE(UNIT=LWDEC) (ABMODE(J,I),J=1,2),
     &            ((BBMODE(J,K,I),J=1,2),K=1,12),(PBMODE(K,I),K=1,12),
     &            (WTBMAX(K,I),K=1,12),IDBPRT(I),IBMODE(I),IBDRTP(I)
        ENDIF
C--write four body decays
        IF(FOURB) THEN
          WRITE(UNIT=LWDEC) N4MODE
          DO 10 I=1,N4MODE
 10       WRITE(UNIT=LWDEC) ((A4MODE(J,K,I),J=1,2),K=1,12),
     &            ((B4MODE(J,K,I),J=1,2),K=1,12),
     &            ((P4MODE(J,K,I),J=1,12),K=1,12),
     &            ((WT4MAX(J,K,I),J=1,12),K=1,12),ID4PRT(I),
     &            (I4MODE(J,I),J=1,2)
        ENDIF
C--finally write the matrix element codes
        WRITE(UNIT=LWDEC) NME
      ENDIF
      RETURN
 999  END
CDECK  ID>, HWISP2.
*CMZ :-        -30/09/02  14:05:28  by  Peter Richardson
*-- Author :    Peter Richardson
C-----------------------------------------------------------------------
      SUBROUTINE HWISP2
C-----------------------------------------------------------------------
C     Initialise the SUSY two body modes for spin correlations
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      INTEGER I,J,IL,IH,L,L1,IM,O(2),II,JJ,III,JJJ,KKK
      COMMON /HWSPNC/ SW,CW,TW,E,G,RT,ORT,MW,MZ,GS,AFN,AFG,AFC,OIJ,OIJP,
     &               OIJPP,HNN,HCC,HNC,HFF,HWW,HZZ,ZAB,HHB
      DOUBLE PRECISION SW,CW,TW,E,G,RT,ORT,MW,MZ,GS,AFN(2,12,2,4),
     &     AFG(2,6,2),AFC(2,12,2,2),OIJ(2,4,2),OIJP(2,2,2),OIJPP(2,4,4),
     &     HNN(2,3,4,4),HCC(2,3,2,2),HNC(2,4,2),HFF(2,4,12),HWW(2),
     &     HZZ(2),ZAB(12,2,2),HHB(2,3),FPI
      DATA O/2,1/
      DATA FPI/0.09298D0/
      IF(IERROR.NE.0.OR..NOT.SUSYIN) RETURN
C--now the two body modes for spin corrections
      DO 1000 JJ=1,NRES
      DO 1000 II=1,NMODES(JJ)
        IF(II.EQ.1) THEN
          I = LSTRT(JJ)
        ELSE
          I = LNEXT(I)
        ENDIF
        IF(IDKPRD(2,I).EQ.0.OR.IDKPRD(3,I).NE.0.OR.
     &        (NME(I).GT.10000.AND.NME(I).LT.50000)) GOTO 1000
        L1 = IDK(I)-449
C--two body top to charged higgs decay 
        IF(IDK(I).EQ.6.AND.IDKPRD(1,I).EQ.206.AND.
     &                     IDKPRD(2,I).EQ.5) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',100,*999)
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 2
            P2MODE(N2MODE) = ONE
            DO 201 J=1,2
 201        A2MODE(J,N2MODE) = HFF(O(J),4,3)
C--two body antitop to charged higgs
        ELSEIF(IDK(I).EQ.12.AND.IDKPRD(1,I).EQ.207.AND.
     &                          IDKPRD(2,I).EQ.11) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',101,*999)
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 14
            P2MODE(N2MODE) = ONE
            DO 202 J=1,2
 202        A2MODE(J,N2MODE) = HFF(  J ,4,3)
C--two body modes of the gluino
        ELSEIF(L1.EQ.0) THEN
          L = IDKPRD(1,I)-449
C--gluino to antisfermion fermion
          IF(IDPDG(IDKPRD(2,I)).GT.0.AND.L.GE.-48.AND.L.LE.-1) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',102,*999)
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 2
            P2MODE(N2MODE) = HALF
            IM = MOD(INT((IDKPRD(1,I)-389)/12)+1,2)+1
            IL = 6*INT((IDKPRD(1,I)-401)/24)+MOD(IDKPRD(1,I)-401,6)+1
            DO 1 J=1,2
 1          A2MODE(J,N2MODE) = AFG(J,IL,IM)
C--gluino to sfermion antifermion
          ELSEIF(IDPDG(IDKPRD(2,I)).LT.0.AND.L.GE.-48.AND.L.LE.-1) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',103,*999)
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 3
            P2MODE(N2MODE) = HALF
            IM = MOD(INT((IDKPRD(1,I)-389)/12)+1,2)+1
            IL = 6*INT((IDKPRD(1,I)-401)/24)+MOD(IDKPRD(1,I)-401,6)+1
            DO 2 J=1,2
 2          A2MODE(J,N2MODE) = AFG(O(J),IL,IM)
C--gluino to neutralino gluon
          ELSEIF(L.GE.1.AND.L.LE.4.AND.IDKPRD(2,I).EQ.13) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',104,*999)
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 4
            P2MODE(N2MODE) = 8.0D0*PIFAC*RMASS(IDK(I))**3/
     &           (RMASS(IDK(I))**2-RMASS(IDKPRD(1,I))**2)**3*
     &           HBAR/RLTIM(IDK(I))*BRFRAC(I)
            A2MODE(1,N2MODE) = ZSGNSS(L)
C--gluino to gravitino gluon
          ELSEIF(IDKPRD(1,I).EQ.458.AND.IDKPRD(2,I).EQ.13) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',105,*999)
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 9
            P2MODE(N2MODE) = ONE/24.0D0
          ENDIF
C--two body modes of the neutralinos
        ELSEIF(L1.GE.1.AND.L1.LE.4) THEN
          L  = IDKPRD(1,I)-449
          IH = IDKPRD(2,I)-202
C--first the neutralino modes to neutralino Higgs
          IF(L.GE.1.AND.L.LE.4.AND.IH.GE.1.AND.IH.LE.3) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GE.NMODE2) CALL HWWARN('HWISP2',106,*999)
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 1
            P2MODE(N2MODE) = ONE
            DO 3 J=1,2
 3          A2MODE(J,N2MODE) = HNN(J,IH,L,L1)
C--neutralino to positive chargino negative Higgs
          ELSEIF((L.EQ.5.OR.L.EQ.6).AND.IH.EQ.5) THEN
            L = L-4
            N2MODE = N2MODE+1
            IF(N2MODE.GE.NMODE2) CALL HWWARN('HWISP2',107,*999)
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 1
            P2MODE(N2MODE) = ONE
            DO 4 J=1,2
 4          A2MODE(J,N2MODE) = HNC(O(J),L1,L)
C--neutralino to negative chargino positive Higgs
          ELSEIF((L.EQ.7.OR.L.EQ.8).AND.IH.EQ.6) THEN
            L = L-6
            N2MODE = N2MODE+1
            IF(N2MODE.GE.NMODE2) CALL HWWARN('HWISP2',108,*999)
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 1
            P2MODE(N2MODE) = ONE
            DO 5 J=1,2
 5          A2MODE(J,N2MODE) = HNC(J,L1,L)
C--neutralino to antisfermion sfermion
          ELSEIF(IDPDG(IDKPRD(2,I)).GT.0.AND.L.GE.-48.AND.L.LE.-1) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',109,*999)
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 2
            P2MODE(N2MODE) = ONE
            IM = MOD(INT((IDKPRD(1,I)-389)/12)+1,2)+1
            IL = 6*INT((IDKPRD(1,I)-401)/24)+MOD(IDKPRD(1,I)-401,6)+1
            IF(IL.LE.6) P2MODE(N2MODE) = THREE
            DO 6 J=1,2
 6          A2MODE(J,N2MODE) = AFN(J,IL,IM,L1)
C--neutralino to sfermion antifermion
          ELSEIF(IDPDG(IDKPRD(2,I)).LT.0.AND.L.GE.-48.AND.L.LE.-1) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',110,*999)
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 3
            P2MODE(N2MODE) = ONE
            IM = MOD(INT((IDKPRD(1,I)-389)/12)+1,2)+1
            IL = 6*INT((IDKPRD(1,I)-401)/24)+MOD(IDKPRD(1,I)-401,6)+1
            IF(IL.LE.6) P2MODE(N2MODE) = THREE
            DO 7 J=1,2
 7          A2MODE(J,N2MODE) = AFN(O(J),IL,IM,L1)
C--neutralino to neutralino photon
          ELSEIF(L.GE.1.AND.L.LE.4.AND.IDKPRD(2,I).EQ.59) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',111,*999)
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 4
            P2MODE(N2MODE) = 8.0D0*PIFAC*RMASS(IDK(I))**3/
     &           (RMASS(IDK(I))**2-RMASS(IDKPRD(1,I))**2)**3*
     &           HBAR/RLTIM(IDK(I))*BRFRAC(I)
            A2MODE(1,N2MODE) = ZSGNSS(L)*ZSGNSS(L1)
C--neutralino to gravitino photon for GMSB
          ELSEIF(IDKPRD(1,I).EQ.458.AND.IDKPRD(2,I).EQ.59) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',112,*999)
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 9
            P2MODE(N2MODE) = ZMIXSS(L1,1)**2/24.0D0
C--neutralino to gravitino Higgs for GMSB
          ELSEIF(IDKPRD(1,I).EQ.458.AND.IH.GE.1.AND.IH.LE.3) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',113,*999)
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 10
            IF(IH.EQ.1) THEN
              P2MODE(N2MODE) = ZMIXSS(L1,3)*SINA-ZMIXSS(L1,4)*COSA
            ELSEIF(IH.EQ.2) THEN
              P2MODE(N2MODE) = ZMIXSS(L1,3)*COSA+ZMIXSS(L1,4)*SINA
            ELSE
              P2MODE(N2MODE) = ZMIXSS(L1,3)*SINB+ZMIXSS(L1,4)*COSB
            ENDIF
            P2MODE(N2MODE) = P2MODE(N2MODE)**2/3.0D0
          ELSE
            CALL HWWARN('HWISP2',1,*999)
          ENDIF
C--two body modes of the positive charginos
        ELSEIF(L1.EQ.5.OR.L1.EQ.6) THEN
          L1 = L1-4
          L  = IDKPRD(1,I)-449
          IH = IDKPRD(2,I)-202
C--first the chargino modes to chargino Higgs
          IF((L.EQ.5.OR.L.EQ.6).AND.IH.GE.1.AND.IH.LE.3) THEN
            L = L-4
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',114,*999)
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 1
            P2MODE(N2MODE) = ONE
            DO 8 J=1,2
 8          A2MODE(J,N2MODE) = HCC(J,IH,L,L1)
C--then the chargino modes to neutralino Higgs
          ELSEIF(L.GE.1.AND.L.LE.4.AND.IH.EQ.4) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',115,*999)
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 1
            P2MODE(N2MODE) = ONE
            DO 9 J=1,2
 9          A2MODE(J,N2MODE) = HNC(J,L,L1)
C--chargino modes to antisfermion fermion
          ELSEIF(IDPDG(IDKPRD(2,I)).GT.0.AND.L.GE.-48.AND.L.LE.-1) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',116,*999)
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 2
            P2MODE(N2MODE) = ONE
            IM = MOD(INT((IDKPRD(1,I)-389)/12)+1,2)+1
            IL = 6*INT((IDKPRD(1,I)-401)/24)+MOD(IDKPRD(1,I)-401,6)+1
            IF(IL.LE.6) P2MODE(N2MODE) = THREE
            DO 10 J=1,2
 10         A2MODE(J,N2MODE) = AFC(J,IL,IM,L1)
C--chargino modes to sfermion antifermion
          ELSEIF(IDPDG(IDKPRD(2,I)).LT.0.AND.L.GE.-48.AND.L.LE.-1) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',117,*999)
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 3
            P2MODE(N2MODE) = ONE
            IM = MOD(INT((IDKPRD(1,I)-389)/12)+1,2)+1
            IL = 6*INT((IDKPRD(1,I)-401)/24)+MOD(IDKPRD(1,I)-401,6)+1
            IF(IL.LE.6) P2MODE(N2MODE) = THREE
            DO 11 J=1,2
 11         A2MODE(J,N2MODE) = AFC(O(J),IL,IM,L1)
C--chargino --> neutralino pi+
          ELSEIF(L.GE.1.AND.L.LE.4.AND.IDKPRD(2,I).EQ.38) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',118,*999)
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 7
            P2MODE(N2MODE) = FPI**2*G**2
            DO 12 J=1,2
 12         A2MODE(J,N2MODE) = OIJ(J,L,L1)
          ENDIF
C--two body modes of the negative charginos
        ELSEIF(L1.EQ.7.OR.L1.EQ.8) THEN
          L1 = L1-6
          L  = IDKPRD(1,I)-449
          IH = IDKPRD(2,I)-202
C--first the chargino modes to chargino Higgs
          IF((L.EQ.7.OR.L.EQ.8).AND.IH.GE.1.AND.IH.LE.3) THEN
            L = L-6
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',119,*999)
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 1
            P2MODE(N2MODE) = ONE
            DO 13 J=1,2
 13         A2MODE(J,N2MODE) = HCC(O(J),IH,L,L1)
C--then the chargino modes to neutralino Higgs
          ELSEIF(L.GE.1.AND.L.LE.4.AND.IH.EQ.5) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',120,*999)
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 1
            P2MODE(N2MODE) = ONE
            DO 14 J=1,2
 14         A2MODE(J,N2MODE) = HNC(O(J),L,L1)
C--chargino to antisfermion fermion
          ELSEIF(IDPDG(IDKPRD(2,I)).GT.0.AND.L.GE.-48.AND.L.LE.-1) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',121,*999)
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 2
            P2MODE(N2MODE) = ONE
            IM = MOD(INT((IDKPRD(1,I)-389)/12)+1,2)+1
            IL = 6*INT((IDKPRD(1,I)-401)/24)+MOD(IDKPRD(1,I)-401,6)+1
            IF(IL.LE.6) P2MODE(N2MODE) = THREE
            DO 15 J=1,2
 15         A2MODE(J,N2MODE) = AFC(J,IL,IM,L1)
C--chargino to sfermion antifermion
          ELSEIF(IDPDG(IDKPRD(2,I)).LT.0.AND.L.GE.-48.AND.L.LE.-1) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',122,*999)
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 3
            P2MODE(N2MODE) = ONE
            IM = MOD(INT((IDKPRD(1,I)-389)/12)+1,2)+1
            IL = 6*INT((IDKPRD(1,I)-401)/24)+MOD(IDKPRD(1,I)-401,6)+1
            IF(IL.LE.6) P2MODE(N2MODE) = THREE
            DO 16 J=1,2
 16         A2MODE(J,N2MODE) = AFC(O(J),IL,IM,L1)
C--chargino --> neutralino pi-
          ELSEIF(L.GE.1.AND.L.LE.4.AND.IDKPRD(2,I).EQ.30) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',123,*999)
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 7
            P2MODE(N2MODE) = FPI**2*G**2
            DO 17 J=1,2
 17         A2MODE(J,N2MODE) =-OIJ(O(J),L,L1)
          ENDIF
        ELSEIF(L1.GE.-48.AND.L1.LT.0) THEN
C--sfermion decay modes
          L = IDKPRD(1,I)-449
C--first sfermion modes to gluinos
          IF(L.EQ.0) THEN
C--first sfermion --> fermion gluino
            IF(IDPDG(IDKPRD(2,I)).GT.0) THEN
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',124,*999)
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              I2DRTP(N2MODE) = 6
              P2MODE(N2MODE) = FOUR/THREE
              IM = MOD(INT((IDK(I)-389)/12)+1,2)+1
              IL = 6*INT((IDK(I)-401)/24)+MOD(IDK(I)-401,6)+1
              DO 18 J=1,2
 18           A2MODE(J,N2MODE) = AFG(J,IL,IM)
C--then antisfermion --> antifermion gluino
            ELSE
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',125,*999)
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              I2DRTP(N2MODE) = 5
              P2MODE(N2MODE) = FOUR/THREE
              IM = MOD(INT((IDK(I)-389)/12)+1,2)+1
              IL = 6*INT((IDK(I)-401)/24)+MOD(IDK(I)-401,6)+1
              DO 19 J=1,2
 19           A2MODE(J,N2MODE) = AFG(O(J),IL,IM)
            ENDIF
C--then sfermion modes to neutralinos
          ELSEIF(L.GE.1.AND.L.LE.4) THEN
C--first sfermion --> fermion neutralino
            IF(IDPDG(IDKPRD(2,I)).GT.0) THEN
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',126,*999)
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              I2DRTP(N2MODE) = 6
              P2MODE(N2MODE) = ONE
              IM = MOD(INT((IDK(I)-389)/12)+1,2)+1
              IL = 6*INT((IDK(I)-401)/24)+MOD(IDK(I)-401,6)+1
              DO 20 J=1,2
 20           A2MODE(J,N2MODE) = AFN(J,IL,IM,L)
C--then antisfermion --> fermion neutralino
            ELSE
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',127,*999)
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              I2DRTP(N2MODE) = 5
              P2MODE(N2MODE) = ONE
              IM = MOD(INT((IDK(I)-389)/12)+1,2)+1
              IL = 6*INT((IDK(I)-401)/24)+MOD(IDK(I)-401,6)+1
              DO 21 J=1,2
 21           A2MODE(J,N2MODE) = AFN(O(J),IL,IM,L)
            ENDIF
C--sfermion modes to charginos
          ELSEIF(L.GE.5.AND.L.LE.8) THEN
            L = MOD(L-5,2)+1
C--first sfermion --> fermion chargino
            IF(IDPDG(IDKPRD(2,I)).GT.0) THEN
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',128,*999)
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              I2DRTP(N2MODE) = 6
              P2MODE(N2MODE) = ONE
              IM = MOD(INT((IDK(I)-389)/12)+1,2)+1
              IL = 6*INT((IDK(I)-401)/24)+MOD(IDK(I)-401,6)+1
              DO 22 J=1,2
 22           A2MODE(J,N2MODE) = AFC(J,IL,IM,L)
C--then antisfermion --> fermion chargino
            ELSE
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',129,*999)
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              I2DRTP(N2MODE) = 5
              P2MODE(N2MODE) = ONE
              IM = MOD(INT((IDK(I)-389)/12)+1,2)+1
              IL = 6*INT((IDK(I)-401)/24)+MOD(IDK(I)-401,6)+1
              DO 23 J=1,2
 23           A2MODE(J,N2MODE) = AFC(O(J),IL,IM,L)
            ENDIF
C--sfermion modes to  fermion gravitino
          ELSEIF(IDKPRD(2,I).EQ.458) THEN
            IF(IDPDG(IDKPRD(1,I)).GT.0) THEN
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',130,*999)
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              I2DRTP(N2MODE) = 11
              P2MODE(N2MODE) = ONE/THREE
              IM = MOD(INT((IDK(I)-389)/12)+1,2)+1
              IL = 6*INT((IDK(I)-401)/24)+MOD(IDK(I)-401,6)+1
              IF(IL.LE.6) THEN
                DO 40 J=1,2
 40             A2MODE(J,N2MODE) = QMIXSS(IL,O(J),IM)
              ELSE
                DO 41 J=1,2
 41             A2MODE(J,N2MODE) = LMIXSS(IL-6,O(J),IM) 
              ENDIF
            ELSE
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',131,*999)
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              I2DRTP(N2MODE) = 12
              P2MODE(N2MODE) = ONE/THREE
              IM = MOD(INT((IDK(I)-389)/12)+1,2)+1
              IL = 6*INT((IDK(I)-401)/24)+MOD(IDK(I)-401,6)+1
              IF(IL.LE.6) THEN
                DO 42 J=1,2
 42             A2MODE(J,N2MODE) = QMIXSS(IL,O(J),IM)
              ELSE
                DO 43 J=1,2
 43             A2MODE(J,N2MODE) = LMIXSS(IL-6,O(J),IM) 
              ENDIF
            ENDIF
C--R-parity violating decay modes
C--LLE modes
          ELSEIF(IDK(I).GE.425.AND.IDK(I).LE.448.AND.
     &           IDKPRD(1,I).GE.121.AND.IDKPRD(1,I).LE.132.AND.
     &           IDKPRD(2,I).GE.121.AND.IDKPRD(2,I).LE.132) THEN
C--charged slepton decays
            IF(MOD(IDK(I),2).EQ.1) THEN
C--right slepton decay
              IF(IDPDG(IDKPRD(1,I))/ABS(IDPDG(IDKPRD(1,I))).EQ.
     &           IDPDG(IDKPRD(2,I))/ABS(IDPDG(IDKPRD(2,I)))) THEN
C--particle decay 
                N2MODE = N2MODE+1
                IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',132,*999)
                NME(I) = 30000+N2MODE
                ID2PRT(N2MODE) = I
                P2MODE(N2MODE) = ONE
                IF(IDPDG(IDK(I)).GT.0) THEN
                  KKK = (IDK(I)-423)/2
                  IF(KKK.GT.3) THEN 
                     KKK = KKK-6
                     IM = 2
                  ELSE
                     IM = 1
                  ENDIF
                  IF(MOD(IDKPRD(1,I),2).EQ.0) THEN
                    III = (IDKPRD(1,I)-120)/2
                    JJJ = (IDKPRD(2,I)-119)/2
                  ELSE
                    III = (IDKPRD(2,I)-120)/2
                    JJJ = (IDKPRD(1,I)-119)/2
                  ENDIF
                  I2DRTP(N2MODE) = 6
                  A2MODE(1,N2MODE) = LMIXSS(2*KKK-1,2,IM)*
     &                 LAMDA1(III,JJJ,KKK)
                  A2MODE(2,N2MODE) = 0.0D0
                ELSE
C--antiparticle decay
                  KKK = (IDK(I)-429)/2
                  IF(KKK.GT.3) THEN
                     KKK = KKK-6
                     IM = 2
                  ELSE
                     IM = 1
                  ENDIF
                  IF(MOD(IDKPRD(1,I),2).EQ.0) THEN
                    III = (IDKPRD(1,I)-126)/2
                    JJJ = (IDKPRD(2,I)-125)/2
                  ELSE
                    III = (IDKPRD(2,I)-126)/2
                    JJJ = (IDKPRD(1,I)-125)/2
                  ENDIF
                  I2DRTP(N2MODE) = 13
                  A2MODE(1,N2MODE) = 0.0D0
                  A2MODE(2,N2MODE) = LMIXSS(2*KKK-1,2,IM)*
     &                 LAMDA1(III,JJJ,KKK)
                ENDIF
C--left slepton decay
              ELSE
                N2MODE = N2MODE+1
                IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',133,*999)
                NME(I) = 30000+N2MODE
                ID2PRT(N2MODE) = I
                P2MODE(N2MODE) = ONE
                IF(IDPDG(IDK(I)).GT.0) THEN
                  JJJ = (IDK(I)-423)/2
                  IF(JJJ.GT.3) THEN
                    JJJ = JJJ-6
                    IM = 2
                  ELSE
                    IM = 1
                  ENDIF
                  IF(MOD(IDKPRD(1,I),2).EQ.0) THEN
                    III = (IDKPRD(1,I)-126)/2
                    KKK = (IDKPRD(2,I)-119)/2
                    I2DRTP(N2MODE) = 8
                  ELSE
                    III = (IDKPRD(2,I)-126)/2
                    KKK = (IDKPRD(1,I)-119)/2
                    I2DRTP(N2MODE) = 5
                  ENDIF
                  A2MODE(1,N2MODE) = 0.0D0
                  A2MODE(2,N2MODE) = LMIXSS(2*JJJ-1,1,IM)*
     &                 LAMDA1(III,JJJ,KKK)
                ELSE
                  JJJ = (IDK(I)-429)/2
                  IF(JJJ.GT.3) THEN
                    JJJ = JJJ-6
                    IM = 2
                  ELSE
                    IM = 1
                  ENDIF
                  IF(MOD(IDKPRD(1,I),2).EQ.0) THEN
                    III = (IDKPRD(1,I)-120)/2
                    KKK = (IDKPRD(2,I)-125)/2
                    I2DRTP(N2MODE) = 5
                  ELSE
                    III = (IDKPRD(2,I)-120)/2
                    KKK = (IDKPRD(1,I)-125)/2
                    I2DRTP(N2MODE) = 8
                  ENDIF
                  A2MODE(1,N2MODE) = LMIXSS(2*JJJ-1,1,IM)*
     &                 LAMDA1(III,JJJ,KKK)
                  A2MODE(2,N2MODE) = 0.0D0
                ENDIF
              ENDIF
C--sneutrino decays
            ELSEIF(MOD(IDK(I),2).EQ.0.AND.IDK(I).LE.436) THEN
C--sneutrino decay
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',134,*999)
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              P2MODE(N2MODE) = ONE
              IF(IDPDG(IDK(I)).GT.0) THEN
                III = (IDK(I)-424)/2
                IF(IDPDG(IDKPRD(1,I)).GT.0) THEN
                  KKK = (IDKPRD(1,I)-119)/2
                  JJJ = (IDKPRD(2,I)-125)/2
                  I2DRTP(N2MODE) = 5
                ELSE
                  JJJ = (IDKPRD(1,I)-125)/2
                  KKK = (IDKPRD(2,I)-119)/2
                  I2DRTP(N2MODE) = 8
                ENDIF
                A2MODE(1,N2MODE) = 0.0D0
                A2MODE(2,N2MODE) = LAMDA1(III,JJJ,KKK)
C--antisneutrino decay
              ELSE
                III = (IDK(I)-430)/2
                IF(IDPDG(IDKPRD(1,I)).LT.0) THEN
                  KKK = (IDKPRD(1,I)-125)/2
                  JJJ = (IDKPRD(2,I)-119)/2
                  I2DRTP(N2MODE) = 8
                ELSE
                  JJJ = (IDKPRD(1,I)-119)/2
                  KKK = (IDKPRD(2,I)-125)/2
                  I2DRTP(N2MODE) = 5
                ENDIF
                A2MODE(1,N2MODE) = LAMDA1(III,JJJ,KKK)
                A2MODE(2,N2MODE) = 0.0D0
              ENDIF
            ENDIF
C--LQD modes
C--squark decays
          ELSEIF(IDK(I).GE.401.AND.IDK(I).LE.424.AND.
     &           IDKPRD(1,I).GE.121.AND.IDKPRD(2,I).LE.132.AND.
     &           IDKPRD(2,I).LE.12) THEN
C--up type squark decay
            IF(MOD(IDK(I),2).EQ.0) THEN
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',135,*999)
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              P2MODE(N2MODE) = ONE
              IF(IDPDG(IDK(I)).GT.0) THEN
                JJJ = (IDK(I)-400)/2
                IF(JJJ.GT.3) THEN
                  JJJ = JJJ-6
                  IM  = 2
                ELSE
                  IM = 1
                ENDIF
                III = (IDKPRD(1,I)-125)/2
                KKK = (IDKPRD(2,I)+1)/2
                I2DRTP(N2MODE) = 8
                A2MODE(1,N2MODE) = ZERO
                A2MODE(2,N2MODE) = QMIXSS(2*JJJ,1,IM)*
     &                             LAMDA2(III,JJJ,KKK)
              ELSE
                JJJ = (IDK(I)-406)/2
                IF(JJJ.GT.3) THEN
                  JJJ = JJJ-6
                  IM  = 2
                ELSE
                  IM = 1
                ENDIF
                III = (IDKPRD(1,I)-119)/2
                KKK = (IDKPRD(2,I)-5)/2
                I2DRTP(N2MODE) = 5
                A2MODE(1,N2MODE) = QMIXSS(2*JJJ,1,IM)*
     &                             LAMDA2(III,JJJ,KKK)
                A2MODE(2,N2MODE) = ZERO
              ENDIF
C--down type squark to lepton up
            ELSEIF(MOD(IDK(I),2).EQ.1.AND.MOD(IDKPRD(1,I),2).EQ.1) THEN
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',136,*999)
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              P2MODE(N2MODE) = ONE
C--particle
              IF(IDPDG(IDK(I)).GT.0) THEN
                KKK = (IDK(I)-399)/2
                IF(KKK.GT.3) THEN
                  KKK = KKK-6
                  IM  = 2
                ELSE
                  IM  = 1
                ENDIF
                III = (IDKPRD(1,I)-119)/2
                JJJ = IDKPRD(2,I)/2
                I2DRTP(N2MODE) = 6
                A2MODE(1,N2MODE) = QMIXSS(2*KKK-1,2,IM)*
     &                             LAMDA2(III,JJJ,KKK)
                A2MODE(2,N2MODE) = ZERO
C--antiparticle
              ELSE
                KKK = (IDK(I)-405)/2
                IF(KKK.GT.3) THEN
                  KKK = KKK-6
                  IM  = 2
                ELSE
                  IM  = 1
                ENDIF
                III = (IDKPRD(1,I)-125)/2
                JJJ = (IDKPRD(2,I)-6)/2
                I2DRTP(N2MODE) = 13
                A2MODE(1,N2MODE) = ZERO
                A2MODE(2,N2MODE) = QMIXSS(2*KKK-1,2,IM)*
     &                             LAMDA2(III,JJJ,KKK)
              ENDIF
C--down (left) squark --> nu d
            ELSEIF(MOD(IDK(I),2).EQ.1.AND.
     &           IDPDG(IDK(I))/ABS(IDPDG(IDK(I))).EQ.
     &          -IDPDG(IDKPRD(1,I))/ABS(IDPDG(IDKPRD(1,I)))) THEN
               
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',137,*999)
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              P2MODE(N2MODE) = ONE
              IF(IDPDG(IDK(I)).GT.0) THEN
                JJJ = (IDK(I)-399)/2
                IF(JJJ.GT.3) THEN
                  JJJ = JJJ-6
                  IM  = 2
                ELSE
                  IM  = 1
                ENDIF
                III = (IDKPRD(1,I)-126)/2
                KKK = (IDKPRD(2,I)+1)/2
                I2DRTP(N2MODE) = 8
                A2MODE(1,N2MODE) = ZERO
                A2MODE(2,N2MODE) = QMIXSS(2*JJJ-1,1,IM)*
     &                             LAMDA2(III,JJJ,KKK)
              ELSE
                JJJ = (IDK(I)-405)/2
                IF(JJJ.GT.3) THEN
                  JJJ = JJJ-6
                  IM = 2
                ELSE
                  IM = 1
                ENDIF
                III = (IDKPRD(1,I)-120)/2
                KKK = (IDKPRD(2,I)-5)/2
                I2DRTP(N2MODE) = 5
                A2MODE(1,N2MODE) = QMIXSS(2*JJJ-1,1,IM)*
     &                             LAMDA2(III,JJJ,KKK)
                A2MODE(2,N2MODE) = ZERO
              ENDIF
C--down (right) squark --> nu d
            ELSEIF(MOD(IDK(I),2).EQ.1.AND.
     &           IDPDG(IDK(I))/ABS(IDPDG(IDK(I))).EQ.
     &           IDPDG(IDKPRD(1,I))/ABS(IDPDG(IDKPRD(1,I)))) THEN
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',138,*999)
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              P2MODE(N2MODE) = ONE
              IF(IDPDG(IDK(I)).GT.0) THEN
                KKK = (IDK(I)-399)/2
                IF(KKK.GT.3) THEN
                  KKK = KKK-6
                  IM  = 2
                ELSE
                  IM  = 1
                ENDIF
                III = (IDKPRD(1,I)-120)/2
                JJJ = (IDKPRD(2,I)+1)/2
                I2DRTP(N2MODE) = 6
                A2MODE(1,N2MODE) = QMIXSS(2*KKK-1,2,IM)*
     &                             LAMDA2(III,JJJ,KKK)
                A2MODE(2,N2MODE) = ZERO
              ELSE
                KKK = (IDK(I)-405)/2
                IF(KKK.GT.3) THEN
                  KKK = KKK-6
                  IM  = 2
                ELSE
                  IM  = 1
                ENDIF
                III = (IDKPRD(1,I)-126)/2
                JJJ = (IDKPRD(2,I)-5)/2
                I2DRTP(N2MODE) = 13
                A2MODE(1,N2MODE) = ZERO
                A2MODE(2,N2MODE) = QMIXSS(2*KKK-1,2,IM)*
     &                             LAMDA2(III,JJJ,KKK)
              ENDIF
            ELSE
              CALL HWWARN('HWISP2',2,*999)
            ENDIF
C--slepton decays
          ELSEIF(IDK(I).GE.425.AND.IDK(I).LE.448.AND.
     &           IDKPRD(1,I).LE.12.AND.IDKPRD(2,I).LE.12) THEN
C--sneutrino decay
            IF(MOD(IDK(I),2).EQ.0) THEN
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',140,*999)
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              P2MODE(N2MODE) = THREE
C--particle 
              IF(IDPDG(IDK(I)).GT.0) THEN
                III = (IDK(I)-424)/2
                JJJ = (IDKPRD(1,I)-5)/2
                KKK = (IDKPRD(2,I)+1)/2
                I2DRTP(N2MODE) = 8
                A2MODE(1,N2MODE) = 0.0D0
                A2MODE(2,N2MODE) = LAMDA2(III,JJJ,KKK)
C--antiparticle
              ELSE
                III = (IDK(I)-430)/2
                JJJ = (IDKPRD(1,I)+1)/2
                KKK = (IDKPRD(2,I)-5)/2
                I2DRTP(N2MODE) = 5
                A2MODE(1,N2MODE) = LAMDA2(III,JJJ,KKK)
                A2MODE(2,N2MODE) = 0.0D0
              ENDIF
C--slepton decay
            ELSEIF(MOD(IDK(I),2).EQ.1) THEN
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',141,*999)
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              P2MODE(N2MODE) = THREE
C--particle
              IF(IDPDG(IDK(I)).GT.0) THEN
                III = (IDK(I)-423)/2
                IF(III.GT.3) THEN
                   III = III -6
                   IM = 2
                ELSE
                   IM = 1
                ENDIF
                JJJ = (IDKPRD(1,I)-6)/2
                KKK = (IDKPRD(2,I)+1)/2
                I2DRTP(N2MODE) = 8
                A2MODE(1,N2MODE) = 0.0D0
                A2MODE(2,N2MODE) = LMIXSS(2*III-1,1,IM)*
     &                             LAMDA2(III,JJJ,KKK)
C--antiparticle
              ELSE
                III = (IDK(I)-429)/2
                IF(III.GT.3) THEN
                   III = III -6
                   IM = 2
                ELSE
                   IM = 1
                ENDIF
                JJJ = IDKPRD(1,I)/2
                KKK = (IDKPRD(2,I)-5)/2
                I2DRTP(N2MODE) = 5
                A2MODE(1,N2MODE) = LMIXSS(2*III-1,1,IM)*
     &                             LAMDA2(III,JJJ,KKK)
                A2MODE(2,N2MODE) = 0.0D0
              ENDIF
            ELSE
              CALL HWWARN('HWISP2',3,*999)
            ENDIF
C--UDD modes
          ELSEIF(IDK(I).GE.401.AND.IDK(I).LE.424.AND.
     &           IDKPRD(1,I).LE.12.AND.IDKPRD(2,I).LE.12) THEN
C--up type squark decay
            IF(MOD(IDK(I),2).EQ.0) THEN
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',143,*999)
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              P2MODE(N2MODE) = 2.0D0
C--squark decay
              IF(IDPDG(IDK(I)).GT.0) THEN
                III = (IDK(I)-400)/2 
                IF(III.GT.3) THEN
                  III = III-6
                  IM = 2
                ELSE
                  IM = 1
                ENDIF
                JJJ = (IDKPRD(1,I)-5)/2
                KKK = (IDKPRD(2,I)-5)/2
                I2DRTP(N2MODE) = 13
                A2MODE(1,N2MODE)=QMIXSS(2*III,2,IM)*LAMDA3(III,JJJ,KKK)
                A2MODE(2,N2MODE)=0.0D0 
C--antisquark decay
              ELSE
                III = (IDK(I)-406)/2 
                IF(III.GT.3) THEN
                  III = III-6
                  IM = 2
                ELSE
                  IM = 1
                ENDIF
                JJJ = (IDKPRD(1,I)+1)/2
                KKK = (IDKPRD(2,I)+1)/2
                I2DRTP(N2MODE) = 6
                A2MODE(1,N2MODE) =0.0D0
                A2MODE(2,N2MODE) =QMIXSS(2*III,2,IM)*LAMDA3(III,JJJ,KKK)
              ENDIF
            ELSE
C--down type squark decay
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',144,*999)
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              P2MODE(N2MODE) = 2.0D0
C--squark decay
              IF(IDPDG(IDK(I)).GT.0) THEN
                JJJ = (IDK(I)-399)/2 
                IF(JJJ.GT.3) THEN
                  JJJ = JJJ-6
                  IM = 2
                ELSE
                  IM = 1
                ENDIF
                III = (IDKPRD(1,I)-6)/2
                KKK = (IDKPRD(2,I)-5)/2
                I2DRTP(N2MODE) = 13
                A2MODE(1,N2MODE)= QMIXSS(2*JJJ-1,2,IM)*
     &                            LAMDA3(III,JJJ,KKK)
                A2MODE(2,N2MODE)= 0.0D0 
C--antisquark decay
              ELSE
                JJJ = (IDK(I)-405)/2 
                IF(JJJ.GT.3) THEN
                  JJJ = JJJ-6
                  IM = 2
                ELSE
                  IM = 1
                ENDIF
                III = IDKPRD(1,I)/2
                KKK = (IDKPRD(2,I)+1)/2
                I2DRTP(N2MODE) = 6
                A2MODE(1,N2MODE) = 0.0D0
                A2MODE(2,N2MODE) = QMIXSS(2*JJJ-1,2,IM)*
     &                             LAMDA3(III,JJJ,KKK)
              ENDIF
            ENDIF
          ELSE
            IF(.NOT.(RSPIN(IDKPRD(1,I)).EQ.ZERO.AND.
     &      RSPIN(IDKPRD(2,I)).EQ.ZERO)) CALL HWWARN('HWISP2',4,*999)
          ENDIF
        ELSEIF(IDK(I).GE.203.AND.IDK(I).LE.207) THEN
          IH = IDK(I)-202
          L  = IDKPRD(1,I)-449
          L1 = IDKPRD(2,I)-449
C--Neutral Higgs decays
          IF(IH.GE.1.AND.IH.LE.3) THEN
C--Higgs to neutralino neutralino
            IF(L.GE.1.AND.L.LE.4) THEN
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',146,*999)
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              I2DRTP(N2MODE) = 6
              P2MODE(N2MODE) = ONE
              IF(L.EQ.L1) P2MODE(N2MODE) = HALF
              DO 24 J=1,2
 24           A2MODE(J,N2MODE) = HNN(J,IH,L,L1)
C--Higgs to chargino chargino
            ELSEIF(L.GE.5.AND.L.LE.8) THEN
              L  = MOD(L -5,2)+1
              L1 = MOD(L1-5,2)+1
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',147,*999)
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              I2DRTP(N2MODE) = 6
              P2MODE(N2MODE) = ONE
              DO 25 J=1,2
              IF(IDPDG(IDKPRD(1,I)).GT.0) THEN
                A2MODE(J,N2MODE) = HCC(  J ,IH,L,L1)
              ELSE
                A2MODE(J,N2MODE) = HCC(O(J),IH,L,L1)
              ENDIF
 25           CONTINUE
C--Higgs to fermion antifermion
            ELSEIF((L.GE.-448.AND.L.LE.-437)
     &         .OR.(L.GE.-328.AND.L.LE.-317)) THEN
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',148,*999)
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              I2DRTP(N2MODE) = 5
              P2MODE(N2MODE) = ONE
              IL = IDKPRD(1,I)
              IL = IL-6*INT((IL-1)/6)+6*INT((IL-1)/120)
              IF(IL.LE.6) P2MODE(N2MODE) = THREE
              DO 26 J=1,2
 26           A2MODE(J,N2MODE) = HFF(J,IH,IL)
            ELSE
              IF(.NOT.
     &       (RSPIN(IDKPRD(1,I)).EQ.ZERO.AND.RSPIN(IDKPRD(2,I)).EQ.ZERO)
     &        .AND..NOT.(IDKPRD(1,I).EQ.13.AND.IDKPRD(2,I).EQ.13)
     &        .AND..NOT.(IDKPRD(1,I).EQ.59.AND.IDKPRD(2,I).EQ.59)
     &        .AND..NOT.(IDKPRD(1,I).GE.198.AND.IDKPRD(1,I).LE.200.AND.
     &                   IDKPRD(2,I).GE.198.AND.IDKPRD(2,I).LE.200))
     &        CALL HWWARN('HWISP2',5,*999)
            ENDIF
C--charged Higgs decays
          ELSE
            IH = IDK(I)-205
            L  = IDKPRD(1,I)-449
            L1 = IDKPRD(2,I)-449
C--positive Higgs decays
            IF(IH.EQ.1) THEN
C--decay to chargino neutralino
              IF(L.EQ.5.OR.L.EQ.6) THEN
                L = L-4
                N2MODE = N2MODE+1
                IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',149,*999)
                NME(I) = 30000+N2MODE
                ID2PRT(N2MODE) = I
                I2DRTP(N2MODE) = 6
                P2MODE(N2MODE) = ONE
                DO 27 J=1,2
 27             A2MODE(J,N2MODE) = HNC(O(J),L1,L)
C--decay to neutralino chargino
              ELSEIF(L.GE.1.AND.L.LE.4) THEN
                L1 = L1-4
                N2MODE = N2MODE+1
                IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',150,*999)
                NME(I) = 30000+N2MODE
                ID2PRT(N2MODE) = I
                I2DRTP(N2MODE) = 6
                P2MODE(N2MODE) = ONE
                DO 28 J=1,2
 28             A2MODE(J,N2MODE) = HNC(O(J),L1,L)
C--fermion antifermion decay modes
              ELSEIF((L.GE.-448.AND.L.LE.-437)
     &               .OR.(L.GE.-328.AND.L.LE.-317)) THEN
                N2MODE = N2MODE+1
                IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',151,*999)
                NME(I) = 30000+N2MODE
                ID2PRT(N2MODE) = I
                I2DRTP(N2MODE) = 5
                P2MODE(N2MODE) = ONE
                IL = IDKPRD(1,I)
                IL = IL-6*INT((IL-1)/6)+6*INT((IL-1)/120)
                IL = INT((IL+1)/2)
                IF(IL.LE.3) P2MODE(N2MODE) = THREE
                DO 29 J=1,2
 29             A2MODE(J,N2MODE) = HFF(J,4,IL)
              ELSE
                IF(RSPIN(IDKPRD(1,I)).NE.ZERO.OR.RSPIN(IDKPRD(2,I)).NE.
     &           ZERO) CALL HWWARN('HWISP2',6,*999)
              ENDIF
C--negative Higgs decays
            ELSE
C--Higgs to chargino neutralino
              IF(L.EQ.7.OR.L.EQ.8) THEN
                L = L-6
                N2MODE = N2MODE+1
                IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',152,*999)
                NME(I) = 30000+N2MODE
                ID2PRT(N2MODE) = I
                I2DRTP(N2MODE) = 6
                P2MODE(N2MODE) = ONE
                DO 30 J=1,2
 30             A2MODE(J,N2MODE) = HNC(J,L1,L)
C--Higgs to neutralino chargino
              ELSEIF(L.GE.1.AND.L.LE.4) THEN
                L1 = L1-6
                N2MODE = N2MODE+1
                IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',153,*999)
                NME(I) = 30000+N2MODE
                ID2PRT(N2MODE) = I
                I2DRTP(N2MODE) = 6
                P2MODE(N2MODE) = ONE
                DO 31 J=1,2
 31             A2MODE(J,N2MODE) = HNC(J,L1,L)
C--fermion antifermion decay modes
              ELSEIF((L.GE.-448.AND.L.LE.-437)
     &               .OR.(L.GE.-328.AND.L.LE.-317)) THEN
                N2MODE = N2MODE+1
                IF(N2MODE.GT.NMODE2) CALL HWWARN('HWISP2',154,*999)
                NME(I) = 30000+N2MODE
                ID2PRT(N2MODE) = I
                I2DRTP(N2MODE) = 8
                P2MODE(N2MODE) = ONE
                IL = IDKPRD(1,I)
                IL = IL-6*INT((IL-1)/6)+6*INT((IL-1)/120)
                IL = INT((IL+1)/2)
                IF(IL.LE.3) P2MODE(N2MODE) = THREE
                DO 32 J=1,2
 32             A2MODE(J,N2MODE) = HFF(O(J),4,IL)
              ELSE
                IF(RSPIN(IDKPRD(1,I)).NE.ZERO.OR.RSPIN(IDKPRD(1,I)).NE.
     &           ZERO) CALL HWWARN('HWISP2',7,*999)
              ENDIF
            ENDIF
          ENDIF
        ENDIF
 1000 CONTINUE
C--now find the maximum weights and compute the decay rates
      DO 2000 I=1,N2MODE
      IF(IPRINT.EQ.2) WRITE(6,5010) RNAME(IDK(ID2PRT(I))),
     &   RNAME(IDKPRD(1,ID2PRT(I))),RNAME(IDKPRD(2,ID2PRT(I)))
 2000 CALL HWD2ME(I)
      RETURN
 5010 FORMAT(/'CALCULATING TWO BODY DECAY ',
     &     A8,' --> ',A8,' ',A8/)
 999  END
CDECK  ID>, HWISP3.
*CMZ :-        -30/09/02  14:05:28  by  Peter Richardson
*-- Author :    Peter Richardson
C-----------------------------------------------------------------------
      SUBROUTINE HWISP3
C-----------------------------------------------------------------------
C     Initialise the top/SUSY three body decay modes
C     gravitino and RPV modes added by Peter Richardson
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      INTEGER I,J,K,L,L1,IL,IQ,IQ1,IQ2,IFR,SIFR,IH,IH1,IM,O(2),II,JJ,
     &     III,JJJ,KKK
      DOUBLE PRECISION SW,CW,TW,E,G,RT,ORT,MW,MZ,GS,AFN(2,12,2,4),
     &     AFG(2,6,2),AFC(2,12,2,2),OIJ(2,4,2),OIJP(2,2,2),OIJPP(2,4,4),
     &     HNN(2,3,4,4),HCC(2,3,2,2),HNC(2,4,2),HFF(2,4,12),HWW(2),
     &     HZZ(2),ZAB(12,2,2),HHB(2,3)
      DOUBLE COMPLEX RHOIN(2,2)
      COMMON /HWSPNC/ SW,CW,TW,E,G,RT,ORT,MW,MZ,GS,AFN,AFG,AFC,OIJ,OIJP,
     &               OIJPP,HNN,HCC,HNC,HFF,HWW,HZZ,ZAB,HHB
      DATA O/2,1/
      IF(IERROR.NE.0) RETURN
C--loop over the decays and find the top decays
      DO 1000 JJ=6,12,6
      DO 1000 II=1,NMODES(JJ)
        IF(II.EQ.1) THEN
          I = LSTRT(JJ)
        ELSE
          I = LNEXT(I)
        ENDIF
C--top decay via W
        IF(IDK(I).EQ.6.AND.NME(I).EQ.100) THEN
          N3MODE = N3MODE+1
          IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',100,*999)
          P3MODE(N3MODE) = ONE
          IF(IDKPRD(1,I).LE.12) P3MODE(N3MODE) = THREE
          SPN3CF(1,1,N3MODE) = ONE
          N3NCFL(N3MODE) = 1
          ID3PRT(N3MODE) = I
          NME(I)         = 10000+N3MODE
          NDI3BY(N3MODE)   = 1
          I3DRTP(1,N3MODE) = 1
          I3DRCF(1,N3MODE) = 1
          I3MODE(1,N3MODE) = 198
          A3MODE(1,1,N3MODE) = ZERO
          A3MODE(2,1,N3MODE) = -G*ORT
          B3MODE(1,1,N3MODE) = ZERO
          B3MODE(2,1,N3MODE) = -G*ORT
C--antitop decay via W
        ELSEIF(IDK(I).EQ.12.AND.NME(I).EQ.100) THEN
          N3MODE = N3MODE+1
          IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',101,*999)
          P3MODE(N3MODE) = ONE
          IF(IDKPRD(1,I).LE.12) P3MODE(N3MODE) = THREE
          SPN3CF(1,1,N3MODE) = ONE
          N3NCFL(N3MODE) = 1
          ID3PRT(N3MODE) = I
          NME(I) = 10000+N3MODE
          NDI3BY(N3MODE)   = 1
          I3DRTP(1,N3MODE) = 5
          I3DRCF(1,N3MODE) = 1
          I3MODE(1,N3MODE) = 199
          A3MODE(1,1,N3MODE) = ZERO
          A3MODE(2,1,N3MODE) = -G*ORT
          B3MODE(1,1,N3MODE) = ZERO
          B3MODE(2,1,N3MODE) = -G*ORT
C--top decay via charged Higgs
        ELSEIF(IDK(I).EQ.6.AND.NME(I).EQ.200) THEN
          N3MODE = N3MODE+1
          IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',102,*999)
          P3MODE(N3MODE) = ONE
          IF(IDKPRD(1,I).LE.12) P3MODE(N3MODE) = THREE
          SPN3CF(1,1,N3MODE) = ONE
          N3NCFL(N3MODE) = 1
          ID3PRT(N3MODE) = I
          NME(I) = 10000+N3MODE
          NDI3BY(N3MODE)   = 1
          I3DRTP(1,N3MODE) = 2
          I3DRCF(1,N3MODE) = 1
          I3MODE(1,N3MODE) = 206
          IL = IDKPRD(1,I)
          IL = IL-6*INT((IL-1)/6)+6*INT((IL-1)/120)
          IL = INT((IL+1)/2)
          DO 201 J=1,2
          A3MODE(J,1,N3MODE) = HFF(O(J),4,3)
 201      B3MODE(J,1,N3MODE) = HFF(  J ,4,IL)
C--antitop decay via charged Higgs 
        ELSEIF(IDK(I).EQ.12.AND.NME(I).EQ.200) THEN
          N3MODE = N3MODE+1
          IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',103,*999)
          P3MODE(N3MODE) = ONE
          IF(IDKPRD(1,I).LE.12) P3MODE(N3MODE) = THREE
          SPN3CF(1,1,N3MODE) = ONE
          N3NCFL(N3MODE) = 1
          ID3PRT(N3MODE) = I
          NME(I) = 10000+N3MODE
          NDI3BY(N3MODE)   = 1
          I3DRTP(1,N3MODE) = 17
          I3DRCF(1,N3MODE) = 1
          I3MODE(1,N3MODE) = 207
          IL = IDKPRD(1,I)
          IL = IL-6*INT((IL-1)/6)+6*INT((IL-1)/120)
          IL = INT((IL+1)/2)
          DO 202 J=1,2
          A3MODE(J,1,N3MODE) = HFF(  J ,4,3) 
 202      B3MODE(J,1,N3MODE) = HFF(O(J),4,IL)
        ENDIF
 1000 CONTINUE
      IF(.NOT.SUSYIN) GOTO 2999
C--loop over all the SUSY decay modes and find the ones we want
C--first the true three body gaugino decays
      DO 2000 JJ=1,NRES
      DO 2000 II=1,NMODES(JJ)
        IF(II.EQ.1) THEN
          I = LSTRT(JJ)
        ELSE
          I = LNEXT(I)
        ENDIF
        L = IDKPRD(1,I)-449
        IF(IDKPRD(3,I).EQ.0.OR.IDKPRD(4,I).NE.0) GOTO 2500
C--gluino modes first
        IF(IDK(I).EQ.449) THEN
C--first the gluino modes to quark-antiquark neutralino
          IF(L.GE.1.AND.L.LE.4.AND.(IDKPRD(2,I).LE.12.OR.
     &       (IDKPRD(2,I).GE.121.AND.IDKPRD(2,I).LE.132))) THEN
            IQ = IDKPRD(2,I)
            IF(IQ.GT.6) IQ=IQ-6
            IF(IQ.GT.6.OR.IQ.LT.1) CALL HWWARN('HWISP3',200,*2000)
            N3MODE = N3MODE+1
            IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',104,*999)
            P3MODE(N3MODE) = HALF
            SPN3CF(1,1,N3MODE) = ONE
            N3NCFL(N3MODE) = 1
            ID3PRT(N3MODE) = I
            NME(I) = 10000+N3MODE
            NDI3BY(N3MODE)   = 4
C--only squark exchange diagrams
            DO 1 K=1,2
            I3DRTP(K  ,N3MODE) = 3
            I3DRCF(K  ,N3MODE) = 1
            I3DRTP(K+2,N3MODE) = 4
            I3DRCF(K+2,N3MODE) = 1
            I3MODE(K  ,N3MODE) = 12*(K-1)+400+IQ
            I3MODE(K+2,N3MODE) = 12*(K-1)+406+IQ
            DO 1 J=1,2
            A3MODE(J,K  ,N3MODE) = AFG(  J ,IQ,K)
            B3MODE(J,K  ,N3MODE) = AFN(O(J),IQ,K,L)
            A3MODE(J,K+2,N3MODE) = AFG(O(J),IQ,K)
 1          B3MODE(J,K+2,N3MODE) = ZSGNSS(L)*AFN(  J ,IQ,K,L)
C--then the gluino modes to quark-antiquark +ve chargino
          ELSEIF(L.EQ.5.OR.L.EQ.6.AND.(IDKPRD(2,I).LE.12.OR.
     &       (IDKPRD(2,I).GE.121.AND.IDKPRD(2,I).LE.132))) THEN
            L = L-4
            IQ = IDKPRD(2,I)
            IF(IQ.GT.6) IQ=IQ-6
            IF(IQ.GT.6.OR.IQ.LT.1) CALL HWWARN('HWISP3',201,*2000)
            IQ = (IQ+MOD(IQ,2))/2
            IQ1 = 2*IQ-1
            IQ2 = 2*IQ
            N3MODE = N3MODE+1
            IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',105,*999)
            P3MODE(N3MODE) = HALF
            SPN3CF(1,1,N3MODE) = ONE
            N3NCFL(N3MODE) = 1
            ID3PRT(N3MODE) = I
            NME(I) = 10000+N3MODE
            NDI3BY(N3MODE)   = 4
C--only squark exchange diagrams
            DO 2 K=1,2
            I3DRTP(K  ,N3MODE) = 3
            I3DRCF(K  ,N3MODE) = 1
            I3DRTP(K+2,N3MODE) = 4
            I3DRCF(K+2,N3MODE) = 1
            I3MODE(K  ,N3MODE) = 12*(K-1)+400+IQ1
            I3MODE(K+2,N3MODE) = 12*(K-1)+406+IQ2
            DO 2 J=1,2
            A3MODE(J,K  ,N3MODE) = AFG(  J ,IQ1,K)
            B3MODE(J,K  ,N3MODE) = AFC(O(J),IQ1,K,L)
            A3MODE(J,K+2,N3MODE) = AFG(O(J),IQ2,K)
 2          B3MODE(J,K+2,N3MODE) = AFC(  J ,IQ2,K,L)
C--then the gluino modes to quark-antiquark -ve chargino
          ELSEIF(L.EQ.7.OR.L.EQ.8.AND.(IDKPRD(2,I).LE.12.OR.
     &       (IDKPRD(2,I).GE.121.AND.IDKPRD(2,I).LE.132))) THEN
            L = L-6
            IQ = IDKPRD(2,I)
            IF(IQ.GT.6) IQ=IQ-6
            IF(IQ.GT.6.OR.IQ.LT.1) CALL HWWARN('HWISP3',202,*2000)
            IQ = (IQ+MOD(IQ,2))/2
            IQ1 = 2*IQ
            IQ2 = 2*IQ-1
            N3MODE = N3MODE+1
            IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',106,*999)
            P3MODE(N3MODE) = HALF
            SPN3CF(1,1,N3MODE) = ONE
            N3NCFL(N3MODE) = 1
            ID3PRT(N3MODE) = I
            NME(I) = 10000+N3MODE
            NDI3BY(N3MODE)   = 4
C--only squark exchange diagrams
            DO 3 K=1,2
            I3DRTP(K  ,N3MODE) = 3
            I3DRCF(K  ,N3MODE) = 1
            I3DRTP(K+2,N3MODE) = 4
            I3DRCF(K+2,N3MODE) = 1
            I3MODE(K  ,N3MODE) = 12*(K-1)+400+IQ1
            I3MODE(K+2,N3MODE) = 12*(K-1)+406+IQ2
            DO 3 J=1,2
            A3MODE(J,K  ,N3MODE) = AFG(  J ,IQ1,K)
            B3MODE(J,K  ,N3MODE) = AFC(O(J),IQ1,K,L)
            A3MODE(J,K+2,N3MODE) = AFG(O(J),IQ2,K)
 3          B3MODE(J,K+2,N3MODE) = AFC(  J ,IQ2,K,L)
C--RPV decay modes
C--LQD first
          ELSEIF(IDKPRD(1,I).GE.121.AND.IDKPRD(1,I).LE.132.AND.
     &           IDKPRD(2,I).LE.12 .AND.IDKPRD(3,I).LE.12) THEN
            N3MODE = N3MODE+1
            IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',107,*999)
            ID3PRT(N3MODE) = I
            NME(I) = 10000+N3MODE
            P3MODE(N3MODE) = HALF
            SPN3CF(1,1,N3MODE) = ONE
            N3NCFL(N3MODE) = 1
            NDI3BY(N3MODE) = 4
            DO 98 J=1,4
 98         I3DRCF(J,N3MODE) = 1
C--first the neutrino mode
            IF(MOD(IDKPRD(1,I),2).EQ.0) THEN
C--particle mode
              IF(IDPDG(IDKPRD(1,I)).GT.0) THEN
                III = (IDKPRD(1,I)-120)/2
                JJJ = (IDKPRD(2,I)+1)/2
                KKK = (IDKPRD(3,I)-5)/2
                DO 99 K=1,2
                I3DRTP(K  ,N3MODE) = 3
                I3DRTP(K+2,N3MODE) = 4
                I3MODE(K  ,N3MODE) = 399+2*JJJ+(K-1)*12
                I3MODE(K+2,N3MODE) = 399+2*KKK+(K-1)*12
                B3MODE(2,K  ,N3MODE) = 0.0D0
                B3MODE(1,K  ,N3MODE) = -QMIXSS(2*JJJ-1,1,K)*
     &                                 LAMDA2(III,JJJ,KKK)
                B3MODE(2,K+2,N3MODE) = 0.0D0
                B3MODE(1,K+2,N3MODE) = -QMIXSS(2*KKK-1,2,K)*
     &                                 LAMDA2(III,JJJ,KKK)
                DO 99 J=1,2
                A3MODE(J,K  ,N3MODE) = AFG(  J ,2*JJJ-1,K)
 99             A3MODE(J,K+2,N3MODE) = AFG(O(J),2*KKK-1,K)
C--antiparticle mode
              ELSE
                III = (IDKPRD(1,I)-126)/2
                JJJ = (IDKPRD(2,I)-5)/2
                KKK = (IDKPRD(3,I)+1)/2
                DO 101 K=1,2
                I3DRTP(K  ,N3MODE) = 9
                I3DRTP(K+2,N3MODE) = 10
                I3MODE(K  ,N3MODE) = 399+2*JJJ+(K-1)*12
                I3MODE(K+2,N3MODE) = 399+2*KKK+(K-1)*12
                B3MODE(1,K  ,N3MODE) = 0.0D0
                B3MODE(2,K  ,N3MODE) = -QMIXSS(2*JJJ-1,1,K)*
     &                                 LAMDA2(III,JJJ,KKK)
                B3MODE(1,K+2,N3MODE) = 0.0D0
                B3MODE(2,K+2,N3MODE) = -QMIXSS(2*KKK-1,2,K)*
     &                                 LAMDA2(III,JJJ,KKK)
                DO 101 J=1,2
                A3MODE(J,K  ,N3MODE) = AFG(O(J),2*JJJ-1,K)
 101            A3MODE(J,K+2,N3MODE) = AFG(  J ,2*KKK-1,K)
              ENDIF
C--then the charged lepton mode
            ELSE
C--particle mode
              IF(IDPDG(IDKPRD(1,I)).GT.0) THEN
                III = (IDKPRD(1,I)-119)/2
                JJJ = IDKPRD(2,I)/2
                KKK = (IDKPRD(3,I)-5)/2
                DO 102 K=1,2
                I3DRTP(K  ,N3MODE) = 3
                I3DRTP(K+2,N3MODE) = 4
                I3MODE(K  ,N3MODE) = 400+2*JJJ+(K-1)*12
                I3MODE(K+2,N3MODE) = 399+2*KKK+(K-1)*12
                B3MODE(2,K  ,N3MODE) = 0.0D0
                B3MODE(1,K  ,N3MODE) = QMIXSS(2*JJJ,1,K)*
     &                                 LAMDA2(III,JJJ,KKK)
                B3MODE(2,K+2,N3MODE) = 0.0D0
                B3MODE(1,K+2,N3MODE) = QMIXSS(2*KKK-1,2,K)*
     &                                 LAMDA2(III,JJJ,KKK)
                DO 102 J=1,2
                A3MODE(J,K  ,N3MODE) = AFG(  J ,2*JJJ  ,K)
 102            A3MODE(J,K+2,N3MODE) = AFG(O(J),2*KKK-1,K)
C--antiparticle mode
              ELSE
                III = (IDKPRD(1,I)-125)/2
                JJJ = (IDKPRD(2,I)-6)/2
                KKK = (IDKPRD(3,I)+1)/2
                DO 103 K=1,2
                I3DRTP(K  ,N3MODE) = 9
                I3DRTP(K+2,N3MODE) = 10
                I3MODE(K  ,N3MODE) = 400+2*JJJ+(K-1)*12
                I3MODE(K+2,N3MODE) = 399+2*KKK+(K-1)*12
                B3MODE(1,K  ,N3MODE) = 0.0D0
                B3MODE(2,K  ,N3MODE) = QMIXSS(2*JJJ,1,K)*
     &                                 LAMDA2(III,JJJ,KKK)
                B3MODE(1,K+2,N3MODE) = 0.0D0
                B3MODE(2,K+2,N3MODE) = QMIXSS(2*KKK-1,2,K)*
     &                                 LAMDA2(III,JJJ,KKK)
                DO 103 J=1,2
                A3MODE(J,K  ,N3MODE) = AFG(O(J),2*JJJ  ,K)
 103            A3MODE(J,K+2,N3MODE) = AFG(  J ,2*KKK-1,K)
              ENDIF
            ENDIF
C--then UDD
          ELSEIF(IDKPRD(1,I).LE.12.AND.IDKPRD(2,I).LE.12.AND.
     &           IDKPRD(3,I).LE.12) THEN
            N3MODE = N3MODE+1
            IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',108,*999)
            P3MODE(N3MODE) = ONE
            N3NCFL(N3MODE) = 3
            ID3PRT(N3MODE) = I
            NME(I) = 10000+N3MODE
            NDI3BY(N3MODE)   = 6
            DO 70 J=1,3
            DO 70 K=1,3
              IF(J.NE.K) THEN
                SPN3CF(J,K,N3MODE) = -HALF
              ELSE
                SPN3CF(J,K,N3MODE) =  ONE
              ENDIF
 70         CONTINUE
C--particle mode
            IF(IDKPRD(1,I).LE.6) THEN
C--antiparticle mode
              III =  IDKPRD(1,I)/2
              JJJ = (IDKPRD(2,I)+1)/2
              KKK = (IDKPRD(3,I)+1)/2
              DO 71 K=1,2
              I3DRTP(K  ,N3MODE) = 11
              I3DRCF(K  ,N3MODE) = 1
              I3DRTP(K+2,N3MODE) = 12
              I3DRCF(K+2,N3MODE) = 2
              I3DRTP(K+4,N3MODE) = 13
              I3DRCF(K+4,N3MODE) = 3
              I3MODE(K  ,N3MODE) = 400+2*III+(K-1)*12
              I3MODE(K+2,N3MODE) = 399+2*JJJ+(K-1)*12
              I3MODE(K+4,N3MODE) = 399+2*KKK+(K-1)*12
              B3MODE(2,K  ,N3MODE) = QMIXSS(2*III,2,K)*
     &                               LAMDA3(III,JJJ,KKK)
              B3MODE(2,K+2,N3MODE) = QMIXSS(2*JJJ-1,2,K)*
     &                               LAMDA3(III,JJJ,KKK)
              B3MODE(2,K+4,N3MODE) = QMIXSS(2*KKK-1,2,K)*
     &                               LAMDA3(III,JJJ,KKK)
              B3MODE(1,K  ,N3MODE) = 0.0D0
              B3MODE(1,K+2,N3MODE) = 0.0D0
              B3MODE(1,K+4,N3MODE) = 0.0D0
              DO 71 J=1,2
              A3MODE(J,K  ,N3MODE) = AFG(J,2*III  ,K) 
              A3MODE(J,K+2,N3MODE) = AFG(J,2*JJJ-1,K)
 71           A3MODE(J,K+4,N3MODE) = AFG(J,2*KKK-1,K)
            ELSE
              III = (IDKPRD(1,I)-6)/2
              JJJ = (IDKPRD(2,I)-5)/2
              KKK = (IDKPRD(3,I)-5)/2
              DO 72 K=1,2
              I3DRTP(K  ,N3MODE) = 14
              I3DRCF(K  ,N3MODE) = 1
              I3DRTP(K+2,N3MODE) = 15
              I3DRCF(K+2,N3MODE) = 2
              I3DRTP(K+4,N3MODE) = 16
              I3DRCF(K+4,N3MODE) = 3
              I3MODE(K  ,N3MODE) = 400+2*III+(K-1)*12
              I3MODE(K+2,N3MODE) = 399+2*JJJ+(K-1)*12
              I3MODE(K+4,N3MODE) = 399+2*KKK+(K-1)*12
              B3MODE(1,K  ,N3MODE) = QMIXSS(2*III,2,K)*
     &                               LAMDA3(III,JJJ,KKK)
              B3MODE(1,K+2,N3MODE) = QMIXSS(2*JJJ-1,2,K)*
     &                               LAMDA3(III,JJJ,KKK)
              B3MODE(1,K+4,N3MODE) = QMIXSS(2*KKK-1,2,K)*
     &                               LAMDA3(III,JJJ,KKK)
              B3MODE(2,K  ,N3MODE) = 0.0D0
              B3MODE(2,K+2,N3MODE) = 0.0D0
              B3MODE(2,K+4,N3MODE) = 0.0D0
              DO 72 J=1,2
              A3MODE(J,K  ,N3MODE) = AFG(O(J),2*III  ,K) 
              A3MODE(J,K+2,N3MODE) = AFG(O(J),2*JJJ-1,K)
 72           A3MODE(J,K+4,N3MODE) = AFG(O(J),2*KKK-1,K)
            ENDIF
C--unrecognized decay issue warning
          ELSE
            CALL HWWARN('HWISP3',1,*2000)
          ENDIF
        ELSEIF(IDK(I).GE.450.AND.IDK(I).LE.453) THEN
          L1 = IDK(I)-449
C--neutralino modes next
          IF(L.GE.1.AND.L.LE.4.AND.(IDKPRD(2,I).LE.12.OR.
     &       (IDKPRD(2,I).GE.121.AND.IDKPRD(2,I).LE.132))) THEN
C--first the neutralino modes to fermion-antifermion neutralino
            IFR  = IDKPRD(2,I)
            J    = INT((IFR-1)/120)
            IFR  = IFR-6*INT((IFR-1)/6)+6*J
            IL   = IFR+4*J
            SIFR = IFR+18*J
            N3MODE = N3MODE+1
            IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',109,*999)
            P3MODE(N3MODE) = ONE
            IF(IFR.LE.6) P3MODE(N3MODE)=THREE
            SPN3CF(1,1,N3MODE) = ONE
            N3NCFL(N3MODE) = 1
            ID3PRT(N3MODE) = I
            NME(I) = 10000+N3MODE
            NDI3BY(N3MODE) = 4
C--sfermion exchange diagrams
            DO 4 K=1,2
            I3DRTP(K  ,N3MODE) = 3
            I3DRCF(K  ,N3MODE) = 1
            I3DRTP(K+2,N3MODE) = 4
            I3DRCF(K+2,N3MODE) = 1
            I3MODE(K  ,N3MODE) = 12*(K-1)+400+SIFR
            I3MODE(K+2,N3MODE) = 12*(K-1)+406+SIFR
            DO 4 J=1,2
            A3MODE(J,K  ,N3MODE) = AFN(  J ,IFR,K,L1)
            B3MODE(J,K  ,N3MODE) = AFN(O(J),IFR,K,L )
            A3MODE(J,K+2,N3MODE) = ZSGNSS(L1)*AFN(O(J),IFR,K,L1)
 4          B3MODE(J,K+2,N3MODE) = ZSGNSS(L )*AFN(  J ,IFR,K,L )
C--now add higgs diagrams if third generation fermion, if Higgs off shell
            IF(IFR.EQ.5.OR.IFR.EQ.6.OR.IFR.EQ.11) THEN
              DO 5 J=1,3
                IF(RMASS(IDK(I)).LT.
     &                RMASS(203+J)+RMASS(IDKPRD(1,I))) THEN
                  NDI3BY(N3MODE) = NDI3BY(N3MODE)+1
                  I3DRTP(  NDI3BY(N3MODE),N3MODE) = 2
                  I3DRCF(  NDI3BY(N3MODE),N3MODE) = 1
                  I3MODE(  NDI3BY(N3MODE),N3MODE) = 203+J
                  DO 6 K=1,2
                  A3MODE(K,NDI3BY(N3MODE),N3MODE) = HNN(K,J,L,L1)
 6                B3MODE(K,NDI3BY(N3MODE),N3MODE) = HFF(K,J,IFR)
                ENDIF
 5            CONTINUE
            ENDIF
C-- and gauge boson diagrams if Z not on-shell
            IF(RMASS(IDK(I)).LT.MZ+RMASS(IDKPRD(1,I))) THEN
              NDI3BY(N3MODE) = NDI3BY(N3MODE)+1
              I3DRTP(NDI3BY(N3MODE),N3MODE) = 1
              I3DRCF(NDI3BY(N3MODE),N3MODE) = 1
              I3MODE(NDI3BY(N3MODE),N3MODE) = 200
              DO 7 J=1,2
 7            A3MODE(J,NDI3BY(N3MODE),N3MODE) =  OIJPP(J,L,L1)
              B3MODE(1,NDI3BY(N3MODE),N3MODE) = -E*RFCH(IL)
              B3MODE(2,NDI3BY(N3MODE),N3MODE) = -E*LFCH(IL)
            ENDIF
          ELSEIF(L.EQ.5.OR.L.EQ.6.AND.(IDKPRD(2,I).LE.12.OR.
     &       (IDKPRD(2,I).GE.121.AND.IDKPRD(2,I).LE.132))) THEN
C--then  the neutralino modes to fermion-antifermion +ve chargino
C--NB ISAJET ONLY HAS W EXCHANGE AND THEREFORE SO DO WE
            IF(RMASS(IDK(I)).GT.MW+RMASS(IDKPRD(1,I))) GOTO 2000
            L = L-4
            N3MODE = N3MODE+1
            IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',110,*999)
            ID3PRT(N3MODE) = I
            NME(I) = 10000+N3MODE
            NDI3BY(N3MODE) = 1
            P3MODE(N3MODE) = ONE
            IF(IDKPRD(2,I).LE.12) P3MODE(N3MODE) = THREE
            SPN3CF(1,1,N3MODE) = ONE
            N3NCFL(N3MODE) = 1
C--gauge boson diagram
            I3DRTP(1,N3MODE) = 1
            I3DRCF(1,N3MODE) = 1
            I3MODE(1,N3MODE) = 199
            DO 8 J=1,2
 8          A3MODE(J,1,N3MODE) = OIJ(J,L1,L)
            B3MODE(1,1,N3MODE) = ZERO
            B3MODE(2,1,N3MODE) = -G*ORT
          ELSEIF(L.EQ.7.OR.L.EQ.8.AND.(IDKPRD(2,I).LE.12.OR.
     &       (IDKPRD(2,I).GE.121.AND.IDKPRD(2,I).LE.132))) THEN
C--then  the neutralino modes to fermion-antifermion -ve chargino
C--NB ISAJET ONLY HAS W EXCHANGE AND THEREFORE SO DO WE
            IF(RMASS(IDK(I)).GT.MW+RMASS(IDKPRD(1,I))) GOTO 2000
            L = L-6
            N3MODE = N3MODE+1
            IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',111,*999)
            ID3PRT(N3MODE) = I
            NME(I) = 10000+N3MODE
            NDI3BY(N3MODE) = 1
            P3MODE(N3MODE) = ONE
            IF(IDKPRD(2,I).LE.12) P3MODE(N3MODE) = THREE
            SPN3CF(1,1,N3MODE) = ONE
            N3NCFL(N3MODE) = 1
C--gauge boson diagram
            I3DRTP(1,N3MODE) = 1
            I3DRCF(1,N3MODE) = 1
            I3MODE(1,N3MODE) = 198
            DO 9 J=1,2
 9          A3MODE(J,1,N3MODE) =-OIJ(O(J),L1,L)
            B3MODE(1,1,N3MODE) = ZERO
            B3MODE(2,1,N3MODE) = -G*ORT
C--gravitino E+e- modes
          ELSEIF(L.EQ.9.AND.(IDKPRD(2,I).LE.12.OR.
     &       (IDKPRD(2,I).GE.121.AND.IDKPRD(2,I).LE.132))) THEN
            IFR  = IDKPRD(2,I)
            J    = INT((IFR-1)/120)
            IFR  = IFR-6*INT((IFR-1)/6)+6*J
            IL   = IFR+4*J
            N3MODE = N3MODE+1
            IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',112,*999)
            ID3PRT(N3MODE) = I
            NME(I) = 10000+N3MODE
            NDI3BY(N3MODE) = 1
            P3MODE(N3MODE) = ONE
            IF(IDKPRD(2,I).LE.12) P3MODE(N3MODE) = THREE
            SPN3CF(1,1,N3MODE) = ONE
            N3NCFL(N3MODE) = 1
C--diagram
            I3DRTP(1,N3MODE) = 7
            I3DRCF(1,N3MODE) = 1
            I3MODE(1,N3MODE) = 59
            A3MODE(1,1,N3MODE) = 2.0D0/SQRT(6.0D0)*ZMIXSS(L1,1)
            A3MODE(2,1,N3MODE) = 0
            B3MODE(1,1,N3MODE) = -E*QFCH(IL)
            B3MODE(2,1,N3MODE) = -E*QFCH(IL)
C--R-parity violating modes
C--LLE modes
          ELSEIF(IDKPRD(1,I).GE.121.AND.IDKPRD(1,I).LE.132.AND.
     &           IDKPRD(2,I).GE.121.AND.IDKPRD(2,I).LE.132.AND.
     &           IDKPRD(3,I).GE.121.AND.IDKPRD(3,I).LE.132) THEN
            N3MODE = N3MODE+1
            IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',113,*999)
            ID3PRT(N3MODE) = I
            NME(I) = 10000+N3MODE
            NDI3BY(N3MODE) = 5
            P3MODE(N3MODE) = ONE
            SPN3CF(1,1,N3MODE) = ONE
            N3NCFL(N3MODE) = 1
C--particle mode
            DO 53 J=1,6
 53         I3DRCF(J,N3MODE) = 1
            IF(IDPDG(IDKPRD(1,I)).GT.0) THEN
              III = (IDKPRD(1,I)-119)/2
              JJJ = (IDKPRD(2,I)-120)/2
              KKK = (IDKPRD(3,I)-125)/2
              DO 51 J=1,2
              I3DRTP(J  ,N3MODE) = 2
              I3DRTP(J+2,N3MODE) = 4
              I3MODE(J  ,N3MODE) = 423+2*III+(J-1)*12
              I3MODE(J+2,N3MODE) = 423+2*KKK+(J-1)*12
              B3MODE(1,J  ,N3MODE) = LMIXSS(2*III-1,1,J)*
     &             LAMDA1(III,JJJ,KKK)
              B3MODE(2,J  ,N3MODE) = 0.0D0
              B3MODE(1,J+2,N3MODE) = LMIXSS(2*KKK-1,2,J)*
     &             LAMDA1(III,JJJ,KKK)
              B3MODE(2,J+2,N3MODE) = 0.0D0
              DO 51 K=1,2
              A3MODE(K,J  ,N3MODE) = AFN(  K ,5+2*III,J,L1)
 51           A3MODE(K,J+2,N3MODE) = AFN(O(K),5+2*KKK,J,L1)
              DO 48 K=1,2
 48           A3MODE(K,5,N3MODE) = AFN(  K ,6+2*JJJ,1,L1)
              I3DRTP(5,N3MODE) = 3
              I3MODE(5,N3MODE) = 430+2*JJJ
              B3MODE(1,5,N3MODE) = LAMDA1(III,JJJ,KKK)
              B3MODE(2,5,N3MODE) = 0.0D0
C--antiparticle mode
            ELSE
              III = (IDKPRD(1,I)-125)/2
              JJJ = (IDKPRD(2,I)-126)/2
              KKK = (IDKPRD(3,I)-119)/2
              DO 52 J=1,2
              I3DRTP(J  ,N3MODE) = 8
              I3DRTP(J+2,N3MODE) = 10
              I3MODE(J  ,N3MODE) = 423+2*III+(J-1)*12
              I3MODE(J+2,N3MODE) = 423+2*KKK+(J-1)*12
              B3MODE(2,J  ,N3MODE) = LMIXSS(2*III-1,1,J)*
     &             LAMDA1(III,JJJ,KKK)
              B3MODE(1,J  ,N3MODE) = 0.0D0
              B3MODE(2,J+2,N3MODE) = LMIXSS(2*KKK-1,2,J)*
     &             LAMDA1(III,JJJ,KKK)
              B3MODE(1,J+2,N3MODE) = 0.0D0
              DO 52 K=1,2
              A3MODE(K,J  ,N3MODE) = AFN(O(K),5+2*III,J,L1)
 52           A3MODE(K,J+2,N3MODE) = AFN(  K ,5+2*KKK,J,L1)
              DO 49 K=1,2
 49           A3MODE(K,5,N3MODE) = AFN(O(K),6+2*JJJ,1,L1)
              I3DRTP(5,N3MODE) = 9
              I3MODE(5,N3MODE) = 430+2*JJJ
              B3MODE(2,5,N3MODE) = LAMDA1(III,JJJ,KKK)
              B3MODE(1,5,N3MODE) = 0.0D0
            ENDIF
C--LQD modes
          ELSEIF(IDKPRD(1,I).GE.121.AND.IDKPRD(1,I).LE.132.AND.
     &           IDKPRD(2,I).LE.12 .AND.IDKPRD(3,I).LE.12) THEN
            N3MODE = N3MODE+1
            IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',114,*999)
            ID3PRT(N3MODE) = I
            NME(I) = 10000+N3MODE
            P3MODE(N3MODE) = 3.0D0
            SPN3CF(1,1,N3MODE) = ONE
            N3NCFL(N3MODE) = 1
            DO 81 J=1,6
 81         I3DRCF(J,N3MODE) = 1
C--first the neutrino mode
            IF(MOD(IDKPRD(1,I),2).EQ.0) THEN
              NDI3BY(N3MODE) = 5
C--particle mode
              IF(IDPDG(IDKPRD(1,I)).GT.0) THEN
                III = (IDKPRD(1,I)-120)/2
                JJJ = (IDKPRD(2,I)+1)/2
                KKK = (IDKPRD(3,I)-5)/2
                DO 82 K=1,2
                I3DRTP(K  ,N3MODE) = 3
                I3DRTP(K+2,N3MODE) = 4
                I3MODE(K  ,N3MODE) = 399+2*JJJ+(K-1)*12
                I3MODE(K+2,N3MODE) = 399+2*KKK+(K-1)*12
                B3MODE(2,K  ,N3MODE) = 0.0D0
                B3MODE(1,K  ,N3MODE) = -QMIXSS(2*JJJ-1,1,K)*
     &                                 LAMDA2(III,JJJ,KKK)
                B3MODE(2,K+2,N3MODE) = 0.0D0
                B3MODE(1,K+2,N3MODE) = -QMIXSS(2*KKK-1,2,K)*
     &                                 LAMDA2(III,JJJ,KKK)
                DO 82 J=1,2
                A3MODE(J,K  ,N3MODE) = AFN(  J ,2*JJJ-1,K,L1)
 82             A3MODE(J,K+2,N3MODE) = AFN(O(J),2*KKK-1,K,L1)
                I3DRTP(5,N3MODE) = 2
                I3MODE(5,N3MODE) = 424+2*III
                B3MODE(2,5,N3MODE) = 0.0D0
                B3MODE(1,5,N3MODE) = -LAMDA2(III,JJJ,KKK)
                DO 83 J=1,2
 83             A3MODE(J,5,N3MODE) = AFN(J,6+2*III,1,L1)
C--antiparticle mode
              ELSE
                III = (IDKPRD(1,I)-126)/2
                JJJ = (IDKPRD(2,I)-5)/2
                KKK = (IDKPRD(3,I)+1)/2
                DO 84 K=1,2
                I3DRTP(K  ,N3MODE) = 9
                I3DRTP(K+2,N3MODE) = 10
                I3MODE(K  ,N3MODE) = 399+2*JJJ+(K-1)*12
                I3MODE(K+2,N3MODE) = 399+2*KKK+(K-1)*12
                B3MODE(1,K  ,N3MODE) = 0.0D0
                B3MODE(2,K  ,N3MODE) = -QMIXSS(2*JJJ-1,1,K)*
     &                                 LAMDA2(III,JJJ,KKK)
                B3MODE(1,K+2,N3MODE) = 0.0D0
                B3MODE(2,K+2,N3MODE) = -QMIXSS(2*KKK-1,2,K)*
     &                                 LAMDA2(III,JJJ,KKK)
                DO 84 J=1,2
                A3MODE(J,K  ,N3MODE) = AFN(O(J),2*JJJ-1,K,L1)
 84             A3MODE(J,K+2,N3MODE) = AFN(  J ,2*KKK-1,K,L1)
                I3DRTP(5,N3MODE) = 8
                I3MODE(5,N3MODE) = 424+2*III
                B3MODE(1,5,N3MODE) = 0.0D0
                B3MODE(2,5,N3MODE) = -LAMDA2(III,JJJ,KKK)
                DO 85 J=1,2
 85             A3MODE(J,5,N3MODE) = AFN(O(J),6+2*III,1,L1)
              ENDIF
C--then the charged lepton mode
            ELSE
              NDI3BY(N3MODE) = 6
C--particle mode
              IF(IDPDG(IDKPRD(1,I)).GT.0) THEN
                III = (IDKPRD(1,I)-119)/2
                JJJ = IDKPRD(2,I)/2
                KKK = (IDKPRD(3,I)-5)/2
                DO 86 K=1,2
                I3DRTP(K  ,N3MODE) = 2
                I3DRTP(K+2,N3MODE) = 3
                I3DRTP(K+4,N3MODE) = 4
                I3MODE(K  ,N3MODE) = 423+2*III+(K-1)*12
                I3MODE(K+2,N3MODE) = 400+2*JJJ+(K-1)*12
                I3MODE(K+4,N3MODE) = 399+2*KKK+(K-1)*12
                B3MODE(2,K  ,N3MODE) = 0.0D0
                B3MODE(1,K  ,N3MODE) = LMIXSS(2*III-1,1,K)*
     &                                 LAMDA2(III,JJJ,KKK)
                B3MODE(2,K+2,N3MODE) = 0.0D0
                B3MODE(1,K+2,N3MODE) = QMIXSS(2*JJJ,1,K)*
     &                                 LAMDA2(III,JJJ,KKK)
                B3MODE(2,K+4,N3MODE) = 0.0D0
                B3MODE(1,K+4,N3MODE) = QMIXSS(2*KKK-1,2,K)*
     &                                 LAMDA2(III,JJJ,KKK)
                DO 86 J=1,2
                A3MODE(J,K  ,N3MODE) = AFN(  J ,2*III+5,K,L1)
                A3MODE(J,K+2,N3MODE) = AFN(  J ,2*JJJ  ,K,L1)
 86             A3MODE(J,K+4,N3MODE) = AFN(O(J),2*KKK-1,K,L1)
C--antiparticle mode
              ELSE
                III = (IDKPRD(1,I)-125)/2
                JJJ = (IDKPRD(2,I)-6)/2
                KKK = (IDKPRD(3,I)+1)/2
                DO 87 K=1,2
                I3DRTP(K  ,N3MODE) = 8
                I3DRTP(K+2,N3MODE) = 9
                I3DRTP(K+4,N3MODE) = 10
                I3MODE(K  ,N3MODE) = 423+2*III+(K-1)*12
                I3MODE(K+2,N3MODE) = 400+2*JJJ+(K-1)*12
                I3MODE(K+4,N3MODE) = 399+2*KKK+(K-1)*12
                B3MODE(1,K  ,N3MODE) = 0.0D0
                B3MODE(2,K  ,N3MODE) = LMIXSS(2*III-1,1,K)*
     &                                 LAMDA2(III,JJJ,KKK)
                B3MODE(1,K+2,N3MODE) = 0.0D0
                B3MODE(2,K+2,N3MODE) = QMIXSS(2*JJJ,1,K)*
     &                                 LAMDA2(III,JJJ,KKK)
                B3MODE(1,K+4,N3MODE) = 0.0D0
                B3MODE(2,K+4,N3MODE) = QMIXSS(2*KKK-1,2,K)*
     &                                 LAMDA2(III,JJJ,KKK)
                DO 87 J=1,2
                A3MODE(J,K  ,N3MODE) = AFN(O(J),2*III+5,K,L1)
                A3MODE(J,K+2,N3MODE) = AFN(O(J),2*JJJ  ,K,L1)
 87             A3MODE(J,K+4,N3MODE) = AFN(  J ,2*KKK-1,K,L1)
              ENDIF
            ENDIF
C--UDD modes
          ELSEIF(IDKPRD(1,I).LE.12.AND.IDKPRD(2,I).LE.12.AND.
     &           IDKPRD(3,I).LE.12) THEN
            N3MODE = N3MODE+1
            IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',115,*999)
            ID3PRT(N3MODE) = I
            NME(I) = 10000+N3MODE
            NDI3BY(N3MODE) = 6
            P3MODE(N3MODE) = 6.0D0
            SPN3CF(1,1,N3MODE) = ONE
            N3NCFL(N3MODE) = 1
            DO 61 J=1,6
 61         I3DRCF(J,N3MODE) = 1
C--particle mode
            IF(IDPDG(IDKPRD(1,I)).GT.0) THEN
              III = IDKPRD(1,I)/2
              JJJ = (IDKPRD(2,I)+1)/2
              KKK = (IDKPRD(3,I)+1)/2
              DO 62 J=1,2
              I3DRTP(J  ,N3MODE) = 11
              I3DRTP(J+2,N3MODE) = 12
              I3DRTP(J+4,N3MODE) = 13
              I3MODE(J  ,N3MODE) = 400+2*III+(J-1)*12
              I3MODE(J+2,N3MODE) = 399+2*JJJ+(J-1)*12
              I3MODE(J+4,N3MODE) = 399+2*KKK+(J-1)*12
              B3MODE(2,J  ,N3MODE) = QMIXSS(2*III,2,J)*
     &                               LAMDA3(III,JJJ,KKK)
              B3MODE(2,J+2,N3MODE) = QMIXSS(2*JJJ-1,2,J)*
     &                               LAMDA3(III,JJJ,KKK)
              B3MODE(2,J+4,N3MODE) = QMIXSS(2*KKK-1,2,J)*
     &                               LAMDA3(III,JJJ,KKK)
              B3MODE(1,J  ,N3MODE) = 0.0D0
              B3MODE(1,J+2,N3MODE) = 0.0D0
              B3MODE(1,J+4,N3MODE) = 0.0D0
              DO 62 K=1,2
              A3MODE(K,J  ,N3MODE) = AFN(K,2*III  ,J,L1)
              A3MODE(K,J+2,N3MODE) = AFN(K,2*JJJ-1,J,L1)
 62           A3MODE(K,J+4,N3MODE) = AFN(K,2*KKK-1,J,L1)
C--antiparticle mode
            ELSE
              III = (IDKPRD(1,I)-6)/2
              JJJ = (IDKPRD(2,I)-5)/2
              KKK = (IDKPRD(3,I)-5)/2
              DO 63 J=1,2
              I3DRTP(J  ,N3MODE) = 14
              I3DRTP(J+2,N3MODE) = 15
              I3DRTP(J+4,N3MODE) = 16
              I3MODE(J  ,N3MODE) = 400+2*III+(J-1)*12
              I3MODE(J+2,N3MODE) = 399+2*JJJ+(J-1)*12
              I3MODE(J+4,N3MODE) = 399+2*KKK+(J-1)*12
              B3MODE(2,J  ,N3MODE) = 0.0D0
              B3MODE(2,J+2,N3MODE) = 0.0D0
              B3MODE(2,J+4,N3MODE) = 0.0D0
              B3MODE(1,J  ,N3MODE) = QMIXSS(2*III,2,J)*
     &                               LAMDA3(III,JJJ,KKK)
              B3MODE(1,J+2,N3MODE) = QMIXSS(2*JJJ-1,2,J)*
     &                               LAMDA3(III,JJJ,KKK)
              B3MODE(1,J+4,N3MODE) = QMIXSS(2*KKK-1,2,J)*
     &                               LAMDA3(III,JJJ,KKK)
              DO 63 K=1,2
              A3MODE(K,J  ,N3MODE) = AFN(O(K),2*III  ,J,L1)
              A3MODE(K,J+2,N3MODE) = AFN(O(K),2*JJJ-1,J,L1)
 63           A3MODE(K,J+4,N3MODE) = AFN(O(K),2*KKK-1,J,L1)
            ENDIF
C--unrecognized decay issue warning
          ELSE
            CALL HWWARN('HWISP3',2,*2000)
          ENDIF
        ELSEIF(IDK(I).GE.454.AND.IDK(I).LE.455) THEN
C--+ve chargino modes
C--first the chargino modes to fermion-antifermion neutralino
          IF(L.GE.1.AND.L.LE.4.AND.(IDKPRD(2,I).LE.12.OR.
     &       (IDKPRD(2,I).GE.121.AND.IDKPRD(2,I).LE.132))) THEN
            IFR = IDKPRD(2,I)
            IFR = IFR+MOD(IFR,2)
            J    = INT((IFR-1)/120)
            IFR  = IFR-6*INT((IFR-1)/6)+6*J
            IL   = IFR+4*J
            SIFR = IFR+18*J
            L1 = IDK(I)-453
            N3MODE = N3MODE+1
            IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',116,*999)
            ID3PRT(N3MODE) = I
            NME(I) = 10000+N3MODE
            NDI3BY(N3MODE) = 4
            P3MODE(N3MODE) = ONE
            IF(IDKPRD(2,I).LE.12) P3MODE(N3MODE) = THREE
            SPN3CF(1,1,N3MODE) = ONE
            N3NCFL(N3MODE) = 1
C--sfermion exchange diagrams
            DO 10 K=1,2
            I3DRTP(K  ,N3MODE) = 3
            I3DRCF(K  ,N3MODE) = 1
            I3DRTP(K+2,N3MODE) = 4
            I3DRCF(K+2,N3MODE) = 1
            I3MODE(K  ,N3MODE) = 12*(K-1)+405+SIFR
            I3MODE(K+2,N3MODE) = 12*(K-1)+400+SIFR
            DO 10 J=1,2
            A3MODE(J,K  ,N3MODE) = AFC(  J ,IFR-1,K,L1)
            B3MODE(J,K  ,N3MODE) = AFN(O(J),IFR-1,K,L )
            A3MODE(J,K+2,N3MODE) = AFC(O(J),IFR  ,K,L1)
 10         B3MODE(J,K+2,N3MODE) = AFN(  J ,IFR  ,K,L )
C--gauge boson diagram
            IF(RMASS(IDK(I)).LT.MW+RMASS(IDKPRD(1,I))) THEN
              NDI3BY(N3MODE) = NDI3BY(N3MODE)+1
              I3DRTP(NDI3BY(N3MODE),N3MODE) = 1
              I3DRCF(NDI3BY(N3MODE),N3MODE) = 1
              I3MODE(NDI3BY(N3MODE),N3MODE) = 198
              DO 11 J=1,2
 11           A3MODE(J,NDI3BY(N3MODE),N3MODE) = OIJ(J,L,L1)
              B3MODE(1,NDI3BY(N3MODE),N3MODE) = ZERO
              B3MODE(2,NDI3BY(N3MODE),N3MODE) = -G*ORT
            ENDIF
C--then  the chargino modes to fermion-antifermion chargino
          ELSEIF(L.GE.5.AND.L.LE.8.AND.(IDKPRD(2,I).LE.12.OR.
     &       (IDKPRD(2,I).GE.121.AND.IDKPRD(2,I).LE.132))) THEN
            L = L-4
            IFR = IDKPRD(2,I)
            J    = INT((IFR-1)/120)
            IFR  = IFR-6*INT((IFR-1)/6)+6*J
            IL   = IFR+4*J
            SIFR = IFR+18*J
            IF(MOD(IFR,2).EQ.0) THEN
              IFR = IFR-1
              SIFR = SIFR-1
            ELSE
              IFR = IFR+1
              SIFR = SIFR+1
            ENDIF
            L1 = IDK(I)-453
            N3MODE = N3MODE+1
            IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',117,*999)
            ID3PRT(N3MODE) = I
            NME(I) = 10000+N3MODE
            NDI3BY(N3MODE) = 2
            P3MODE(N3MODE) = ONE
            IF(IDKPRD(2,I).LE.12) P3MODE(N3MODE) = THREE
            SPN3CF(1,1,N3MODE) = ONE
            N3NCFL(N3MODE) = 1
C--sfermion exchange diagrams
            IF(MOD(IL,2).EQ.0) THEN
              DO 12 K=1,2
              I3DRTP(K,N3MODE) = 3
              I3DRCF(K,N3MODE) = 1
              I3MODE(K,N3MODE) = 12*(K-1)+400+SIFR
              DO 12 J=1,2
              A3MODE(J,K,N3MODE) = AFC(  J ,IFR,K,L1)
 12           B3MODE(J,K,N3MODE) = AFC(O(J),IFR,K,L )
            ELSE
              DO 13 K=1,2
              I3DRTP(K,N3MODE) = 4
              I3DRCF(K,N3MODE) = 1
              I3MODE(K,N3MODE) = 12*(K-1)+400+SIFR
              DO 13 J=1,2
              A3MODE(J,K,N3MODE) = AFC(O(J),IFR,K,L1)
 13           B3MODE(J,K,N3MODE) = AFC(  J ,IFR,K,L )
            ENDIF
C--gauge boson diagram
            IF(RMASS(IDK(I)).LT.MZ+RMASS(IDKPRD(1,I))) THEN
              NDI3BY(N3MODE) = NDI3BY(N3MODE)+1
              I3DRTP(NDI3BY(N3MODE),N3MODE) = 1
              I3DRCF(NDI3BY(N3MODE),N3MODE) = 1
              I3MODE(NDI3BY(N3MODE),N3MODE) = 200
              DO 14 J=1,2
 14           A3MODE(J,NDI3BY(N3MODE),N3MODE) = OIJP(J,L,L1)
              B3MODE(1,NDI3BY(N3MODE),N3MODE) = -E*RFCH(IL)
              B3MODE(2,NDI3BY(N3MODE),N3MODE) = -E*LFCH(IL)
            ENDIF
C--R-parity violating decays
C--LLE first
          ELSEIF(IDKPRD(1,I).GE.121.AND.IDKPRD(1,I).LE.132.AND.
     &           IDKPRD(2,I).GE.121.AND.IDKPRD(2,I).LE.132.AND.
     &           IDKPRD(1,I).GE.121.AND.IDKPRD(3,I).LE.132) THEN
            L1 = IDK(I)-453
C--neutrino lepton neutrino
            IF(MOD(IDKPRD(1,I),2).EQ.0.AND.MOD(IDKPRD(2,I),2).EQ.1.AND.
     &         MOD(IDKPRD(3,I),2).EQ.0) THEN
              N3MODE = N3MODE+1
              IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',118,*999)
              ID3PRT(N3MODE) = I
              NME(I) = 10000+N3MODE
              NDI3BY(N3MODE) = 2
              P3MODE(N3MODE) = ONE
              N3NCFL(N3MODE) = 1
              SPN3CF(1,1,N3MODE) = ONE
              III = (IDKPRD(1,I)-126)/2
              JJJ = (IDKPRD(2,I)-125)/2
              KKK = (IDKPRD(3,I)-120)/2
              DO 54 K=1,2
              I3DRTP(K,N3MODE) = 10
              I3DRCF(K,N3MODE) = 1
              I3MODE(K,N3MODE) = 423+2*KKK+12*(K-1)
              B3MODE(1,K,N3MODE) = 0.0D0
              B3MODE(2,K,N3MODE)=LAMDA1(III,JJJ,KKK)*LMIXSS(2*KKK-1,2,K)
              DO 54 J=1,2
 54           A3MODE(J,K,N3MODE) = AFC(J,5+2*KKK,K,L1)
C--neutrino neutrino lepton
            ELSEIF(MOD(IDKPRD(1,I),2).EQ.0.AND.MOD(IDKPRD(2,I),2).EQ.0
     &             .AND.MOD(IDKPRD(3,I),2).EQ.1) THEN
              N3MODE = N3MODE+1
              IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',119,*999)
              ID3PRT(N3MODE) = I
              NME(I) = 10000+N3MODE
              NDI3BY(N3MODE) = 4
              P3MODE(N3MODE) = ONE
              N3NCFL(N3MODE) = 1
              SPN3CF(1,1,N3MODE) = ONE
              III = (IDKPRD(1,I)-120)/2
              JJJ = (IDKPRD(2,I)-120)/2
              KKK = (IDKPRD(3,I)-125)/2
              DO 55 K=1,2
              I3DRTP(K  ,N3MODE) = 2
              I3DRTP(K+2,N3MODE) = 3
              I3DRCF(K  ,N3MODE) = 1
              I3DRCF(K+2,N3MODE) = 1
              I3MODE(K  ,N3MODE) = 423+2*III+12*(K-1)
              I3MODE(K+2,N3MODE) = 423+2*JJJ+12*(K-1)
              B3MODE(1,K,N3MODE) = LAMDA1(III,JJJ,KKK)*
     &             LMIXSS(2*III-1,1,K)
              B3MODE(2,K,N3MODE) = 0.0D0
              B3MODE(1,K+2,N3MODE) =-LAMDA1(III,JJJ,KKK)*
     &             LMIXSS(2*JJJ-1,1,K)
              B3MODE(2,K+2,N3MODE) = 0.0D0
              DO 55 J=1,2
              A3MODE(J,K,N3MODE)   = AFC(J,5+2*III,K,L1)
 55           A3MODE(J,K+2,N3MODE) = AFC(J,5+2*JJJ,K,L1)
C--lepton lepton lepton
            ELSEIF(MOD(IDKPRD(1,I),2).EQ.1.AND.MOD(IDKPRD(2,I),2).EQ.1
     &             .AND.MOD(IDKPRD(3,I),2).EQ.1) THEN
              N3MODE = N3MODE+1
              IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',120,*999)
              ID3PRT(N3MODE) = I
              NME(I) = 10000+N3MODE
              NDI3BY(N3MODE) = 2
              P3MODE(N3MODE) = ONE
              N3NCFL(N3MODE) = 1
              SPN3CF(1,1,N3MODE) = ONE
              III = (IDKPRD(1,I)-125)/2
              JJJ = (IDKPRD(2,I)-125)/2
              KKK = (IDKPRD(3,I)-119)/2
              I3DRTP(1,N3MODE) = 8
              I3DRTP(2,N3MODE) = 9
              I3DRCF(1,N3MODE) = 1
              I3DRCF(2,N3MODE) = 1
              I3MODE(1,N3MODE) = 424+2*III
              I3MODE(2,N3MODE) = 424+2*JJJ
              B3MODE(1,1,N3MODE) = 0.0D0
              B3MODE(2,1,N3MODE) = LAMDA1(III,JJJ,KKK)
              B3MODE(1,2,N3MODE) = 0.0D0
              B3MODE(2,2,N3MODE) =-LAMDA1(III,JJJ,KKK)
              DO 56 J=1,2
              A3MODE(J,1,N3MODE) = AFC(O(J),6+2*III,1,L1)
 56           A3MODE(J,2,N3MODE) = AFC(O(J),6+2*JJJ,1,L1)
            ELSE
              CALL HWWARN('HWISP3',3,*2000)
            ENDIF
C--LQD decays
          ELSEIF(IDKPRD(1,I).GE.121.AND.IDKPRD(1,I).LE.132.AND.
     &           IDKPRD(2,I).LE.12 .AND.IDKPRD(3,I).LE. 12) THEN
            L1 = IDK(I)-453
C--nubar dbar u
            IF(IDKPRD(1,I).GE.128.AND.MOD(IDKPRD(1,I),2).EQ.0) THEN
              N3MODE = N3MODE+1
              IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',121,*999)
              ID3PRT(N3MODE) = I
              NME(I) = 10000+N3MODE
              NDI3BY(N3MODE) = 2
              P3MODE(N3MODE) = THREE
              N3NCFL(N3MODE) = 1
              SPN3CF(1,1,N3MODE) = ONE
              III = (IDKPRD(1,I)-126)/2
              JJJ = (IDKPRD(2,I)-5)/2
              KKK = IDKPRD(3,I)/2
              DO 88 K=1,2
              I3DRTP(K,N3MODE) = 10
              I3DRCF(K,N3MODE) = 1
              I3MODE(K,N3MODE) = 399+2*KKK+12*(K-1)
              B3MODE(1,K,N3MODE) = 0.0D0
              B3MODE(2,K,N3MODE) = QMIXSS(2*KKK-1,2,K)*
     &                             LAMDA2(III,JJJ,KKK)
              DO 88 J=1,2
 88           A3MODE(J,K,N3MODE) = AFC(J,2*KKK-1,K,L1)
C--l+ ubar u
            ELSEIF(IDKPRD(1,I).GE.127.AND.MOD(IDKPRD(1,I),2).EQ.1.AND.
     &             MOD(IDKPRD(2,I),2).EQ.0) THEN
              N3MODE = N3MODE+1
              IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',122,*999)
              ID3PRT(N3MODE) = I
              NME(I) = 10000+N3MODE
              NDI3BY(N3MODE) = 2
              P3MODE(N3MODE) = THREE
              N3NCFL(N3MODE) = 1
              SPN3CF(1,1,N3MODE) = ONE
              III = (IDKPRD(1,I)-125)/2
              JJJ = (IDKPRD(2,I)-6)/2
              KKK = IDKPRD(3,I)/2
              DO 89 K=1,2
              I3DRTP(K,N3MODE) = 10
              I3DRCF(K,N3MODE) = 1
              I3MODE(K,N3MODE) = 399+2*KKK+12*(K-1)
              B3MODE(1,K,N3MODE) = 0.0D0
              B3MODE(2,K,N3MODE) = QMIXSS(2*KKK-1,2,K)*
     &                             LAMDA2(III,JJJ,KKK)
              DO 89 J=1,2
 89           A3MODE(J,K,N3MODE) = AFC(J,2*KKK-1,K,L1)
C--l+ dbar d
            ELSEIF(IDKPRD(1,I).GE.127.AND.MOD(IDKPRD(1,I),2).EQ.1.AND.
     &             MOD(IDKPRD(2,I),2).EQ.1) THEN
              N3MODE = N3MODE+1
              IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',123,*999)
              ID3PRT(N3MODE) = I
              NME(I) = 10000+N3MODE
              NDI3BY(N3MODE) = 3
              P3MODE(N3MODE) = THREE
              N3NCFL(N3MODE) = 1
              SPN3CF(1,1,N3MODE) = ONE
              III = (IDKPRD(1,I)-125)/2
              JJJ = (IDKPRD(2,I)-5)/2
              KKK = (IDKPRD(3,I)+1)/2
              I3DRTP(1,N3MODE) = 8
              I3DRCF(1,N3MODE) = 1
              I3MODE(1,N3MODE) = 424+2*III
              B3MODE(1,1,N3MODE) = 0.0D0
              B3MODE(2,1,N3MODE) = -LAMDA2(III,JJJ,KKK)
              DO 91 J=1,2
 91           A3MODE(J,1,N3MODE) = AFC(O(J),2*III+6,1,L1)
              DO 92 K=1,2
              I3DRTP(K+1,N3MODE) = 9
              I3DRCF(K+1,N3MODE) = 1
              I3MODE(K+1,N3MODE) = 400+2*JJJ+12*(K-1)
              B3MODE(1,K+1,N3MODE) = 0.0D0
              B3MODE(2,K+1,N3MODE) = QMIXSS(2*JJJ,1,K)*
     &                               LAMDA2(III,JJJ,KKK)
              DO 92 J=1,2
 92           A3MODE(J,K+1,N3MODE) = AFC(O(J),2*JJJ,K,L1)
C--nu u dbar
            ELSEIF(IDKPRD(1,I).LE.126.AND.MOD(IDKPRD(1,I),2).EQ.0) THEN
              N3MODE = N3MODE+1
              IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',124,*999)
              ID3PRT(N3MODE) = I
              NME(I) = 10000+N3MODE
              NDI3BY(N3MODE) = 4
              P3MODE(N3MODE) = THREE
              N3NCFL(N3MODE) = 1
              SPN3CF(1,1,N3MODE) = ONE
              III = (IDKPRD(1,I)-120)/2
              JJJ = IDKPRD(2,I)/2
              KKK = (IDKPRD(3,I)-5)/2
              DO 90 K=1,2
              I3DRTP(K  ,N3MODE) = 2
              I3DRTP(K+2,N3MODE) = 3
              I3DRCF(K  ,N3MODE) = 1
              I3DRCF(K+2,N3MODE) = 1
              I3MODE(K  ,N3MODE) = 423+2*III+12*(K-1)
              I3MODE(K+2,N3MODE) = 399+2*JJJ+12*(K-1)
              B3MODE(1,K  ,N3MODE) = LMIXSS(2*III-1,1,K)*
     &                               LAMDA2(III,JJJ,KKK)
              B3MODE(2,K  ,N3MODE) = 0.0D0
              B3MODE(1,K+2,N3MODE) = -QMIXSS(2*JJJ-1,1,K)*
     &                               LAMDA2(III,JJJ,KKK)
              B3MODE(2,K+2,N3MODE) = 0.0D0
              DO 90 J=1,2
              A3MODE(J,K  ,N3MODE) = AFC(J,2*III+5,K,L1)
 90           A3MODE(J,K+2,N3MODE) = AFC(J,2*JJJ-1,K,L1)
C--unrecognised
            ELSE
              CALL HWWARN('HWISP3',4,*2000)
            ENDIF
C--UDD decays
          ELSEIF(IDKPRD(1,I).LE.12.AND.IDKPRD(2,I).LE.12.AND.
     &           IDKPRD(3,I).LE.12) THEN
             L1 = IDK(I)-453
C--dbar dbar dbar mode
            IF(MOD(IDKPRD(1,I),2).EQ.1.AND.MOD(IDKPRD(2,I),2).EQ.1.AND.
     &         MOD(IDKPRD(3,I),2).EQ.1) THEN
              N3MODE = N3MODE+1
              IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',125,*999)
              ID3PRT(N3MODE) = I
              NME(I) = 10000+N3MODE
              NDI3BY(N3MODE) = 6
              N3NCFL(N3MODE) = 1
              SPN3CF(1,1,N3MODE) = ONE
              III = (IDKPRD(1,I)-5)/2
              JJJ = (IDKPRD(2,I)-5)/2
              KKK = (IDKPRD(3,I)-5)/2
              P3MODE(N3MODE) = ONE
              IF(III.EQ.JJJ) P3MODE(N3MODE) = P3MODE(N3MODE)+ONE
              IF(JJJ.EQ.KKK) P3MODE(N3MODE) = P3MODE(N3MODE)+ONE
              IF(III.EQ.KKK) P3MODE(N3MODE) = P3MODE(N3MODE)+ONE
              P3MODE(N3MODE) = 6.0D0/P3MODE(N3MODE)
              DO 66 K=1,6
 66           I3DRCF(K,N3MODE) = 1
              DO 65 K=1,2
              I3DRTP(K  ,N3MODE) = 14 
              I3DRTP(K+2,N3MODE) = 15
              I3DRTP(K+4,N3MODE) = 16
              I3MODE(K  ,N3MODE) = 400+2*III+(K-1)*12
              I3MODE(K+2,N3MODE) = 400+2*JJJ+(K-1)*12
              I3MODE(K+4,N3MODE) = 400+2*KKK+(K-1)*12
              B3MODE(1,K  ,N3MODE) = QMIXSS(2*III,2,K)*
     &                               LAMDA3(III,JJJ,KKK)
              B3MODE(2,K  ,N3MODE) = 0.0D0
              B3MODE(1,K+2,N3MODE) =-QMIXSS(2*JJJ,2,K)*
     &                               LAMDA3(JJJ,III,KKK)
              B3MODE(2,K+2,N3MODE) = 0.0D0
              B3MODE(1,K+4,N3MODE) = QMIXSS(2*KKK,2,K)*
     &                               LAMDA3(KKK,III,JJJ)
              B3MODE(2,K+4,N3MODE) = 0.0D0
              DO 65 J=1,2
              A3MODE(J,K  ,N3MODE) = AFC(O(J),2*III,K,L1)
              A3MODE(J,K+2,N3MODE) = AFC(O(J),2*JJJ,K,L1)
 65           A3MODE(J,K+4,N3MODE) = AFC(O(J),2*KKK,K,L1)
C--u u d mode
            ELSEIF(MOD(IDKPRD(1,I),2).EQ.0.AND.MOD(IDKPRD(2,I),2).EQ.0
     &              .AND.MOD(IDKPRD(3,I),2).EQ.1) THEN
              N3MODE = N3MODE+1
              IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',126,*999)
              ID3PRT(N3MODE) = I
              NME(I) = 10000+N3MODE
              NDI3BY(N3MODE) = 4
              P3MODE(N3MODE) = 6.0D0
              N3NCFL(N3MODE) = 1
              SPN3CF(1,1,N3MODE) = ONE
              III = IDKPRD(1,I)/2
              JJJ = IDKPRD(2,I)/2
              KKK = (IDKPRD(3,I)+1)/2
              IF(III.EQ.JJJ) P3MODE(N3MODE) = HALF*P3MODE(N3MODE)
              DO 64 K=1,2
              I3DRTP(K  ,N3MODE) = 11
              I3DRTP(K+2,N3MODE) = 12
              I3DRCF(K  ,N3MODE) = 1
              I3DRCF(K+2,N3MODE) = 1
              I3MODE(K  ,N3MODE) = 399+2*III+(K-1)*12
              I3MODE(K+2,N3MODE) = 399+2*JJJ+(K-1)*12
              B3MODE(1,K  ,N3MODE) = 0.0D0
              B3MODE(2,K  ,N3MODE) = QMIXSS(2*III-1,2,K)*
     &                               LAMDA3(JJJ,III,KKK)
c              B3MODE(2,K,N3MODE) = 0.0D0
              B3MODE(1,K+2,N3MODE) = 0.0D0
              B3MODE(2,K+2,N3MODE) =-QMIXSS(2*JJJ-1,2,K)*
     &                               LAMDA3(III,JJJ,KKK)
              DO 64 J=1,2
              A3MODE(J,K  ,N3MODE) = AFC(J,2*III-1,K,L1)
 64           A3MODE(J,K+2,N3MODE) = AFC(J,2*JJJ-1,K,L1)
C--unrecognized decay issue warning
            ELSE
              CALL HWWARN('HWISP3',5,*2000)
            ENDIF
C--unrecognized decay issue warning
          ELSE
            CALL HWWARN('HWISP3',6,*2000)
          ENDIF
        ELSEIF(IDK(I).GE.456.AND.IDK(I).LE.457) THEN
C-- -ve chargino modes last
C--first the chargino modes to fermion-antifermion neutralino
          IF(L.GE.1.AND.L.LE.4.AND.(IDKPRD(2,I).LE.12.OR.
     &       (IDKPRD(2,I).GE.121.AND.IDKPRD(2,I).LE.132))) THEN
            IFR = IDKPRD(2,I)
            IFR = IFR+MOD(IFR,2)
            J    = INT((IFR-1)/120)
            IFR  = IFR-6*INT((IFR-1)/6)+6*J
            IL   = IFR+4*J
            SIFR = IFR+18*J
            L1 = IDK(I)-455
            N3MODE = N3MODE+1
            IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',127,*999)
            ID3PRT(N3MODE) = I
            NME(I) = 10000+N3MODE
            NDI3BY(N3MODE) = 4
            P3MODE(N3MODE) = ONE
            IF(IDKPRD(2,I).LE.12) P3MODE(N3MODE) = THREE
            SPN3CF(1,1,N3MODE) = ONE
            N3NCFL(N3MODE) = 1
C--sfermion exchange diagrams
            DO 15 K=1,2
            I3DRTP(K  ,N3MODE) = 3
            I3DRCF(K  ,N3MODE) = 1
            I3DRTP(K+2,N3MODE) = 4
            I3DRCF(K+2,N3MODE) = 1
            I3MODE(K  ,N3MODE) = 12*(K-1)+406+SIFR
            I3MODE(K+2,N3MODE) = 12*(K-1)+399+SIFR
            DO 15 J=1,2
            A3MODE(J,K  ,N3MODE) = AFC(  J ,IFR  ,K,L1)
            B3MODE(J,K  ,N3MODE) = AFN(O(J),IFR  ,K,L )
            A3MODE(J,K+2,N3MODE) = AFC(O(J),IFR-1,K,L1)
 15         B3MODE(J,K+2,N3MODE) = AFN(  J ,IFR-1,K,L )
C--gauge boson diagram
            IF(RMASS(IDK(I)).LT.MW+RMASS(IDKPRD(1,I))) THEN
              NDI3BY(N3MODE) = NDI3BY(N3MODE)+1
              I3DRTP(NDI3BY(N3MODE),N3MODE) = 1
              I3DRCF(NDI3BY(N3MODE),N3MODE) = 1
              I3MODE(NDI3BY(N3MODE),N3MODE) = 199
              DO 16 J=1,2
 16           A3MODE(J,NDI3BY(N3MODE),N3MODE) =-OIJ(O(J),L,L1)
              B3MODE(1,NDI3BY(N3MODE),N3MODE) = ZERO
              B3MODE(2,NDI3BY(N3MODE),N3MODE) = -G*ORT
            ENDIF
C--then  the chargino modes to fermion-antifermion chargino
          ELSEIF(L.GE.5.AND.L.LE.8.AND.(IDKPRD(2,I).LE.12.OR.
     &       (IDKPRD(2,I).GE.121.AND.IDKPRD(2,I).LE.132))) THEN
            L = L-6
            IFR = IDKPRD(2,I)
            J    = INT((IFR-1)/120)
            IFR  = IFR-6*INT((IFR-1)/6)+6*J
            IL   = IFR+4*J
            SIFR = IFR+18*J
            IF(MOD(IFR,2).EQ.0) THEN
              IFR = IFR-1
              SIFR = SIFR-1
            ELSE
              IFR = IFR+1
              SIFR = SIFR+1
            ENDIF
            L1 = IDK(I)-455
            N3MODE = N3MODE+1
            IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',128,*999)
            ID3PRT(N3MODE) = I
            NME(I) = 10000+N3MODE
            NDI3BY(N3MODE) = 2
            P3MODE(N3MODE) = ONE
            IF(IDKPRD(2,I).LE.12) P3MODE(N3MODE) = THREE
            SPN3CF(1,1,N3MODE) = ONE
            N3NCFL(N3MODE) = 1
C--sfermion exchange diagrams
            IF(MOD(IL,2).EQ.0) THEN
              DO 17 K=1,2
              I3DRTP(K,N3MODE) = 4
              I3DRCF(K,N3MODE) = 1
              I3MODE(K,N3MODE) = 12*(K-1)+400+SIFR
              DO 17 J=1,2
              A3MODE(J,K,N3MODE) = AFC(O(J),IFR,K,L1)
 17           B3MODE(J,K,N3MODE) = AFC(  J ,IFR,K,L )
            ELSE
              DO 18 K=1,2
              I3DRTP(K,N3MODE) = 3
              I3DRCF(K,N3MODE) = 1
              I3MODE(K,N3MODE) = 12*(K-1)+400+SIFR
              DO 18 J=1,2
              A3MODE(J,K,N3MODE) = AFC(  J ,IFR,K,L1)
 18           B3MODE(J,K,N3MODE) = AFC(O(J),IFR,K,L )
            ENDIF
C--gauge boson diagram
            IF(RMASS(IDK(I)).LT.MZ+RMASS(IDKPRD(1,I))) THEN
              NDI3BY(N3MODE) = NDI3BY(N3MODE)+1
              I3DRTP(NDI3BY(N3MODE),N3MODE) = 1
              I3DRCF(NDI3BY(N3MODE),N3MODE) = 1
              I3MODE(NDI3BY(N3MODE),N3MODE) = 200
              DO 19 J=1,2
 19           A3MODE(J,NDI3BY(N3MODE),N3MODE) =-OIJP(O(J),L,L1)
              B3MODE(1,NDI3BY(N3MODE),N3MODE) = -E*RFCH(IL)
              B3MODE(2,NDI3BY(N3MODE),N3MODE) = -E*LFCH(IL)
            ENDIF
C--R-parity violating decays
C--LLE first
          ELSEIF(IDKPRD(1,I).GE.121.AND.IDKPRD(1,I).LE.132.AND.
     &           IDKPRD(2,I).GE.121.AND.IDKPRD(2,I).LE.132.AND.
     &           IDKPRD(1,I).GE.121.AND.IDKPRD(3,I).LE.132) THEN
             L1 = IDK(I)-455
C--neutrino lepton neutrino
            IF(MOD(IDKPRD(1,I),2).EQ.0.AND.MOD(IDKPRD(2,I),2).EQ.1.AND.
     &         MOD(IDKPRD(3,I),2).EQ.0) THEN
              N3MODE = N3MODE+1
              IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',129,*999)
              ID3PRT(N3MODE) = I
              NME(I) = 10000+N3MODE
              NDI3BY(N3MODE) = 2
              P3MODE(N3MODE) = ONE
              N3NCFL(N3MODE) = 1
              SPN3CF(1,1,N3MODE) = ONE
              III = (IDKPRD(1,I)-120)/2
              JJJ = (IDKPRD(2,I)-119)/2
              KKK = (IDKPRD(3,I)-126)/2
              DO 57 K=1,2
              I3DRTP(K,N3MODE) = 4
              I3DRCF(K,N3MODE) = 1
              I3MODE(K,N3MODE) = 423+2*KKK+12*(K-1)
              B3MODE(2,K,N3MODE) = 0.0D0
              B3MODE(1,K,N3MODE)=LAMDA1(III,JJJ,KKK)*LMIXSS(2*KKK-1,2,K)
              DO 57 J=1,2
 57           A3MODE(J,K,N3MODE) = AFC(O(J),5+2*KKK,K,L1)
C--neutrino neutrino lepton
            ELSEIF(MOD(IDKPRD(1,I),2).EQ.0.AND.MOD(IDKPRD(2,I),2).EQ.0
     &             .AND.MOD(IDKPRD(3,I),2).EQ.1) THEN
              N3MODE = N3MODE+1
              IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',130,*999)
              ID3PRT(N3MODE) = I
              NME(I) = 10000+N3MODE
              NDI3BY(N3MODE) = 4
              P3MODE(N3MODE) = ONE
              N3NCFL(N3MODE) = 1
              SPN3CF(1,1,N3MODE) = ONE
              III = (IDKPRD(1,I)-126)/2
              JJJ = (IDKPRD(2,I)-126)/2
              KKK = (IDKPRD(3,I)-119)/2
              DO 58 K=1,2
              I3DRTP(K  ,N3MODE) = 8
              I3DRTP(K+2,N3MODE) = 9
              I3DRCF(K  ,N3MODE) = 1
              I3DRCF(K+2,N3MODE) = 1
              I3MODE(K  ,N3MODE) = 423+2*III+12*(K-1)
              I3MODE(K+2,N3MODE) = 423+2*JJJ+12*(K-1)
              B3MODE(2,K,N3MODE) = LAMDA1(III,JJJ,KKK)*
     &             LMIXSS(2*III-1,1,K)
              B3MODE(1,K,N3MODE) = 0.0D0
              B3MODE(2,K+2,N3MODE) =-LAMDA1(III,JJJ,KKK)*
     &             LMIXSS(2*JJJ-1,1,K)
              B3MODE(1,K+2,N3MODE) = 0.0D0
              DO 58 J=1,2
              A3MODE(J,K,N3MODE)   = AFC(O(J),5+2*III,K,L1)
 58           A3MODE(J,K+2,N3MODE) = AFC(O(J),5+2*JJJ,K,L1)
C--lepton lepton lepton
            ELSEIF(MOD(IDKPRD(1,I),2).EQ.1.AND.MOD(IDKPRD(2,I),2).EQ.1
     &             .AND.MOD(IDKPRD(3,I),2).EQ.1) THEN
              N3MODE = N3MODE+1
              IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',131,*999)
              ID3PRT(N3MODE) = I
              NME(I) = 10000+N3MODE
              NDI3BY(N3MODE) = 2
              P3MODE(N3MODE) = ONE
              N3NCFL(N3MODE) = 1
              SPN3CF(1,1,N3MODE) = ONE
              III = (IDKPRD(1,I)-119)/2
              JJJ = (IDKPRD(2,I)-119)/2
              KKK = (IDKPRD(3,I)-125)/2
              I3DRTP(1,N3MODE) = 2
              I3DRTP(2,N3MODE) = 3
              I3DRCF(1,N3MODE) = 1
              I3DRCF(2,N3MODE) = 1
              I3MODE(1,N3MODE) = 424+2*III
              I3MODE(2,N3MODE) = 424+2*JJJ
              B3MODE(1,1,N3MODE) = LAMDA1(III,JJJ,KKK)
              B3MODE(2,1,N3MODE) = 0.0D0
              B3MODE(1,2,N3MODE) =-LAMDA1(III,JJJ,KKK)
              B3MODE(2,2,N3MODE) = 0.0D0
              DO 59 J=1,2
              A3MODE(J,1,N3MODE) = AFC(J,6+2*III,1,L1)
 59           A3MODE(J,2,N3MODE) = AFC(J,6+2*JJJ,1,L1)
            ELSE
              CALL HWWARN('HWISP3',7,*2000)
            ENDIF
C--LQD decays
          ELSEIF(IDKPRD(1,I).GE.121.AND.IDKPRD(1,I).LE.132.AND.
     &           IDKPRD(2,I).LE.12 .AND.IDKPRD(3,I).LE. 12) THEN
            L1 = IDK(I)-455
C--nu d ubar
            IF(IDKPRD(1,I).LE.126.AND.MOD(IDKPRD(1,I),2).EQ.0) THEN
              N3MODE = N3MODE+1
              IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',132,*999)
              ID3PRT(N3MODE) = I
              NME(I) = 10000+N3MODE
              NDI3BY(N3MODE) = 2
              P3MODE(N3MODE) = THREE
              N3NCFL(N3MODE) = 1
              SPN3CF(1,1,N3MODE) = ONE
              III = (IDKPRD(1,I)-120)/2
              JJJ = (IDKPRD(2,I)+1)/2
              KKK = (IDKPRD(3,I)-6)/2
              DO 93 K=1,2
              I3DRTP(K,N3MODE) = 4
              I3DRCF(K,N3MODE) = 1
              I3MODE(K,N3MODE) = 399+2*KKK+12*(K-1)
              B3MODE(2,K,N3MODE) = 0.0D0
              B3MODE(1,K,N3MODE) = QMIXSS(2*KKK-1,2,K)*
     &                             LAMDA2(III,JJJ,KKK)
              DO 93 J=1,2
 93           A3MODE(J,K,N3MODE) = AFC(O(J),2*KKK-1,K,L1)
C--l- u ubar
            ELSEIF(IDKPRD(1,I).LE.125.AND.MOD(IDKPRD(1,I),2).EQ.1.AND.
     &             MOD(IDKPRD(2,I),2).EQ.0) THEN
              N3MODE = N3MODE+1
              IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',133,*999)
              ID3PRT(N3MODE) = I
              NME(I) = 10000+N3MODE
              NDI3BY(N3MODE) = 2
              P3MODE(N3MODE) = THREE
              N3NCFL(N3MODE) = 1
              SPN3CF(1,1,N3MODE) = ONE
              III = (IDKPRD(1,I)-119)/2
              JJJ = IDKPRD(2,I)/2
              KKK = (IDKPRD(3,I)-6)/2
              DO 94 K=1,2
              I3DRTP(K,N3MODE) = 4
              I3DRCF(K,N3MODE) = 1
              I3MODE(K,N3MODE) = 399+2*KKK+12*(K-1)
              B3MODE(2,K,N3MODE) = 0.0D0
              B3MODE(1,K,N3MODE) = QMIXSS(2*KKK-1,2,K)*
     &                             LAMDA2(III,JJJ,KKK)
              DO 94 J=1,2
 94           A3MODE(J,K,N3MODE) = AFC(J,2*KKK-1,K,L1)
C--l- d dbar
            ELSEIF(IDKPRD(1,I).LE.125.AND.MOD(IDKPRD(1,I),2).EQ.1.AND.
     &             MOD(IDKPRD(2,I),2).EQ.1) THEN
              N3MODE = N3MODE+1
              IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',134,*999)
              ID3PRT(N3MODE) = I
              NME(I) = 10000+N3MODE
              NDI3BY(N3MODE) = 3
              P3MODE(N3MODE) = THREE
              N3NCFL(N3MODE) = 1
              SPN3CF(1,1,N3MODE) = ONE
              III = (IDKPRD(1,I)-119)/2
              JJJ = (IDKPRD(2,I)+1)/2
              KKK = (IDKPRD(3,I)-5)/2
              I3DRTP(1,N3MODE) = 2
              I3DRCF(1,N3MODE) = 1
              I3MODE(1,N3MODE) = 424+2*III
              B3MODE(2,1,N3MODE) = 0.0D0
              B3MODE(1,1,N3MODE) = -LAMDA2(III,JJJ,KKK)
              DO 95 J=1,2
 95           A3MODE(J,1,N3MODE) = AFC(J,2*III+6,1,L1)
              DO 96 K=1,2
              I3DRTP(K+1,N3MODE) = 3
              I3DRCF(K+1,N3MODE) = 1
              I3MODE(K+1,N3MODE) = 400+2*JJJ+12*(K-1)
              B3MODE(2,K+1,N3MODE) = 0.0D0
              B3MODE(1,K+1,N3MODE) = QMIXSS(2*JJJ,1,K)*
     &                               LAMDA2(III,JJJ,KKK)
              DO 96 J=1,2
 96           A3MODE(J,K+1,N3MODE) = AFC(J,2*JJJ,K,L1)
C--nubar ubar d
            ELSEIF(IDKPRD(1,I).GE.128.AND.MOD(IDKPRD(1,I),2).EQ.0) THEN
              N3MODE = N3MODE+1
              IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',135,*999)
              ID3PRT(N3MODE) = I
              NME(I) = 10000+N3MODE
              NDI3BY(N3MODE) = 4
              P3MODE(N3MODE) = THREE
              N3NCFL(N3MODE) = 1
              SPN3CF(1,1,N3MODE) = ONE
              III = (IDKPRD(1,I)-126)/2
              JJJ = (IDKPRD(2,I)-6)/2
              KKK = (IDKPRD(3,I)+1)/2
              DO 97 K=1,2
              I3DRTP(K  ,N3MODE) = 8
              I3DRTP(K+2,N3MODE) = 9
              I3DRCF(K  ,N3MODE) = 1
              I3DRCF(K+2,N3MODE) = 1
              I3MODE(K  ,N3MODE) = 423+2*III+12*(K-1)
              I3MODE(K+2,N3MODE) = 399+2*JJJ+12*(K-1)
              B3MODE(2,K  ,N3MODE) = LMIXSS(2*III-1,1,K)*
     &                               LAMDA2(III,JJJ,KKK)
              B3MODE(1,K  ,N3MODE) = 0.0D0
              B3MODE(2,K+2,N3MODE) = -QMIXSS(2*JJJ-1,1,K)*
     &                               LAMDA2(III,JJJ,KKK)
              B3MODE(1,K+2,N3MODE) = 0.0D0
              DO 97 J=1,2
              A3MODE(J,K  ,N3MODE) = AFC(O(J),2*III+5,K,L1)
 97           A3MODE(J,K+2,N3MODE) = AFC(O(J),2*JJJ-1,K,L1)
C--unrecognised
            ELSE
              CALL HWWARN('HWISP3',8,*2000)
            ENDIF
C-- UDD modes
          ELSEIF(IDKPRD(1,I).LE.12.AND.IDKPRD(2,I).LE.12.AND.
     &           IDKPRD(3,I).LE.12) THEN
             L1 = IDK(I)-455
C-- d d d mode
            IF(MOD(IDKPRD(1,I),2).EQ.1.AND.MOD(IDKPRD(2,I),2).EQ.1.AND.
     &         MOD(IDKPRD(3,I),2).EQ.1) THEN
              N3MODE = N3MODE+1
              IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',136,*999)
              ID3PRT(N3MODE) = I
              NME(I) = 10000+N3MODE
              NDI3BY(N3MODE) = 6
              N3NCFL(N3MODE) = 1
              SPN3CF(1,1,N3MODE) = ONE
              III = (IDKPRD(1,I)+1)/2
              JJJ = (IDKPRD(2,I)+1)/2
              KKK = (IDKPRD(3,I)+1)/2
              P3MODE(N3MODE) = ONE
              IF(III.EQ.JJJ) P3MODE(N3MODE) = P3MODE(N3MODE)+ONE
              IF(JJJ.EQ.KKK) P3MODE(N3MODE) = P3MODE(N3MODE)+ONE
              IF(III.EQ.KKK) P3MODE(N3MODE) = P3MODE(N3MODE)+ONE
              P3MODE(N3MODE) = 6.0D0/P3MODE(N3MODE)
              DO 68 K=1,6
 68           I3DRCF(K,N3MODE) = 1
              DO 67 K=1,2
              I3DRTP(K  ,N3MODE) = 12
              I3DRTP(K+2,N3MODE) = 13
              I3DRTP(K+4,N3MODE) = 14
              I3MODE(K  ,N3MODE) = 400+2*III+(K-1)*12
              I3MODE(K+2,N3MODE) = 400+2*JJJ+(K-1)*12
              I3MODE(K+4,N3MODE) = 400+2*KKK+(K-1)*12
              B3MODE(1,K  ,N3MODE) = 0.0D0
              B3MODE(1,K+2,N3MODE) = 0.0D0
              B3MODE(1,K+4,N3MODE) = 0.0D0
              B3MODE(2,K  ,N3MODE) = QMIXSS(2*III,2,K)*
     &                               LAMDA3(III,JJJ,KKK)
              B3MODE(2,K+2,N3MODE) =-QMIXSS(2*JJJ,2,K)*
     &                               LAMDA3(JJJ,III,KKK)
              B3MODE(2,K+4,N3MODE) = QMIXSS(2*KKK,2,K)*
     &                               LAMDA3(KKK,III,JJJ)
              DO 67 J=1,2
              A3MODE(J,K  ,N3MODE) = AFC(J,2*III,K,L1)
              A3MODE(J,K+2,N3MODE) = AFC(J,2*JJJ,K,L1)
 67           A3MODE(J,K+4,N3MODE) = AFC(J,2*KKK,K,L1)
C--u u d mode
            ELSEIF(MOD(IDKPRD(1,I),2).EQ.0.AND.MOD(IDKPRD(2,I),2).EQ.0
     &              .AND.MOD(IDKPRD(3,I),2).EQ.1) THEN
              N3MODE = N3MODE+1
              IF(N3MODE.GT.NMODE3) CALL HWWARN('HWISP3',137,*999)
              ID3PRT(N3MODE) = I
              NME(I) = 10000+N3MODE
              NDI3BY(N3MODE) = 4
              P3MODE(N3MODE) = 6.0D0
              N3NCFL(N3MODE) = 1
              SPN3CF(1,1,N3MODE) = ONE
              III = (IDKPRD(1,I)-6)/2
              JJJ = (IDKPRD(2,I)-6)/2
              KKK = (IDKPRD(3,I)-5)/2
              IF(III.EQ.JJJ) P3MODE(N3MODE) = HALF*P3MODE(N3MODE)
              DO 69 K=1,2
              I3DRTP(K  ,N3MODE) = 11
              I3DRTP(K+2,N3MODE) = 12
              I3DRCF(K  ,N3MODE) = 1
              I3DRCF(K+2,N3MODE) = 1
              I3MODE(K  ,N3MODE) = 399+2*III+(K-1)*12
              I3MODE(K+2,N3MODE) = 399+2*JJJ+(K-1)*12
              B3MODE(1,K  ,N3MODE) = QMIXSS(2*III-1,2,K)*
     &                               LAMDA3(JJJ,III,KKK)
              B3MODE(1,K+2,N3MODE) =-QMIXSS(2*JJJ-1,2,K)*
     &                               LAMDA3(III,JJJ,KKK)
              B3MODE(2,K+2,N3MODE) = 0.0D0
              B3MODE(2,K+2,N3MODE) = 0.0D0
              DO 69 J=1,2
              A3MODE(J,K  ,N3MODE) = AFC(O(J),2*III-1,K,L1)
 69           A3MODE(J,K+2,N3MODE) = AFC(O(J),2*JJJ-1,K,L1)
C--unrecognized decay issue warning
            ELSE
              CALL HWWARN('HWISP3',9,*2000)
            ENDIF
C--unrecognized decay issue warning
          ELSE
            CALL HWWARN('HWISP3',10,*2000)
          ENDIF
        ENDIF
C--NOW FIND THE TWO BODY MODES WE WILL TREAT AS THREE BODY
 2500   IF(IDKPRD(2,I).EQ.0.OR.IDKPRD(3,I).NE.0) GOTO 2000
        L1  = IDK(I)-449
        IH1 = IDK(I)-202
        IH  = IDKPRD(1,I)-202
C--first the neutralino decay modes
        IF(L1.GE.1.AND.L1.LE.4.AND.
     &     IDKPRD(2,I).GE.198.AND.IDKPRD(2,I).LE.200) THEN
C--neutralino --> neutralino Z
          IF(L.GE.1.AND.L.LE.4.AND.IDKPRD(2,I).EQ.200) THEN
            NBMODE = NBMODE+1
            IF(NBMODE.GT.NMODEB) CALL HWWARN('HWISP3',138,*999)
            NME(I) = 20000+NBMODE
            IDBPRT(NBMODE) = I
            IBMODE(NBMODE) = 200
            IBDRTP(NBMODE) = 1
            DO 20 J=1,2
 20         ABMODE(J,NBMODE) = OIJPP(J,L,L1)
            DO 21 K=1,12
            IF(K.LE.6) THEN
              IL = K
              PBMODE(K,NBMODE) = THREE
            ELSE
              IL=K+4
              PBMODE(K,NBMODE) = ONE
            ENDIF
            BBMODE(1,K,NBMODE) = -E*RFCH(IL)
 21         BBMODE(2,K,NBMODE) = -E*LFCH(IL)
C--neutralino --> chargino+ W-
          ELSEIF((L.EQ.5.OR.L.EQ.6).AND.IDKPRD(2,I).EQ.199) THEN
            L = L-4
            NBMODE = NBMODE+1
            IF(NBMODE.GT.NMODEB) CALL HWWARN('HWISP3',139,*999)
            NME(I) = 20000+NBMODE
            IDBPRT(NBMODE) = I
            IBMODE(NBMODE) = 199
            IBDRTP(NBMODE) = 1
            DO 22 J=1,2
 22         ABMODE(J,NBMODE) = OIJ(J,L1,L)
            DO 23 K=1,6
            PBMODE(K,NBMODE) = ONE
            IF(K.LE.3) PBMODE(K,NBMODE) = THREE
            BBMODE(1,K,NBMODE) = ZERO
 23         BBMODE(2,K,NBMODE) = -G*ORT
C--neutralino --> chargino- W+
          ELSEIF((L.EQ.7.OR.L.EQ.8).AND.IDKPRD(2,I).EQ.198) THEN
            L = L-6
            NBMODE = NBMODE+1
            IF(NBMODE.GT.NMODEB) CALL HWWARN('HWISP3',140,*999)
            NME(I) = 20000+NBMODE
            IDBPRT(NBMODE) = I
            IBMODE(NBMODE) = 198
            IBDRTP(NBMODE) = 1
            DO 24 J=1,2
 24         ABMODE(J,NBMODE) =-OIJ(O(J),L1,L)
            DO 25 K=1,6
            PBMODE(K,NBMODE) = ONE
            IF(K.LE.3) PBMODE(K,NBMODE) = THREE
            BBMODE(1,K,NBMODE) = ZERO
 25         BBMODE(2,K,NBMODE) = -G*ORT
C--gravitino Z modes
          ELSEIF(L.EQ.9.AND.IDKPRD(2,I).EQ.200) THEN
            NBMODE = NBMODE+1
            IF(NBMODE.GT.NMODEB) CALL HWWARN('HWISP3',141,*999)
            NME(I) = 20000+NBMODE
            IDBPRT(NBMODE) = I
            IBMODE(NBMODE) = 200
            IBDRTP(NBMODE) = 7
            ABMODE(1,NBMODE) = 2.0D0/SQRT(6.0D0)*ZMIXSS(L1,2)
            ABMODE(2,NBMODE) = 2.0D0/SQRT(6.0D0)*RMASS(200)*
     &                         (ZMIXSS(L1,3)*COSB-ZMIXSS(L1,4)*SINB)
            DO 41 K=1,12
            IF(K.LE.6) THEN
              IL = K
              PBMODE(K,NBMODE) = THREE
            ELSE
              IL=K+4
              PBMODE(K,NBMODE) = ONE
            ENDIF
            BBMODE(1,K,NBMODE) = -E*RFCH(IL)
 41         BBMODE(2,K,NBMODE) = -E*LFCH(IL)
C--unrecognized decay issue warning
          ELSE
            CALL HWWARN('HWISP3',11,*2000)
          ENDIF
C--then the +ve chargino decay modes
        ELSEIF((L1.EQ.5.OR.L1.EQ.6)
     &         .AND.IDKPRD(2,I).GE.198.AND.IDKPRD(2,I).LE.200) THEN
          L1 = L1-4
C--chargino --> chargino Z
          IF((L.EQ.5.OR.L.EQ.6).AND.IDKPRD(2,I).EQ.200) THEN
            L = L-4
            NBMODE = NBMODE+1
            IF(NBMODE.GT.NMODEB) CALL HWWARN('HWISP3',142,*999)
            NME(I) = 20000+NBMODE
            IDBPRT(NBMODE) = I
            IBMODE(NBMODE) = 200
            IBDRTP(NBMODE) = 1
            DO 26 J=1,2
 26         ABMODE(J,NBMODE) = OIJP(J,L,L1)
            DO 27 K=1,12
            IF(K.LE.6) THEN
              IL = K
              PBMODE(K,NBMODE) = THREE
            ELSE
              IL=K+4
              PBMODE(K,NBMODE) = ONE
            ENDIF
            BBMODE(1,K,NBMODE) = -E*RFCH(IL)
 27         BBMODE(2,K,NBMODE) = -E*LFCH(IL)
C--chargino --> neutralino W+
          ELSEIF(L.GE.1.AND.L.LE.4.AND.IDKPRD(2,I).EQ.198) THEN
            NBMODE = NBMODE+1
            IF(NBMODE.GT.NMODEB) CALL HWWARN('HWISP3',143,*999)
            NME(I) = 20000+NBMODE
            IDBPRT(NBMODE) = I
            IBMODE(NBMODE) = 198
            IBDRTP(NBMODE) = 1
            DO 28 J=1,2
 28         ABMODE(J,NBMODE) = OIJ(J,L,L1)
            DO 29 K=1,6
            PBMODE(K,NBMODE) = ONE
            IF(K.LE.3) PBMODE(K,NBMODE) = THREE
            BBMODE(1,K,NBMODE) = ZERO
 29         BBMODE(2,K,NBMODE) = -G*ORT
C--unrecognised decay issue warning
          ELSE
            CALL HWWARN('HWISP3',12,*2000)
          ENDIF
C--then the -ve chargino decay modes
        ELSEIF((L1.EQ.7.OR.L1.EQ.8)
     &         .AND.IDKPRD(2,I).GE.198.AND.IDKPRD(2,I).LE.200) THEN
          L1 = L1-6
C--chargino --> chargino Z
          IF((L.EQ.7.OR.L.EQ.8).AND.IDKPRD(2,I).EQ.200) THEN
            L = L-6
            NBMODE = NBMODE+1
            IF(NBMODE.GT.NMODEB) CALL HWWARN('HWISP3',144,*999)
            NME(I) = 20000+NBMODE
            IDBPRT(NBMODE) = I
            IBMODE(NBMODE) = 200
            IBDRTP(NBMODE) = 1
            DO 30 J=1,2
 30         ABMODE(J,NBMODE) =-OIJP(O(J),L,L1)
            DO 31 K=1,12
            IF(K.LE.6) THEN
              IL = K
              PBMODE(K,NBMODE) = THREE
            ELSE
              IL=K+4
              PBMODE(K,NBMODE) = ONE
            ENDIF
            BBMODE(1,K,NBMODE) = -E*RFCH(IL)
 31         BBMODE(2,K,NBMODE) = -E*LFCH(IL)
C--chargino --> neutralino W-
          ELSEIF(L.GE.1.AND.L.LE.4.AND.IDKPRD(2,I).EQ.199) THEN
            NBMODE = NBMODE+1
            IF(NBMODE.GT.NMODEB) CALL HWWARN('HWISP3',145,*999)
            NME(I) = 20000+NBMODE
            IDBPRT(NBMODE) = I
            IBMODE(NBMODE) = 199
            IBDRTP(NBMODE) = 1
            DO 32 J=1,2
 32         ABMODE(J,NBMODE) =-OIJ(O(J),L,L1)
            DO 33 K=1,6
            PBMODE(K,NBMODE) = ONE
            IF(K.LE.3) PBMODE(K,NBMODE) = THREE
            BBMODE(1,K,NBMODE) = ZERO
 33         BBMODE(2,K,NBMODE) = -G*ORT
C--unrecognised decay issue warning
          ELSE
            CALL HWWARN('HWISP3',13,*2000)
          ENDIF
C--gauge boson decay modes of the Higgs
        ELSEIF(IH.GE.1.AND.IH.LE.5.AND.IH1.GE.1.AND.IH1.LE.5.AND.
     &         IDKPRD(1,I).GE.198.AND.IDKPRD(2,I).LE.200) THEN
C--decay of the A0 to scalar Higgs and Z boson
          IF(IH1.EQ.3.AND.IH.LE.2) THEN
            NBMODE = NBMODE+1
            IF(NBMODE.GT.NMODEB) CALL HWWARN('HWISP3',146,*999)
            NME(I) = 20000+NBMODE
            IDBPRT(NBMODE) = I
            IBMODE(NBMODE) = 200
            IBDRTP(NBMODE) = 6
            ABMODE(1,NBMODE) =-HHB(2,IH)
            ABMODE(2,NBMODE) = ZERO
            DO 34 K=1,12
            IF(K.LE.6) THEN
              IL = K
              PBMODE(K,NBMODE) = 3.0D0
            ELSE
              IL=K+4
              PBMODE(K,NBMODE) = 1.0D0
            ENDIF
            BBMODE(1,K,NBMODE) = -E*RFCH(IL)
 34         BBMODE(2,K,NBMODE) = -E*LFCH(IL)
C--decay of scalar Higgs to A0 and Z
          ELSEIF(IH.EQ.3.AND.IH1.LE.3) THEN
            NBMODE = NBMODE+1
            IF(NBMODE.GT.NMODEB) CALL HWWARN('HWISP3',147,*999)
            NME(I) = 20000+NBMODE
            IDBPRT(NBMODE) = I
            IBMODE(NBMODE) = 200
            IBDRTP(NBMODE) = 6
            ABMODE(1,NBMODE) = HHB(2,IH1)
            ABMODE(2,NBMODE) = ZERO
            DO 35 K=1,12
            IF(K.LE.6) THEN
              IL = K
              PBMODE(K,NBMODE) = 3.0D0
            ELSE
              IL=K+4
              PBMODE(K,NBMODE) = 1.0D0
            ENDIF
            BBMODE(1,K,NBMODE) = -E*RFCH(IL)
 35         BBMODE(2,K,NBMODE) = -E*LFCH(IL)
C--decay of the positively charged Higgs
          ELSEIF(IH1.EQ.4.AND.IH.LE.3) THEN
            NBMODE = NBMODE+1
            IF(NBMODE.GT.NMODEB) CALL HWWARN('HWISP3',148,*999)
            NME(I) = 20000+NBMODE
            IDBPRT(NBMODE) = I
            IBMODE(NBMODE) = 198
            IBDRTP(NBMODE) = 6
            ABMODE(1,NBMODE) =-HHB(1,IH)
            ABMODE(2,NBMODE) = ZERO
            DO 36 K=1,6
            PBMODE(K,NBMODE) = 1.0D0
            IF(K.LE.3) PBMODE(K,NBMODE) = 3.0D0
            BBMODE(1,K,NBMODE) = ZERO
 36         BBMODE(2,K,NBMODE) = -G*ORT
C--decay of the negatively charged Higgs
          ELSEIF(IH1.EQ.5.AND.IH.LE.3) THEN
            NBMODE = NBMODE+1
            IF(NBMODE.GT.NMODEB) CALL HWWARN('HWISP3',149,*999)
            NME(I) = 20000+NBMODE
            IDBPRT(NBMODE) = I
            IBMODE(NBMODE) = 199
            IBDRTP(NBMODE) = 6
            ABMODE(1,NBMODE) =-HHB(1,IH)
            ABMODE(2,NBMODE) = ZERO
            DO 37 K=1,6
            PBMODE(K,NBMODE) = 1.0D0
            IF(K.LE.3) PBMODE(K,NBMODE) = 3.0D0
            BBMODE(1,K,NBMODE) = ZERO
 37         BBMODE(2,K,NBMODE) = -G*ORT
          ENDIF
C--finally sfermion modes to gauge bosons
        ELSEIF(IDK(I).GE.401.AND.IDK(I).LE.448.AND.
     &         IDKPRD(2,I).GE.401.AND.IDKPRD(2,I).LE.448.AND.
     &         IDKPRD(1,I).GE.198.AND.IDKPRD(1,I).LE.200) THEN
C--change the order of the decay products
          IM = MOD(INT((IDK(I)-389)/12)+1,2)+1
          IL = 6*INT((IDK(I)-401)/24)+MOD(IDK(I)-401,6)+1
          IH = MOD(INT((IDKPRD(2,I)-389)/12)+1,2)+1
          IQ = 6*INT((IDKPRD(2,I)-401)/24)+MOD(IDKPRD(2,I)-401,6)+1
C--first the Z decay modes
          IF(IDKPRD(1,I).EQ.200) THEN
            NBMODE = NBMODE+1
            IF(NBMODE.GT.NMODEB) CALL HWWARN('HWISP3',150,*999)
            NME(I) = 20000+NBMODE
            IDBPRT(NBMODE) = I
            IBMODE(NBMODE) = 200
            IBDRTP(NBMODE) = 6
            ABMODE(1,NBMODE) = ZAB(IL,IM,IH)
            ABMODE(2,NBMODE) = ZERO
            DO 38 K=1,12
            IF(K.LE.6) THEN
              IL = K
              PBMODE(K,NBMODE) = 3.0D0
            ELSE
              IL=K+4
              PBMODE(K,NBMODE) = 1.0D0
            ENDIF
            BBMODE(1,K,NBMODE) = -E*RFCH(IL)
 38         BBMODE(2,K,NBMODE) = -E*LFCH(IL)
C--then  the W+ decay modes
          ELSEIF(IDKPRD(1,I).EQ.198) THEN
            NBMODE = NBMODE+1
            IF(NBMODE.GT.NMODEB) CALL HWWARN('HWISP3',151,*999)
            NME(I) = 20000+NBMODE
            IDBPRT(NBMODE) = I
            IBMODE(NBMODE) = 198
            IBDRTP(NBMODE) = 6
            IF(IL.LE.6) THEN
              ABMODE(1,NBMODE) = -G*ORT*QMIXSS(IL,1,IM)*QMIXSS(IQ,1,IH)
            ELSE
              ABMODE(1,NBMODE) = -G*ORT*LMIXSS(IL-6,1,IM)*
     &                                  LMIXSS(IQ-6,1,IH)
            ENDIF
            ABMODE(2,NBMODE) = ZERO
            DO 39 K=1,6
            PBMODE(K,NBMODE) = 1.0D0
            IF(K.LE.3) PBMODE(K,NBMODE) = 3.0D0
            BBMODE(1,K,NBMODE) = ZERO
 39         BBMODE(2,K,NBMODE) = -G*ORT
          ELSEIF(IDKPRD(1,I).EQ.199) THEN
            NBMODE = NBMODE+1
            IF(NBMODE.GT.NMODEB) CALL HWWARN('HWISP3',152,*999)
            NME(I) = 20000+NBMODE
            IDBPRT(NBMODE) = I
            IBMODE(NBMODE) = 199
            IBDRTP(NBMODE) = 6
            IF(IL.LE.6) THEN
              ABMODE(1,NBMODE) = -G*ORT*QMIXSS(IL,1,IM)*QMIXSS(IQ,1,IH)
            ELSE
              ABMODE(1,NBMODE) = -G*ORT*LMIXSS(IL-6,1,IM)*
     &                                  LMIXSS(IQ-6,1,IH)
            ENDIF
            ABMODE(2,NBMODE) = ZERO
            DO 40 K=1,6
            PBMODE(K,NBMODE) = 1.0D0
            IF(K.LE.3) PBMODE(K,NBMODE) = 3.0D0
            BBMODE(1,K,NBMODE) = ZERO
 40         BBMODE(2,K,NBMODE) = -G*ORT
          ENDIF
        ENDIF
 2000 CONTINUE
C--now compute the maximum weights for the three body decays found
 2999 CONTINUE
      DO 3000 I=1,N3MODE
      IF(RSPIN(IDK(ID3PRT(I))).EQ.ZERO) THEN
        RHOIN(1,1) = ONE
        RHOIN(1,2) = ZERO
        RHOIN(2,1) = ZERO
        RHOIN(2,2) = ZERO
      ELSE
        RHOIN(1,1) = HALF
        RHOIN(1,2) = ZERO
        RHOIN(2,1) = ZERO
        RHOIN(2,2) = HALF
      ENDIF
      PHEP(5,1) = RMASS(IDK(ID3PRT(I)))
      PHEP(4,1) = SQRT(100.0D0**2+PHEP(5,1)**2)
      PHEP(1,1) = 100.0D0
      PHEP(2,1) = 0.0D0
      PHEP(3,1) = 0.0D0
      IF(IPRINT.EQ.2) WRITE(6,5000) RNAME(IDK(ID3PRT(I))),
     &   RNAME(IDKPRD(1,ID3PRT(I))),RNAME(IDKPRD(2,ID3PRT(I))),
     &   RNAME(IDKPRD(3,ID3PRT(I)))
 3000 CALL HWD3ME(1,0,I,RHOIN,1)
      IF(.NOT.SUSYIN) RETURN
C--and for the two body gauge boson modes
      DO 4000 I=1,NBMODE
      IF(RSPIN(IDK(IDBPRT(I))).EQ.ZERO) THEN
        RHOIN(1,1) = ONE
        RHOIN(1,2) = ZERO
        RHOIN(2,1) = ZERO
        RHOIN(2,2) = ZERO
      ELSE
        RHOIN(1,1) = HALF
        RHOIN(1,2) = ZERO
        RHOIN(2,1) = ZERO
        RHOIN(2,2) = HALF
      ENDIF
      PHEP(5,1) = RMASS(IDK(IDBPRT(I)))
      PHEP(4,1) = SQRT(100.0D0**2+PHEP(5,1)**2)
      PHEP(1,1) = 100.0D0
      PHEP(2,1) = 0.0D0
      PHEP(3,1) = 0.0D0
      IF(IPRINT.EQ.2) WRITE(6,5010) RNAME(IDK(IDBPRT(I))),
     & RNAME(IDKPRD(1,IDBPRT(I))),RNAME(IDKPRD(2,IDBPRT(I)))
      IL = 12
      IF(IBMODE(I).NE.200) IL = 6
      DO 4000 J=1,IL
 4000 CALL HWD3ME(1,J,I,RHOIN,1)
      RETURN
 5000 FORMAT(/'CALCULATING THREE BODY DECAY ',
     &     A8,' --> ',A8,' ',A8,' ',A8/)
 5010 FORMAT(/'CALCULATING TWO BODY DECAY ',
     &     A8,' --> ',A8,' ',A8/)
 999  END
CDECK  ID>, HWISP4.
*CMZ :-        -12/10/01  12.04.54  by  Peter Richardson
*-- Author :    Peter Richardson
C-----------------------------------------------------------------------
      SUBROUTINE HWISP4
C-----------------------------------------------------------------------
C     Initialise the Higgs four body modes
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      INTEGER I,J,K,IL,IH,II,JJ
      DOUBLE PRECISION COL(2),SW,CW,TW,E,G,RT,ORT,MW,MZ,AFN(2,12,2,4),
     &     AFG(2,6,2),AFC(2,12,2,2),OIJ(2,4,2),OIJP(2,2,2),OIJPP(2,4,4),
     &     HNN(2,3,4,4),HCC(2,3,2,2),HNC(2,4,2),HFF(2,4,12),HWW(2),
     &     HZZ(2),ZAB(12,2,2),HHB(2,3),GS
      COMMON /HWSPNC/ SW,CW,TW,E,G,RT,ORT,MW,MZ,GS,AFN,AFG,AFC,OIJ,OIJP,
     &               OIJPP,HNN,HCC,HNC,HFF,HWW,HZZ,ZAB,HHB
      IF(IERROR.NE.0.OR..NOT.SUSYIN) RETURN
C--four body Higgs modes via virtual WW and ZZ
      DO 1000 JJ=1,NRES
      DO 1000 II=1,NMODES(JJ)
        IF(II.EQ.1) THEN
          I = LSTRT(JJ)
        ELSE
          I = LNEXT(I)
        ENDIF
        IH=IDK(I)-202
        IF((IH.EQ.1.OR.IH.EQ.2).AND.IDKPRD(3,I).EQ.0.AND.
     &       IDKPRD(1,I).GE.198.AND.IDKPRD(1,I).LE.200.AND.
     &       IDKPRD(2,I).GE.198.AND.IDKPRD(2,I).LE.200) THEN
C--first the WW modes
          IF(IDKPRD(1,I).NE.200) THEN
            N4MODE = N4MODE+1
            IF(N4MODE.GT.NMODE4) CALL HWWARN('HWISP4',100,*999)
            NME(I) = 40000+N4MODE
            ID4PRT(N4MODE) = I
            I4MODE(1,N4MODE) = 198
            I4MODE(2,N4MODE) = 199
            DO 1 K=1,6
            A4MODE(1,K,N4MODE) = ZERO
            A4MODE(2,K,N4MODE) =-G*ORT
            B4MODE(1,K,N4MODE) = ZERO
 1          B4MODE(2,K,N4MODE) =-G*ORT
C--now the prefactors
            DO 2 J=1,6
            COL(1) = HWW(IH)**2
            IF(J.LE.3) COL(1) = THREE*COL(1)
            DO 2 K=1,6
            COL(2) = ONE
            IF(K.LE.3) COL(2) = THREE*COL(2)
 2          P4MODE(J,K,N4MODE) = COL(1)*COL(2)
C--then the ZZ modes
          ELSE
            N4MODE = N4MODE+1
            IF(N4MODE.GT.NMODE4) CALL HWWARN('HWISP4',101,*999)
            NME(I) = 40000+N4MODE
            ID4PRT(N4MODE) = I
            I4MODE(1,N4MODE) = 200
            I4MODE(2,N4MODE) = 200
            DO 3 K=1,12
            IL = K
            IF(K.GT.6) IL=K+4
            A4MODE(1,K,N4MODE) =-E*RFCH(IL)
            A4MODE(2,K,N4MODE) =-E*LFCH(IL)
            B4MODE(1,K,N4MODE) =-E*RFCH(IL)
 3          B4MODE(2,K,N4MODE) =-E*LFCH(IL)
            DO 4 J=1,12
            COL(1) = HALF*HZZ(IH)**2
            IF(J.LE.6) COL(1)=THREE*COL(1)
            DO 4 K=1,12
            COL(2) = ONE
            IF(K.LE.6) COL(2) = THREE
 4          P4MODE(J,K,N4MODE) = COL(1)*COL(2)
          ENDIF
        ENDIF
 1000 CONTINUE
C--compute the maximum weights
      IF(N4MODE.EQ.0) RETURN
      DO 2000 I=1,N4MODE
      PHEP(5,1) = RMASS(IDK(ID4PRT(I)))
      PHEP(4,1) = SQRT(100.0D0**2+PHEP(5,1)**2)
      PHEP(1,1) = 100.0D0
      PHEP(2,1) = 0.0D0
      PHEP(3,1) = 0.0D0
      IF(IPRINT.EQ.2) WRITE(6,5010) RNAME(IDK(ID4PRT(I))),
     &            RNAME(IDKPRD(1,ID4PRT(I))),RNAME(IDKPRD(2,ID4PRT(I)))
      IL = 12
      IF(I4MODE(1,I).NE.200) IL = 6
      DO 2000 J=1,IL
      DO 2000 K=1,IL
 2000 CALL HWD4ME(1,J,K,I)
      RETURN
 5010 FORMAT(/'CALCULATING TWO BODY DECAY ',
     &     A8,' --> ',A8,' ',A8/)
 999  END
CDECK  ID>, HWISSP.
*CMZ :-        -12/10/01  09:41:43  by  Peter Richardson
*-- Author :    Bryan Webber, modified by Kosuke Odagiri
C-----------------------------------------------------------------------
      SUBROUTINE HWISSP
C-----------------------------------------------------------------------
C  Reads in SUSY particle properties and decays,
C  in format generated by ISAWIG
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      INTEGER I,J,K,IH,IHW,NSSP,NDEC,MDKYS
      DOUBLE PRECISION BETAH, WEINCOS,WEINSIN, MW,MZ, RMMAX
      DOUBLE PRECISION FTM,FTMUU(4),FTMDD(4),FTMTT(4),FTMBB(4),FTMU,FTMD
      DOUBLE PRECISION YTM,YTM1,DTERM(4), SQHF,SNBCSB,MZSW2
      LOGICAL FIRST
      EQUIVALENCE (MW,RMASS(198)), (MZ,RMASS(200))
      DATA FIRST/.TRUE./
      SAVE MDKYS
      IF (FIRST) THEN
        MDKYS=NDKYS
        FIRST=.FALSE.
      ELSE
        NDKYS=MDKYS
      ENDIF
C--reset susy input flag
      IF (LRSUSY.LT.0) CALL HWWARN('HWISSP',500,*999)
      SUSYIN = .TRUE.
C
C  Input SUSY particle + top quark table
C
      WRITE (6,9)       '                           '
  9   FORMAT(//10X,A28//,
     &         10X,'Since SUSY processes are called,'
     & ,/,     10X,'please also reference: S.Moretti, K.Odagiri,'
     & ,/,     10X,'P.Richardson, M.H.Seymour & B.R.Webber,'
     & ,/,     10X,'JHEP 0204 (2002) 028')
      WRITE (6,10) LRSUSY
 10   FORMAT (/10X,'Reading in SUSY data from unit',I3)
      READ (LRSUSY,'(I4)') NSSP
      IF (NSSP.LE.0) RETURN
      RMMAX=SQRT(HALF*(EBEAM1*EBEAM2+PBEAM1*PBEAM2))
      RMMNSS=RMMAX
      DO I=1,NSSP
        READ (LRSUSY,1) IHW,RMASS(IHW),RLTIM(IHW)
C  Negative gaugino mass means physical field is gamma_5*psi
C  Store the signs
        IF ((IHW.GE.450).AND.(IHW.LE.457)) THEN
          IF (IHW.LE.453) THEN
            J=IHW-449
            ZSGNSS(J)=RMASS(IHW)/ABS(RMASS(IHW))
          ELSEIF (IHW.LE.455) THEN
            J=IHW-453
            WSGNSS(J)=RMASS(IHW)/ABS(RMASS(IHW))
          ENDIF
          RMASS(IHW)=ABS(RMASS(IHW))
        ENDIF
        IF (ABS(IDPDG(IHW)).GT.1000000.AND.(RMASS(IHW).NE.ZERO))
     &    RMMNSS=MIN(RMMNSS,RMASS(IHW))
        IF (IHW.GT.NRES) THEN
          IF (IHW.GT.NMXRES) CALL HWWARN('HWISSP',501,*999)
          NRES=IHW
        ENDIF
      ENDDO
      XLMNSS=TWO*LOG(RMMNSS/RMMAX)
    1 FORMAT(I5,F12.4,E15.5)
C
C  Input decay modes
C
      NDECSY = NDKYS+1
      DO I=1,NSSP
        READ (LRSUSY,'(I4)') NDEC
        IF (NDEC.GT.0) THEN
          DO J=1,NDEC
            NDKYS=NDKYS+1
            IF (NDKYS.GT.NMXDKS) CALL HWWARN('HWISSP',100,*999)
            READ (LRSUSY,11) IDK(NDKYS),BRFRAC(NDKYS),NME(NDKYS),
     &      (IDKPRD(K,NDKYS),K=1,5)
   11       FORMAT(I6,F16.8,6I6)
          ENDDO
        ENDIF
      ENDDO
C
C  Mixings and other SUSY parameters
C
      READ (LRSUSY,'(2F16.8)') TANB,ALPHAH
      DO I=1,4
        READ (LRSUSY,13) ZMXNSS(I,1),ZMXNSS(I,2),ZMXNSS(I,3),ZMXNSS(I,4)
      END DO
      WEINSIN = SQRT(SWEIN)
      WEINCOS = SQRT(1.-SWEIN)
      DO I=1,4
        ZMIXSS(I,1) =  WEINCOS*ZMXNSS(I,1)+WEINSIN*ZMXNSS(I,2)
        ZMIXSS(I,2) = -WEINSIN*ZMXNSS(I,1)+WEINCOS*ZMXNSS(I,2)
        ZMIXSS(I,3) =  ZMXNSS(I,3)
        ZMIXSS(I,4) =  ZMXNSS(I,4)
      END DO
      DO J=1,16
        IF ((J.LE.6).OR.(J.GE.11)) THEN
C--left and right couplings now computed in HWIGIN
          DO I=1,4
            SLFCH(J,I)= ZMIXSS(I,1)*QFCH(J)+ZMIXSS(I,2)*LFCH(J)
            SRFCH(J,I)=-ZMIXSS(I,1)*QFCH(J)-ZMIXSS(I,2)*RFCH(J)
          END DO
        ENDIF
      END DO
      READ (LRSUSY,13) WMXVSS(1,1),WMXVSS(1,2), WMXVSS(2,1),WMXVSS(2,2)
      READ (LRSUSY,13) WMXUSS(1,1),WMXUSS(1,2), WMXUSS(2,1),WMXUSS(2,2)
      READ (LRSUSY,'(3F16.8)') THETAT,THETAB,THETAL
      READ (LRSUSY,'(3F16.8)') ATSS,ABSS,ALSS
      READ (LRSUSY,'( F16.8)') MUSS
      DO I=1,6
        QMIXSS(I,1,1)=1.
        QMIXSS(I,1,2)=0.
        QMIXSS(I,2,1)=0.
        QMIXSS(I,2,2)=1.
        LMIXSS(I,1,1)=1.
        LMIXSS(I,1,2)=0.
        LMIXSS(I,2,1)=0.
        LMIXSS(I,2,2)=1.
      END DO
      QMIXSS(6,1,1)= COS(THETAT)
      QMIXSS(6,1,2)= SIN(THETAT)
      QMIXSS(6,2,1)=-QMIXSS(6,1,2)
      QMIXSS(6,2,2)= QMIXSS(6,1,1)
      QMIXSS(5,1,1)= COS(THETAB)
      QMIXSS(5,1,2)= SIN(THETAB)
      QMIXSS(5,2,1)=-QMIXSS(5,1,2)
      QMIXSS(5,2,2)= QMIXSS(5,1,1)
      LMIXSS(5,1,1)= COS(THETAL)
      LMIXSS(5,1,2)= SIN(THETAL)
      LMIXSS(5,2,1)=-LMIXSS(5,1,2)
      LMIXSS(5,2,2)= LMIXSS(5,1,1)
C--Evaluating Higgs parameters and couplings
      BETAH=ATAN(TANB)
      COTB=ONE/TANB
      COSBPA=COS(BETAH+ALPHAH)
      SINBPA=SIN(BETAH+ALPHAH)
      COSBMA=COS(BETAH-ALPHAH)
      SINBMA=SIN(BETAH-ALPHAH)
      COSA=COS(ALPHAH)
      SINA=SIN(ALPHAH)
      COSB=COS(BETAH)
      SINB=SIN(BETAH)
      GHWWSS(1)=SINBMA
      GHWWSS(2)=COSBMA
      GHWWSS(3)=ZERO
      DO 30 I=1,3
        GHZZSS(I)=GHWWSS(I)
 30   CONTINUE
      GHDDSS(1)=-SINA/COSB
      GHDDSS(2)= COSA/COSB
      GHDDSS(3)= TANB
      GHUUSS(1)= COSA/SINB
      GHUUSS(2)= SINA/SINB
      GHUUSS(3)= COTB
      GHWHSS(1)= COSBMA
      GHWHSS(2)= SINBMA
      GHWHSS(3)= ONE
      MZSW2    = MZ**2 * SQRT(SWEIN*(ONE-SWEIN))
      DTERM(1) =-SINBPA*MZSW2
      DTERM(2) = COSBPA*MZSW2
      DTERM(3) = ZERO
      FTMUU(1) = MUSS*SINA/SINB
      FTMUU(2) =-MUSS*COSA/SINB
      FTMUU(3) =-MUSS
      FTMUU(4) =-MUSS
      FTMTT(1) = ATSS*COSA/SINB
      FTMTT(2) = ATSS*SINA/SINB
      FTMTT(3) =-ATSS*COTB
      FTMTT(4) =-ATSS*COTB
      FTMDD(1) =-MUSS*COSA/COSB
      FTMDD(2) =-MUSS*SINA/COSB
      FTMDD(3) =-MUSS
      FTMDD(4) =-MUSS
      FTMBB(1) =-ABSS*SINA/COSB
      FTMBB(2) = ABSS*COSA/COSB
      FTMBB(3) =-ABSS*TANB
      FTMBB(4) =-ABSS*TANB
      DO 40 IH=1,4
        FTMU=FTMUU(IH)
        FTMD=FTMDD(IH)
        DO 50 I=1,6
          IF (I.EQ.5) FTMU=FTMU+FTMTT(IH)
          IF (I.EQ.5) FTMD=FTMD+FTMBB(IH)
          IF (MOD(I,2).EQ.0) THEN
           YTM = GHUUSS(IH)
           FTM = FTMU
          ELSE
           YTM = GHDDSS(IH)
           FTM = FTMD
          END IF
          IF (IH.EQ.3) THEN
           GHSQSS(IH,I,1,1) = ZERO
           GHSQSS(IH,I,2,2) = ZERO
           GHSQSS(IH,I,1,2) = FTM*HALF*RMASS(I)/MW
           GHSQSS(IH,I,2,1) = - GHSQSS(IH,I,1,2)
           GOTO 50
          ELSEIF (IH.EQ.4) THEN
           SQHF=SQRT(HALF)
           SNBCSB=SINB*COSB
           DO 60 J=1,2
            DO 70 K=1,2
             IF (MOD(I,2).EQ.1) THEN
              GHSQSS(IH,I,J,K)=SQHF*(
     &          RMASS(I  )*FTMD*QMIXSS(I,2,J)*QMIXSS(I+1,1,K)
     &         +RMASS(I+1)*FTMU*QMIXSS(I,1,J)*QMIXSS(I+1,2,K)
     &         +( MW**2*TWO*SNBCSB-RMASS(I+1)**2*COTB
     &           -RMASS(I  )**2*TANB )*QMIXSS(I,1,J)*QMIXSS(I+1,1,K)
     &         -RMASS(I)*RMASS(I+1)/SNBCSB
     &          *QMIXSS(I,2,J)*QMIXSS(I+1,2,K) ) / MW
             ELSE
              GHSQSS(IH,I,J,K)=GHSQSS(IH,I-1,K,J)
             END IF
 70         END DO
 60        END DO
          ELSE
           DO 80 J=1,2
            DO 90 K=1,2
             YTM1=ZERO
             IF (J.EQ.K) YTM1=YTM*RMASS(I)**2
             GHSQSS(IH,I,J,K)=( YTM1
     &        +( LFCH(I)*QMIXSS(I,1,J)*QMIXSS(I,1,K)
     &          -RFCH(I)*QMIXSS(I,2,J)*QMIXSS(I,2,K) )*DTERM(IH)
     &        +FTM*HALF*RMASS(I)*(QMIXSS(I,1,J)*QMIXSS(I,2,K)
     &                           +QMIXSS(I,2,J)*QMIXSS(I,1,K)) ) / MW
 90         CONTINUE
 80        CONTINUE
          END IF
 50     CONTINUE
 40   CONTINUE
C--Rparity violation
      READ (LRSUSY,'(L5)') RPARTY
      IF(.NOT.RPARTY) THEN
        READ(LRSUSY,20) (((LAMDA1(I,J,K),K=1,3),J=1,3),I=1,3)
        READ(LRSUSY,20) (((LAMDA2(I,J,K),K=1,3),J=1,3),I=1,3)
        READ(LRSUSY,20) (((LAMDA3(I,J,K),K=1,3),J=1,3),I=1,3)
      ENDIF
 13   FORMAT(4F16.8)
 20   FORMAT(27E16.8)
      CLOSE(LRSUSY)
      IF(FOURB) CALL HWIMDE
  999 END
CDECK  ID>, HWMEVT.
*CMZ :-        -04/05/99  14.28.59  by  Bryan Webber
*-- Author :    Bryan Webber
C-----------------------------------------------------------------------
      SUBROUTINE HWMEVT
C-----------------------------------------------------------------------
C     IPROC = 1000,... ADDS SOFT UNDERLYING EVENT
C           = 8000:  CREATES MINIMUM-BIAS EVENT
C     SUPPRESSED BY ADDING 10000 TO IPROC
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      DOUBLE PRECISION HWREXP,ENFAC,TECM,SECM,SUMM,EMCL,BMP(5),BMR(3,3)
      INTEGER HWRINT,NETC,IBT,IDBT,ID1,ID2,ID3,KHEP,LHEP,NTRY,ICMS,
     & NPPBAR,MCHT,JCL,JD1,JD2,JD3,ICH,MODC,NCHT,INHEP(2),
     & INID(2,2),JBT
      EXTERNAL HWREXP,HWRINT
      IF (IERROR.NE.0) RETURN
      IF (.NOT.GENSOF) GOTO 990
      IF (IPROC.EQ.8000) THEN
C---SET UP BEAM AND TARGET CLUSTERS
    5   NETC=0
        DO 10 IBT=1,2
        JBT=IBT
        IF (JDAHEP(1,IBT).NE.0) JBT=JDAHEP(1,IBT)
        IDBT=IDHW(JBT)
        IF (IDBT.EQ.73.OR.IDBT.EQ.75) THEN
          INID(1,IBT)=HWRINT(1,2)
          INID(2,IBT)=110
        ELSEIF (IDBT.EQ.91.OR.IDBT.EQ.93) THEN
          INID(1,IBT)=116
          INID(2,IBT)=HWRINT(7,8)
        ELSEIF (IDBT.EQ.30) THEN
          INID(1,IBT)=HWRINT(1,2)
          INID(2,IBT)=8
        ELSEIF (IDBT.EQ.38) THEN
          INID(1,IBT)=2
          INID(2,IBT)=HWRINT(7,8)
        ELSEIF (IDBT.EQ.34) THEN
          INID(1,IBT)=3
          INID(2,IBT)=HWRINT(7,8)
        ELSEIF (IDBT.EQ.46) THEN
          INID(1,IBT)=HWRINT(1,2)
          INID(2,IBT)=9
        ELSEIF (IDBT.EQ.59) THEN
          INID(1,IBT)=HWRINT(1,2)
          INID(2,IBT)=HWRINT(7,8)
        ELSE
          CALL HWWARN('HWMEVT',100,*999)
        ENDIF
        NETC=NETC+ICHRG(IDBT)
     &    -(ICHRG(INID(1,IBT))+ICHRG(INID(2,IBT)))/3
        ENFAC=1.
        IDHW(NHEP+IBT)=19
        IDHEP(NHEP+IBT)=91
        ISTHEP(NHEP+IBT)=163+IBT
        JMOHEP(1,NHEP+IBT)=JBT
   10   CONTINUE
        IF (NETC.EQ.0) THEN
          ID3=HWRINT(1,2)
        ELSEIF (NETC.EQ.-1) THEN
          ID3=1
        ELSEIF (NETC.EQ.1) THEN
          ID3=2
        ELSE
          GOTO 5
        ENDIF
        DO 12 IBT=1,2
        NHEP=NHEP+1
        JBT=IBT
        IF (JDAHEP(1,IBT).NE.0) JBT=JDAHEP(1,IBT)
        CALL HWVEQU(5,PHEP(1,JBT),PHEP(1,NHEP))
   12   INHEP(IBT)=NHEP
      ELSE
C---FIND BEAM AND TARGET CLUSTERS
        DO 20 IBT=1,2
        DO 15 KHEP=1,NHEP
        IF (ISTHEP(KHEP).EQ.163+IBT) THEN
          INHEP(IBT)=KHEP
          INID(1,IBT)=IDHW(JMOHEP(1,KHEP))
          INID(2,IBT)=IDHW(JMOHEP(2,KHEP))
          GOTO 20
        ENDIF
   15   CONTINUE
C---COULDN'T FIND ONE
        INHEP(IBT)=0
   20   CONTINUE
        JCL=-1
C---TEST FOR BOTH FOUND
        IF (INHEP(1).EQ.0) JCL=INHEP(2)
        IF (INHEP(2).EQ.0) JCL=INHEP(1)
        IF (JCL.EQ.0) CALL HWWARN('HWMEVT',101,*999)
        IF (JCL.GT.0) THEN
          ISTHEP(JCL)=163
          CALL HWCFOR
          CALL HWCDEC
          CALL HWDHAD
          CALL HWDHVY
          GOTO 90
        ENDIF
        ID3=HWRINT(1,2)
        ENFAC=ENSOF
        NETC=0
      ENDIF
C---FIND SOFT CM MOMENTUM AND MULTIPLICITY
      NTRY=0
      NHEP=NHEP+1
      IF (NHEP.GT.NMXHEP) CALL HWWARN('HWMEVT',102,*999)
      ICMS=NHEP
      IDHW(NHEP)=16
      IDHEP(NHEP)=0
C--Bug Fix 31/03/00 PR
      JMOHEP(1,ICMS)=INHEP(1)
      JMOHEP(2,ICMS)=INHEP(2)
C--End of Fix
      ISTHEP(NHEP)=170
      CALL HWVSUM(4,PHEP(1,INHEP(1)),PHEP(1,INHEP(2)),PHEP(1,NHEP))
      CALL HWUMAS(PHEP(1,NHEP))
      TECM=PHEP(5,NHEP)
      IF (IPRO/10.EQ.9.OR.IPRO/10.EQ.5) THEN
        SECM=TECM*ENFAC
      ELSE
        SECM=PHEP(5,3)*ENFAC
      ENDIF
C---CHOOSE MULTIPLICITY
   25 CALL HWMULT(SECM,NPPBAR)
   30 NCL=0
      MCHT=0
      IERROR=0
      NHEP =ICMS
      SUMM=0.
      NTRY=NTRY+1
C---CREATE CLUSTERS
   35 NCL=NCL+1
      NHEP=NHEP+1
      IF (NHEP.GT.NMXHEP) CALL HWWARN('HWMEVT',103,*999)
      JCL=NHEP
      IDHW(JCL)=19
      IDHEP(JCL)=91
      IF (NCL.LT.3) THEN
        ISTHEP(JCL)=170+NCL
        ID1=INID(1,NCL)
        ID2=INID(2,NCL)
      ELSE
        ID1=ID2-6
        IF (NCL.EQ.3) ID1=ID3
        ID2=HWRINT(7,8)
        ISTHEP(JCL)=173
      ENDIF
      JMOHEP(1,JCL)=ICMS
      JMOHEP(2,JCL)=0
      CALL HWVZRO(3,PHEP(1,JCL))
      PHEP(4,JCL)=RMASS(ID1)+RMASS(ID2)+PMBM1+HWREXP(TWO/PMBM2)
      PHEP(5,JCL)=PHEP(4,JCL)
C---HADRONIZE AND DECAY CLUSTERS
      CALL HWCFLA(ID1,ID2,JD1,JD2)
      CALL HWCHAD(JCL,JD1,JD2,JD3)
      IF (IERROR.NE.0) RETURN
      IF (JD3.EQ.0) THEN
        EMCL=RMASS(IDHW(NHEP))
        IF (PHEP(4,JCL).NE.EMCL) THEN
          PHEP(4,JCL)=EMCL
          PHEP(5,JCL)=EMCL
          PHEP(4,NHEP)=EMCL
          PHEP(5,NHEP)=EMCL
        ENDIF
      ELSE
        EMCL=PHEP(5,JCL)
      ENDIF
      IDCL(NCL)=JD3
      PPCL(5,NCL)=EMCL
      SUMM=SUMM +EMCL
      CALL HWDHAD
      CALL HWDHVY
      IF (IERROR.NE.0) RETURN
C---CHECK CHARGED MULTIPLICITY
      MODC=0
      DO 50 KHEP=JCL,NHEP
      IF (ISTHEP(KHEP).EQ.1) THEN
         ICH=ICHRG(IDHW(KHEP))
         IF (ICH.NE.0) THEN
            MCHT=MCHT+ABS(ICH)
            MODC=MODC+ICH
         ENDIF
      ENDIF
   50 CONTINUE
      IF (NCL.EQ.1) THEN
         NCHT=NPPBAR+NETC+ABS(MODC)
         GOTO 35
      ELSEIF (NCL.EQ.2) THEN
         NCHT=NCHT+ABS(MODC)
         IF (NCHT.LT.0) NCHT=NCHT+2
      ENDIF
      IF (MCHT.LT.NCHT) THEN
        GOTO 35
      ELSEIF (MCHT.GT.NCHT) THEN
        IF (MOD(NTRY,50).EQ.0) GOTO 25
        IF (NTRY.LT.NSTRY) GOTO 30
C---NO PHASE SPACE FOR SOFT EVENT
        NHEP=ICMS-1
        IF (IPROC.EQ.8000) THEN
C---MINIMUM BIAS: RELABEL BEAM AND TARGET CLUSTERS
          DO 60 IBT=1,2
            KHEP=INHEP(IBT)
            LHEP=JMOHEP(1,KHEP)
            ISTHEP(KHEP)=1
            IDHEP(KHEP)=IDHEP(LHEP)
            IDHW(KHEP)=IDHW(LHEP)
   60     CONTINUE
        ELSE
C---UNDERLYING EVENT: DECAY THEM
          ISTHEP(INHEP(1))=163
          ISTHEP(INHEP(2))=163
          CALL HWCFOR
          CALL HWCDEC
          CALL HWDHAD
          CALL HWDHVY
        ENDIF
        GOTO 90
      ENDIF
C---GENERATE CLUSTER MOMENTA IN CLUSTER CM
C   FRAME.   N.B. SECOND CLUSTER IS TARGET
      IF (SUMM.GT.TECM) GOTO 25
      CALL HWMLPS(TECM)
      IF (NCL.EQ.0) GOTO 25
      JCL=0
C---ROTATE & BOOST CLUSTERS & DECAY PRODUCTS
      CALL HWULOF(PHEP(1,ICMS),PHEP(1,INHEP(1)),BMP)
      CALL HWUROT(BMP, ONE,ZERO,BMR)
C---BMR PUTS BEAM ALONG Z AXIS (WE WANT INVERSE)
      DO 70 KHEP=ICMS+1,NHEP
      IF (ISTHEP(KHEP).GT.180.AND.ISTHEP(KHEP).LT.190
     $       .AND.JMOHEP(1,KHEP).EQ.ICMS) THEN
          ISTHEP(KHEP)=ISTHEP(KHEP)+3
          LHEP=KHEP
          JCL=JCL+1
          CALL HWUROB(BMR,PPCL(1,JCL),PPCL(1,JCL))
          CALL HWULOB(PHEP(1,ICMS),PPCL(1,JCL),PPCL(1,JCL))
C---NOW PPCL(*,JCL) IS LAB MOMENTUM OF JTH CLUSTER
      ENDIF
      CALL HWULOB(PPCL(1,JCL),PHEP(1,KHEP),PHEP(1,KHEP))
   70 CONTINUE
      ISTHEP(INHEP(1))=167
      ISTHEP(INHEP(2))=168
      JDAHEP(1,INHEP(1))=ICMS
      JDAHEP(2,INHEP(1))=0
      JDAHEP(1,INHEP(2))=ICMS
      JDAHEP(2,INHEP(2))=0
      JDAHEP(1,ICMS)=ICMS+1
      JDAHEP(2,ICMS)=LHEP
   90 CONTINUE
  990 ISTAT=100
  999 END
CDECK  ID>, HWMLPS.
*CMZ :-        -04/05/99  14.17.04  by  Bryan Webber
*-- Author :    David Ward, modified by Bryan Webber
C-----------------------------------------------------------------------
      SUBROUTINE HWMLPS(TECM)
C-----------------------------------------------------------------------
C     GENERATES CYLINDRICAL PHASE SPACE USING THE METHOD OF JADACH
C     RETURNS WITH NCL=0 IF UNSUCCESSFUL
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      DOUBLE PRECISION HWREXT,HWRUNG,HWUSQR,TECM,ESS,ALOGS,EPS,SUMX,
     & SUMY,PT,PX,PY,PT2,SUMPT2,SUMTM,XIMIN,XIMAX,YY,SUM1,SUM2,SUM3,
     & SUM4,EX,FY,DD,DYY,ZZ,E1,TM,SLOP,XI(NMXCL)
      INTEGER NTRY,I,NIT,IY(NMXCL),IDP
      EXTERNAL HWREXT,HWRUNG,HWUSQR
      IF (NCL.GT.NMXCL) THEN
        CALL HWWARN('HWMLPS',1,*999)
        NCL=NMXCL
      ENDIF
      ESS=TECM**2
      ALOGS=LOG(ESS)
      EPS=1D-10/NCL
      NTRY=0
  11  NTRY=NTRY+1
      IF (NTRY.GT.NSTRY) THEN
        NCL=0
        RETURN
      ENDIF
      SUMX=0.
      SUMY=0.
      DO 12 I=1,NCL
C---Pt distribution of form exp(-b*Mt)
C---Factors for pt slopes to fit data.  IDCL contains the type of
C   q-qbar pair produced in this cluster (0 if 1-particle cluster).
      IDP=IDCL(I)
      IF (IDP.LE.2) THEN
        SLOP=PMBP1
      ELSEIF(IDP.EQ.3.OR.IDP.EQ.10) THEN
        SLOP=PMBP2
      ELSEIF(IDP.GT.3.AND.IDP.LE.9) THEN
        SLOP=PMBP3
      ELSE
        CALL HWWARN('HWMLPS',IDP,*999)
        SLOP=PMBP2
      ENDIF
      PT=HWREXT(PPCL(5,I),SLOP)
      PT=HWUSQR(PT**2-PPCL(5,I)**2)
      CALL HWRAZM(PT,PX,PY)
      PPCL(1,I)=PX
      PPCL(2,I)=PY
      SUMX=SUMX+PPCL(1,I)
  12  SUMY=SUMY+PPCL(2,I)
      SUMX=SUMX/NCL
      SUMY=SUMY/NCL
      SUMPT2=0.
      SUMTM=0.
      DO 13 I=1,NCL
      PPCL(1,I)=PPCL(1,I)-SUMX
      PPCL(2,I)=PPCL(2,I)-SUMY
      PT2=PPCL(1,I)**2+PPCL(2,I)**2
      SUMPT2=SUMPT2+PT2
C---STORE TRANSVERSE MASS IN PPCL(3,I) TEMPORARILY
      PPCL(3,I)=SQRT(PT2+PPCL(5,I)**2)
  13  SUMTM=SUMTM+PPCL(3,I)
      IF (SUMTM.GT.TECM) GOTO 11
      DO 14 I=1,NCL
C---Form of "reduced rapidity" distribution
      XI(I)=HWRUNG(0.6*ONE,ONE)
  14  CONTINUE
      CALL HWUSOR(XI,NCL,IY,1)
      XIMIN=XI(1)
      XIMAX=XI(NCL)-XI(1)
C---N.B. TARGET CLUSTER IS SECOND
      XI(1)=0.
      DO 16 I=NCL-1,2,-1
      XI(I+1)=(XI(I)-XIMIN)/XIMAX
  16  CONTINUE
      XI(2)=1.
      YY=LOG(ESS/(PPCL(3,1)*PPCL(3,2)))
      DO 18 NIT=1,10
      SUM1=0.
      SUM2=0.
      SUM3=0.
      SUM4=0.
      DO 19 I=1,NCL
      TM=PPCL(3,I)
      EX=EXP(YY*XI(I))
      SUM1=SUM1+(TM*EX)
      SUM2=SUM2+(TM/EX)
      SUM3=SUM3+(TM*EX)*XI(I)
  19  SUM4=SUM4+(TM/EX)*XI(I)
      FY=ALOGS-LOG(SUM1*SUM2)
      DD=(SUM3*SUM2-SUM1*SUM4)/(SUM1*SUM2)
      DYY=FY/DD
      IF(ABS(DYY/YY).LT.EPS) GOTO 20
  18  YY=YY+DYY
C---Y ITERATIONS EXCEEDED - TRY AGAIN
      IF (NTRY.LT.100) GOTO 11
      EPS=10.*EPS
      IF (EPS.GT.ONE) CALL HWWARN('HWMLPS',100,*999)
      CALL HWWARN('HWMLPS',50,*11)
   20 YY=YY+DYY
      ZZ=LOG(TECM/SUM1)
      DO 22 I=1,NCL
      TM=PPCL(3,I)
      E1=EXP(ZZ+YY*XI(I))
      PPCL(3,I)=(0.5*TM)*((1./E1)-E1)
      PPCL(4,I)=(0.5*TM)*((1./E1)+E1)
  22  CONTINUE
 999  END
CDECK  ID>, HWMNBI.
*CMZ :-        -26/04/91  11.11.55  by  Bryan Webber
*-- Author :    David Ward, modified by Bryan Webber
C-----------------------------------------------------------------------
      FUNCTION HWMNBI(N,AVNCH,EK)
C-----------------------------------------------------------------------
C---Computes negative binomial probability
C-----------------------------------------------------------------------
      DOUBLE PRECISION HWMNBI,AVNCH,EK,R
      INTEGER N,I
      IF(N.LE.0) THEN
       HWMNBI=0
      ELSE
       R=AVNCH/EK
       HWMNBI=(1.+R)**(-EK)
       R=R/(1.+R)
       DO 1 I=1,N
       HWMNBI=HWMNBI*R*(EK+I-1)/I
    1  CONTINUE
      ENDIF
      END
